from optparse import OptionParser
from math import sqrt
import os
import shutil

def main():
        p = OptionParser()
        p.add_option("--dirname", "-d", dest="dirname", default="/media/DATI/@_Lorenzo/@_Tesi/Results/Cluster_Number_Perf_1_coll_1000_doc_20080727/", help="Basedir of the experiemnt results")
        p.add_option("--prefix", "-p", dest="prefix", default="Seed_", help="Prefix (common to all seeds) of the subfolders related to the seed")
        p.add_option("--fileName", "-f", dest="fn", default="Cluster_CRIT_", help="Name of the file with the results")
        p.add_option("--summOrNot", dest="summOrNot", default="N", help="If 'Y' we're working with the summarization performances")		
        
        option, arguments = p.parse_args()        	
	
	#seeds = [14123451, 38562837, 99283747, 22858999, 50019589, 75638471, 24648787, 45783493, 68787111, 81723679]
	seeds = [14123451, 38562837, 99283747, 22858999, 50019589]

        clu_time_dict = {}
        
        countFiles = 0
        for i in range(0,len(seeds)) : # Used for all files bu the summarization ones
	#for i in range (0,3) : # Used for the summarization files
		sourceFile = os.path.normpath(option.dirname+os.sep+option.prefix+str(seeds[i])+os.sep+option.fn+str(seeds[i])+".txt") # Used for all files bu the summarization ones
		#sourceFile = os.path.normpath(option.dirname+os.sep+option.prefix+str(seeds[i])+os.sep+option.fn) # Used for all files bu the summarization ones
		#sourceFile = os.path.normpath(option.dirname+os.sep+option.prefix+str(i+1)+os.sep+option.fn) # Used for the summarization files
                fileParse(sourceFile,clu_time_dict)
                countFiles+=1 
                
        print countFiles, " Files processed"
        print clu_time_dict
        print "----"

        xaxes = []
        for keyValue in clu_time_dict:
                xaxes.append(keyValue)

        xaxes.sort(myIntCompare)
        
        fw = open (os.path.normpath(option.dirname+os.sep+"Final_statistics.dat"), mode='w')
        
        tstudent0025 = [12.71, 4.30, 3.18, 2.78, 2.57, 2.45, 2.36, 2.31, 2.26, 2.23, 2.20, 2.18, 2.16, 2.14, 2.13, 2.12, 2.11, 2.10, 2.09, 2.09]
        for i in range(0,len(xaxes)):
                valConst = xaxes[i]
                writeStatistics (valConst, clu_time_dict, fw,tstudent0025, "Cluster_Time", option.summOrNot)
        
        return
        fw.close()

def fileParse(source,clu_time_dict):
        
        f = open (source, mode='r')
        
        x = ""
	header = 1 #For cluster that has not the header line
	#header = 0 # For all the other files

        for line in f :
		if header == 0: # skip the header line
			header = 1 
			continue
		else :
		        metrics = line.strip().split()		        
		        if len(metrics) >= 2: # There must be at least two values in the line
        
				x = metrics[0]
				y = float(metrics[1])
				if clu_time_dict.has_key(x) == 0: #No key
					lst_y_values = []
					lst_y_values.append(y)
					clu_time_dict[x] = lst_y_values
		                else :
		                        clu_time_dict[x].append(y)                              

        f.close()
        
        return

def writeStatistics (xval, metricDict, fpointer,tstudent0025, label, summOrNot):
        
        summ = 0.0
        counter = 0
        for valValue in metricDict[xval]:
                summ+=float(valValue)
                counter+=1
        mean = summ/counter
	
	if summOrNot == "Y":
	        fpointer.write(str(xval)+ " " + str(mean)+ "\n") # No confidence
	        print label +": "+str(xval)+ " " + str(mean) # No confidence
		return	
        
        summQuadr = 0.0
        counter = 0
        for valValue in metricDict[xval]:
                summQuadr+=(float(valValue)-mean)**2
                counter+=1
        if (counter >= 2) : 
                var_sqr = summQuadr/(counter-1)
                var = sqrt(var_sqr)
        else :
                var_sqr = 0.0
                var = 0.0
        #print "Avg ", valConst, ": ", str(mean)
        if (counter >= 2) : 
		print counter
                t = tstudent0025[counter-2]
                delta = t*(var/(sqrt(counter)))
                maxVal = mean + delta
                minVal = mean - delta
        else :
                t = 0.0
                delta = 0.0
                maxVal = mean
                minVal = mean
        # Header del file xval mean min max sqr_var var t delta counter
	xval = int(xval)
        fpointer.write(str(xval)+ " " + str(mean)+ " "+ str(minVal)+ " "+ str(maxVal)+ " "+ str(var_sqr)+ " "+ str(var)+ " "+ str(t)+" "+ str(delta)+" "+ str(counter)+"\n")
        print label +": "+str(xval)+ " " + str(mean)+ " "+ str(minVal)+ " "+ str(maxVal)+ " "+ str(var)
        return

def myIntCompare(val1, val2):
	int1 = int(val1)
	int2 = int(val2)
	return cmp (int1,int2)


if __name__ == "__main__":
	# Someone is launching this directly
	main()
