from xml.etree.ElementTree import ElementTree
from optparse import OptionParser
import os
import subprocess

def main():
        p = OptionParser()
        p.add_option("--work", "-w", dest="workDirNameNB", default="F:\\Experimental_Results_BCK\\", help="Absolute path of the directory where pieces of the framework are stored")
	p.add_option("--sourceDirName", dest="srcDirNameNB", default="F:\\Text_Selection_BCK_ABBD\\", help="Absolute path of the directory where the selected texts are stored")
        p.add_option("--intermediate", "-i", dest="intermediateDirNameNB", default="Intermediate", help="Name of the directory where to store the intermediary processing files (Ex. data.dat)")
	p.add_option("--hashfileName", dest="hashFileName", default="Hash_File.hashfile", help="Name of a file in which each line has two entries: the name of the selected file and the name of the weights")	
	p.add_option("--summFileName", "-n", dest="summaryFileNameNB", default="Summary.txt", help="Name of the summary file")
	p.add_option("--ratio", "-r", dest="ratioNB", default="10", help="Ratio of the original text included in summarization")
	p.add_option("--linux", "-l", dest="linuxOrNot", default="linux", help="If not set -> working under Windows; if set to linux working under Linux")
	
        option, arguments = p.parse_args()

	if option.linuxOrNot == "linux" :
		workDirName = option.workDirNameNB.replace('%20', ' ')
		workDirName = workDirName.replace("F:\\", "/media/DATI/")
		workDirName = workDirName.replace('\\', '/')
		srcDirName = option.srcDirNameNB.replace('%20', ' ')
		srcDirName = srcDirName.replace("F:\\", "/media/DATI/")
		srcDirName = srcDirName.replace('\\', '/')		
		intermediateDirName = option.intermediateDirNameNB.replace('%20', ' ')
		summaryFileName = option.summaryFileNameNB.replace('%20', ' ')
		ratio = option.ratioNB.replace('%20', '')
	else :
		workDirName = option.workDirNameNB.replace('%20', ' ')
		srcDirName = option.srcDirNameNB.replace('%20', ' ')
		intermediateDirName = option.intermediateDirNameNB.replace('%20', ' ')
		summaryFileName = option.summaryFileNameNB.replace('%20', ' ')
		ratio = option.ratioNB.replace('%20', '')

	print "Summarizing ", workDirName
	print "Ratio ", ratio
	print 

	# Reading the file Hash_file.hashfile and creating a dictionary where the keys are the name of the texts files and the values 
	# are the names of the weight files.
	hashfilePath = os.path.normpath(workDirName+os.sep+intermediateDirName+os.sep+option.hashFileName)
	fh = open(hashfilePath, 'r');
	fileWeightMatch = {}
	for line in fh :
		listPaht = line.strip().split()
		fileWeightMatch[listPaht[0]] = listPaht[1]
		
	fh.close()
        index = 600
        for fileName in os.listdir(workDirName) :
		if (fileName != intermediateDirName) :
                	clusterDir = os.path.normpath(workDirName+os.sep+fileName+os.sep)
			ext = os.path.splitext( summaryFileName )
                	finalSummaryName = workDirName+os.sep+fileName+os.sep + ext[0].replace(' ','_') + "_" + fileName +ext[1]
                	summaryFilePath = os.path.normpath(finalSummaryName)
                	sortedSummaryName = workDirName+os.sep+fileName+os.sep + ext[0].replace(' ','_') + "_Sorted_" + fileName +ext[1]
                	sortedsummaryFilePath = os.path.normpath(sortedSummaryName)

			callingOTS(clusterDir, summaryFilePath,sortedsummaryFilePath,ratio,fileWeightMatch,index)
			index += 1

	return
               
def callingOTS(clusterDir, summaryFile, sortedsummaryFile, ratio,fileWeightMatch, index) :
	#f = open(summaryFile, 'w');
	#if (index <= 20 or ( index >= 50 and index <= 80  ) ):
	if ( index <= 200 ):
		print "Summarizing directory: ", clusterDir	
	
	counter = 0
	enter = 0
	for fileName in os.listdir(clusterDir) :
		#if (index <= 20 or ( index >= 50 and index <= 80  ) ):
		#if ( index <= 200 ):
			#print "- File: ", fileName
		#enter = 1
		#wieghtfile = ""
		#weightfile = fileWeightMatch[fileName]
		filePath = os.path.normpath(clusterDir+os.sep+fileName)		
		if filePath == summaryFile :
			os.remove(summaryFile)
			print "Removed"
		if filePath == sortedsummaryFile :
			os.remove(sortedsummaryFile)
			print "Removed"

		#filePath = os.path.normpath(clusterDir+os.sep+fileName)		
		#if weightfile == "" :
			#print "Error "+ filePath 
		#arguments = "--ratio "+ ratio +" --weight "+weightfile+ " >> "+ summaryFile
		#commandLine = "ots "+ filePath + " " + arguments
                #p = subprocess.Popen(commandLine , shell=True)
                #p.wait()
                #if p.returncode < 0:
                	#print "Program killed by a signal", p.returncode
                #else:
			#counter+=1
		#f = open(summaryFile, 'a');
		#f.write("\n ------------------------------\n")
		#f.close()
	#if (enter != 0) :	
		#if ( index <= 200 ):
		#if (index <= 20 or ( index >= 50 and index <= 80  ) ):
			#print " --- Progam 'ots' returned (",counter, " times); code in all cases  ", p.returncode, " ---"                        

	#f.close()
	return


if __name__ == "__main__":
	# Someone is launching this directly
	main()
