#!/usr/bin/python

import optparse, tempfile, os, numpy, operator
from subprocess import *
from numpy import *
from pylab import *
from matplotlib.lines import Line2D

path_absolute = '/home/alessandro/clustering/cluto-2.1.1/Linux/'

# run clustering algorithm (Cluto)
def run_clustering (path_dataset, ncluster):
	args = " " + path_dataset +  " " + str(ncluster)
	try:
		print "run vcluster with clusters ", ncluster
		p = Popen(path_absolute + "vcluster" + args , shell=True)
		p.wait()
		if p.returncode < 0:
			print "Vcluster returnes by signal", p.returncode
		else:
			print "Vcluster returned", p.returncode
	except OSError, e:
		print "Execution failed:", e

# read dataset and return a temp file with cluto format
def read_dataset_train (data, path_dataset, labels):
	f = open (data, mode='r')
	fd_dataset = open (path_dataset, mode='w')
	k = 1
	for line in f:
		tokens = line.strip().split()
		if tokens[0] == 'class':
			pass
		elif k == 1:
			fd_dataset.write(str(tokens[1]) + " " + str(tokens[0])+ "\n")
			k += 1
		else:
			labels.append(tokens[0])
			for t in tokens[1:len(tokens)-1]:
				fd_dataset.write (t)
				fd_dataset.write ('\t')
			fd_dataset.write(str(tokens[len(tokens)-1]) + '\n')
	fd_dataset.close()
	return path_dataset

def read_dataset_test (data, path_dataset, labels):
	f = open (data, mode='r')
	fd_dataset = open (path_dataset, mode='w')
	k = 1
	dict_test = {}
	for line in f:
		tokens = line.strip().split()
		if tokens[0] == 'class':
			pass
		elif k == 1:
			fd_dataset.write(str(tokens[1]) + " " + str(tokens[0])+ "\n")
			k += 1
		else:
			dict_test [tokens[0]] = tokens[1:]
	for l in labels:
		#print l
		for item in dict_test[l]:
			fd_dataset.write(item)
			fd_dataset.write('\t')
		fd_dataset.write('\n')
	fd_dataset.close()
	return path_dataset

# calcola il combinatorio (n 2)
def comb (n):
	fatt =  lambda n:reduce(lambda a,b:a*(b+1),range(n),1)
	if n == 1:
		c = 0
	else:
		c = fatt(n) /( fatt(2) * fatt(n-2) )
	return c

# calcola il rand index per un dato numero di cluster
def run_index (train, test):
	cluster_train = {}
	cluster_test = {}
	f_train = open (train, mode='r')
	f_test = open (test, mode='r')
	k = 1
	for line in f_train:
		cluster_train.setdefault (line.strip(), []).append(k)
		k +=1
	n_tot = k-1
	k = 1
	for line in f_test:
		cluster_test.setdefault (line.strip(), []).append(k)
		k +=1
# calcolo di b1 sul train
	b1 = 0
	for item in cluster_train.values():
		b1 += comb ( len(item) )
#	print b1
# calcolo di c1 sul test
	c1 = 0
	for item in cluster_test.values():
		c1 += comb ( len(item) )
#	print c1
# calcolo di a 
	a = 0
	for item_train in cluster_train.values():
		for item_test in cluster_test.values():
			a += comb ( len( set(item_train).intersection( set(item_test) ) ) )
	#print a
	b = b1 - a
	c = c1 - a
	d = comb(n_tot) - a -b -c
#	print d
	return  (float(a+d)/float(a+b+c+d))



#plotting function for silhouete values
def plotting (k, ri_nf, ri_f, titolo):
	plot (k, ri_nf, 'r')
	plot (k, ri_f, 'b')
	line1 = Line2D(range(10), range(10), linestyle='-', color='b')
	line2 = Line2D(range(10), range(10), linestyle='-', color='r')
	legend((line1,line2), ('Filter','No Filter',), loc=0)
	title(titolo)
	xlabel('Number of clusters')
	ylabel('Rand Index')
	axis ([0,max(k)+1, 0,1])
	show()

	# rimuove i file temporanei
def remove_data(dataset_train, dataset_test, dataset_test_filter, i):
	files = dataset_train + ".clustering." + str(i) + " " + dataset_test + ".clustering." + str(i) + " " + dataset_test_filter + ".clustering." + str(i)
	try:
		p = Popen("rm " + files, shell=True)
		p.wait()
		if p.returncode < 0:
			print "rm returnes by signal", p.returncode
	except OSError, e:
		print "Execution failed:", e

# main
def main():
	p = optparse.OptionParser()
	p.add_option('--cluster', '-k', default=200, type='int')
	p.add_option('--stride', '-s', default=10, type='int')
	p.add_option('--lowcluster', '-l', default=10, type='int')
	p.add_option('--path', '-p', default='/home/alessandro/clustering/cluto-2.1.1/Linux/', help="Path clustering program (Cluto)")
	p.add_option('--title', '-t', default='Dataset')
	option, arguments = p.parse_args()
	path_absolute = option.path
	rand_index_filter = []
	rand_index_nofilter = []
	k = []
#	dataset_train = 'dataset_train.txt'
#	dataset_test = 'dataset_test.txt'
	label_gene = []
	dataset_train = read_dataset_train (arguments[0], 'dataset_train.txt', label_gene)
	dataset_test = read_dataset_test (arguments[1], 'dataset_test.txt', label_gene)
	dataset_test_filter = read_dataset_test (arguments[2], 'dataset_test_filter.txt', label_gene)
	for i in range(option.lowcluster, option.cluster+1, option.stride):
		run_clustering (dataset_train, i)
		run_clustering (dataset_test, i)
		run_clustering (dataset_test_filter, i)
		rand_index_nofilter.append(run_index (dataset_train + '.clustering.' + str(i), dataset_test + '.clustering.' + str(i) ))
		rand_index_filter.append(run_index (dataset_train + '.clustering.' + str(i), dataset_test_filter + '.clustering.' + str(i) ))
		k.append(i)
		remove_data(dataset_train, dataset_test, dataset_test_filter, i)
	#print rand_index

	plotting(k, rand_index_nofilter, rand_index_filter, option.title)


if __name__ == '__main__':
	main()
