from optparse import OptionParser
import os

def main():
        p = OptionParser()
	p.add_option("--baseDirectory", dest="basicDirectory", default="F:\\@_Lorenzo\\@_Tesi\\Results\\Alfa_Beta_Gamma_Evaluation\\Top_20_More_Info_normalized_less_gamma\\", help="")
	p.add_option("--jews", dest="jews", default="Jews", help="")		
	p.add_option("--vaccin", dest="vaccin", default="Vaccin", help="")		
	p.add_option("--osteoclast", dest="osteoclast", default="Osteoclast", help="")		
	p.add_option("--stat", dest="stat", default="Stat", help="")		
	p.add_option("--srcRecall", dest="srcRecall", default="Recall.txt", help="")
	p.add_option("--srcScore", dest="srcScore", default="Score.txt", help="")
	p.add_option("--dstRecall", dest="dstRecall", default="F:\\@_Lorenzo\\@_Tesi\\Results\\Alfa_Beta_Gamma_Evaluation\\Top_20_More_Info_normalized_less_gamma\\Avg_Recall.txt", help="")
	p.add_option("--dstScore", dest="dstScore", default="F:\\@_Lorenzo\\@_Tesi\\Results\\Alfa_Beta_Gamma_Evaluation\\Top_20_More_Info_normalized_less_gamma\\Avg_Score.txt", help="")
	p.add_option("--linux", "-l", dest="linuxOrNot", default="linux", help="If not set -> working under Windows; if set to linux working under Linux")
	
        option, arguments = p.parse_args()

	if option.linuxOrNot == "linux" :
		basicDirectory = option.basicDirectory.replace('%20', ' ')
		basicDirectory = basicDirectory.replace("F:\\", "/media/DATI/")
		basicDirectory = basicDirectory.replace('\\', '/')
		dstRecall = option.dstRecall.replace('%20', ' ')
		dstRecall = dstRecall.replace("F:\\", "/media/DATI/")
		dstRecall = dstRecall.replace('\\', '/')
		dstScore = option.dstScore.replace('%20', ' ')
		dstScore = dstScore.replace("F:\\", "/media/DATI/")
		dstScore = dstScore.replace('\\', '/')
	else :
		basicDirectory = option.basicDirectory
		dstRecall = option.dstRecall
		dstScore = option.dstScore

	jewsDir = basicDirectory + os.sep + option.jews
	jewsRecall = jewsDir + os.sep + option.srcRecall
	jewsScore = jewsDir + os.sep + option.srcScore
	vaccDir = basicDirectory + os.sep + option.vaccin
	vaccRecall = vaccDir + os.sep + option.srcRecall
	vaccScore = vaccDir + os.sep + option.srcScore
	ostDir = basicDirectory + os.sep + option.osteoclast
	ostRecall = ostDir + os.sep + option.srcRecall
	ostScore = ostDir + os.sep + option.srcScore
	statDir = basicDirectory + os.sep + option.stat
	statRecall = statDir + os.sep + option.srcRecall
	statScore = statDir + os.sep + option.srcScore

	#Working on the recall files
	fj = open(jewsRecall, 'r')
	fv = open(vaccRecall, 'r')
	fo = open(ostRecall, 'r')
	fs = open(statRecall, 'r')
	frec = open(dstRecall, 'w') # final destination
	recall = []
	header = 0
	lineJ = fj.readline()
	lineV = fv.readline()
	lineO = fo.readline()
	lineS = fs.readline()

	while ( lineJ != "" and lineV != "" and  lineO != "" and  lineS != "") :
		if header == 0:
			header = 1 

		else :
			vj = lineJ.strip().split()
			vv = lineV.strip().split()
			vo = lineO.strip().split()
			vs = lineS.strip().split()
			alfa = float(vj[0])
			beta = float(vj[1])
			gamma = float(vj[2])
			# Working for recall
			avg_r = ( float(vj[3]) + float(vv[3]) + float(vo[3]) + float(vs[3])) /4.0
			tokenR = [alfa, beta, gamma, avg_r]
			recall.append(tokenR)	
		lineJ = fj.readline()
		lineV = fv.readline()
		lineO = fo.readline()
		lineS = fs.readline()

	#recall.sort(myCompareRecall)
	frec.write("Alfa\tBeta\tGamma\tAVG_Recall\n")
	for i in range(0,len(recall)):
		frec.write(str(recall[i][0])+"\t"+str(recall[i][1])+"\t"+str(recall[i][2])+"\t"+'%.5f' %(recall[i][3])+ "\n")
	frec.close()
	fj.close()
	fv.close()
	fo.close()
	fs.close()

	#Working on the score files
	fj = open(jewsScore, 'r')
	fv = open(vaccScore, 'r')
	fo = open(ostScore, 'r')
	fs = open(statScore, 'r')
	fscr = open(dstScore, 'w') # final destination
	scoreGene = []
	header = 0
	lineJ = fj.readline()
	lineV = fv.readline()
	lineO = fo.readline()
	lineS = fs.readline()

	while ( lineJ != "" and lineV != "" and  lineO != "" and  lineS != "") :
		if header == 0:
			header = 1 

		else :
			vj = lineJ.strip().split()
			vv = lineV.strip().split()
			vo = lineO.strip().split()
			vs = lineS.strip().split()
			alfa = float(vj[0])
			beta = float(vj[1])
			gamma = float(vj[2])

			avg_gene = ( float(vj[3]) + float(vv[3]) + float(vo[3]) + float(vs[3])) /4.0
			avg_ots = ( float(vj[4]) + float(vv[4]) + float(vo[4]) + float(vs[4])) /4.0

			tokenS = [alfa, beta, gamma, avg_gene, avg_ots]
			scoreGene.append(tokenS)	
		lineJ = fj.readline()
		lineV = fv.readline()
		lineO = fo.readline()
		lineS = fs.readline()

	#scoreGene.sort(myCompareScoreGene)
	fscr.write("Alfa\tBeta\tGamma\tGENE\tOTS\t\n")
	for i in range(0,len(scoreGene)):
		fscr.write(str(scoreGene[i][0])+"\t"+str(scoreGene[i][1])+"\t"+str(scoreGene[i][2])+"\t"+'%.5f' %(scoreGene[i][3])+"\t"+'%.5f' %(scoreGene[i][4])+"\n")
	fscr.close()
	fj.close()
	fv.close()
	fo.close()
	fs.close()

	return

def myCompareRecall(token1, token2):
	totRecall1 = float(token1[3])
	totRecall2 = float(token2[3])
	return cmp (totRecall2,totRecall1)

def myCompareScoreGene(token1, token2):
	scoreGene1 = float(token1[3])
	scoreGene2 = float(token2[3])
	scoreOTS1 = float(token1[4])
	scoreOTS2 = float(token2[4])
	if cmp (scoreGene2,scoreGene1) != 0:
		return cmp (scoreGene2,scoreGene1)
	return cmp (scoreOTS2,scoreOTS1)



if __name__ == "__main__":
	# Someone is launching this directly
	main()
