from xml.etree.ElementTree import ElementTree
from optparse import OptionParser
import os
import subprocess

def main():
        p = OptionParser()
	p.add_option("--sourceDirName", dest="srcDirNameNB", default="F:\\Text_Selection_JEWS_ABBD\\", help="Absolute path of the directory where the selected texts are stored")
	p.add_option("--finalDirName", dest="finDirNameNB", default="F:\\Text_Selection_JEWS_with_info_ABBD\\", help="Absolute path of the directory where the selected texts are stored")
        p.add_option("--intermediate", "-i", dest="intermediateDirNameNB", default="Intermediate", help="Name of the directory where to store the intermediary processing files (Ex. data.dat)")
	p.add_option("--hashfileName", dest="hashFileName", default="Hash_File.hashfile", help="Name of a file in which each line has two entries: the name of the selected file and the name of the weights")	
	p.add_option("--ratio", "-r", dest="ratio", default="20", help="Ratio of the original text included in summarization")
	p.add_option("--summFileName", "-n", dest="summaryFileNameNB", default="Summary.txt", help="Name of the summary file")
	p.add_option("--summSorted", dest="summarySortedNB", default="Summary_Sorted.txt", help="Name of the summary file")
	p.add_option("--linux", "-l", dest="linuxOrNot", default="linux", help="If not set -> working under Windows; if set to linux working under Linux")
	
        option, arguments = p.parse_args()

	if option.linuxOrNot == "linux" :
		finDirName = option.finDirNameNB.replace('%20', ' ')
		finDirName = finDirName.replace("F:\\", "/media/DATI/")
		finDirName = finDirName.replace('\\', '/')
		srcDirName = option.srcDirNameNB.replace('%20', ' ')
		srcDirName = srcDirName.replace("F:\\", "/media/DATI/")
		srcDirName = srcDirName.replace('\\', '/')		
		intermediateDirName = option.intermediateDirNameNB.replace('%20', ' ')
		summaryFileName = option.summaryFileNameNB.replace('%20', ' ')
		summarySorted = option.summarySortedNB.replace('%20', ' ')
	else :
		finDirName = option.finDirNameNB.replace('%20', ' ')
		srcDirName = option.srcDirNameNB.replace('%20', ' ')
		intermediateDirName = option.intermediateDirNameNB.replace('%20', ' ')
		summaryFileName = option.summaryFileNameNB.replace('%20', ' ')
		summarySorted = option.summarySortedNB.replace('%20', ' ')

	# Find the GoldenGeneNumber and fill a dictionary with all the sentences
	listToSort = []
	listNotSorted = []
	sentDict = {}
	totWc = 0
        for fileName in os.listdir(finDirName) :
		source = os.path.normpath(finDirName+os.sep+fileName)
		fr = open(source, 'r')
		fw = open("/media/DATI/GoldenGeneCounter.txt", 'w')
		fid = open("/media/DATI/GoldenGeneCounter_ID.txt", 'w')
	
		fileWc = 0
		sentence = ""
		for line in fr :
			if line.strip() == "------------------------------":
				continue
			if line.strip() == "" or line.strip() == " ":
				continue

			if (line.find("{{{") != -1) : 
				#found the last line
				values = line.strip().split("{{{")
				# in 0 I have the sentence; in 1 I have 'ID WC GENE BUCKET}}}'
				sentence += values[0].strip()
				insideBrackets = values[1].strip().split("}}}")
				fourNumbers = insideBrackets[0].strip().split(", ")
				sentId = fourNumbers[0].strip()
				sentWc = int(fourNumbers[1].strip())
				fileWc += sentWc
				sentGene = int(fourNumbers[2].strip())
				sentBuck = int(fourNumbers[3].strip())				

				token = [sentence, sentId, sentWc, sentGene, sentBuck]
				listToSort.append(token)
				listNotSorted.append(token)
				#print len(listToSort), " ", listToSort[len(listToSort)-1]
				sentDict[sentence] = len(listNotSorted)-1 

				sentence = ""
			else :
				sentence += line
		totWc += (fileWc*int(option.ratio)*1.0/100)

	listToSort.sort(myCompare)

	counter = 0
	i = 0
	numOfSentences = 0
	while counter <= totWc: 	
		if counter + listToSort[i][2] <= totWc:
			counter += listToSort[i][2]
			numOfSentences += 1
			fw.write(str(listToSort[i][0])+" {{{"+str(listToSort[i][1])+", "+str(listToSort[i][2]) +", "+str(listToSort[i][3])+", "+str(listToSort[i][4])+"}}}\n\n")
			fid.write( str(listToSort[i][1])+"\n" )
		else:
			break
		i += 1

	fw.write("\n"+str(numOfSentences)+" "+str(counter)+"\n")
			
	fr.close()
	fw.close()
	fid.close()

	success = 0
	# Find the OTS Golden; run OTS
	for fileName in os.listdir(srcDirName) :
		if (fileName != intermediateDirName) :
		        otsSummaryFilePath = os.path.normpath("/media/DATI/Summary.txt")
			filePath = os.path.normpath(srcDirName+os.sep+fileName)		
			arguments = "--ratio "+ option.ratio +" >> "+ otsSummaryFilePath
			commandLine = "ots "+ filePath + " " + arguments
		        p = subprocess.Popen(commandLine , shell=True)
		        p.wait()
		        if p.returncode < 0:
		        	print "Program killed by a signal", p.returncode
		        else:
				success += 1
	print " --- Progam 'ots' returned code ", p.returncode, " (", success, " times)---" 

	# Sort the summary OTS, remove [[SCORE..., insert {{{...
	fr = open("/media/DATI/Summary.txt", 'r');
	fw = open("/media/DATI/Summary_Sorted.txt", 'w');
	fsid = open("/media/DATI/Summary_Sorted_Id.txt", 'w');
		
	listToSortSumm = []
	sentence = ""
	for line in fr :
		if line.strip() == "------------------------------":
			continue
		if line.strip() == "" or line.strip() == " ":
			continue

		#if (line.find("[[SCORE =") != -1) : 
		if (line.find("[[POINT =") != -1) : 
			#found the last line
			
			#values = line.strip().split("[[SCORE = ")
			values = line.strip().split("[[POINT = ")
			words = values[0]
			sentence += words

			values2 = values[1].strip().split("]]")
			score = int(values2[0])

			#Retrieve the sentence from the dictionary
			if sentence[0]==' ':
				index = sentDict[sentence[1:]]			
			else: 
				index = sentDict[sentence]			
			tokenS = [listNotSorted[index][0],listNotSorted[index][1],listNotSorted[index][2],listNotSorted[index][3],listNotSorted[index][4],score]
			listToSortSumm.append(tokenS)
			sentence = ""
		else :
			sentence += line

	listToSortSumm.sort(myCompareSumm)
	
	numOfSentences = 0
	wordCount = 0
	for i in range(0, len(listToSortSumm)) :
		fw.write(str(listToSortSumm[i][0])+" {{{"+str(listToSortSumm[i][1])+", "+str(listToSortSumm[i][2]) +", "+str(listToSortSumm[i][3])+", "+str(listToSortSumm[i][4])+"}}}\n\n")
		wordCount += listToSortSumm[i][2]
		numOfSentences += 1
		fsid.write( str(listToSortSumm[i][1])+"\n" )
	fw.write("\n"+str(numOfSentences)+" "+str(wordCount)+"\n")
	fr.close()
	fw.close()
	fsid.close()
	return


def myCompare(token1, token2):

	gene1 = int(token1[3])
	gene2 = int(token2[3])
	wc1 = int(token1[2])
	wc2 = int(token2[2])
	id1 = token1[1]
	id2 = token1[1]
	if cmp(gene2,gene1) != 0 :
		return cmp(gene2,gene1)
	if cmp(wc2,wc1) != 0 :
		return cmp(wc2,wc1)
	return cmp(id2,id1)

def myCompareSumm(token1, token2):

	score1 = int(token1[5])
	score2 = int(token2[5])
	return cmp(score2,score1)

if __name__ == "__main__":
	# Someone is launching this directly
	main()
