from xml.etree.ElementTree import ElementTree
from optparse import OptionParser
import os
import shutil

def main():
        p = OptionParser()

        p.add_option("--selected", dest="selectedDirNB", default="F:\\Text_Selection_JEWS_ABBD\\", help="Absolute path of the directory where the cleaned articles are stored")
        p.add_option("--numDup", dest="numDupDirNB", default="F:\\FileNumFiles_JEWS\\", help="Absolute path of the directory where the cleaned articles are stored")
        p.add_option("--intDirectory", dest="intDirName", default="Intermediate", help="Name of the directory where to store the intermediary processing files (Ex. data.dat)")
	p.add_option("--dest", dest="destDirNB", default="F:\\ID_GENUM\\", help="Absolute path of the directory where the selected parts of the articles are stored")
        p.add_option("--suffix", "-n", dest="suffixNB", default="cleaned", help="Suffix to be added to the processed article name")
        p.add_option("--linux", "-l", dest="linuxOrNot", default="linux", help="If not set -> working under Windows; if set to linux working under Linux")
        
        option, arguments = p.parse_args()

        if option.linuxOrNot == "linux" :
		ndDir = option.numDupDirNB.replace('%20', ' ')
		ndDir = ndDir.replace("F:\\", "/media/DATI/")
		ndDir = ndDir.replace('\\', '/')
		selDir = option.selectedDirNB.replace('%20', ' ')
		selDir = selDir.replace("F:\\", "/media/DATI/")
		selDir = selDir.replace('\\', '/')
		destDir = option.destDirNB.replace('%20', ' ')
		destDir = destDir.replace("F:\\", "/media/DATI/")
		destDir = destDir.replace('\\', '/')
		suffix = option.suffixNB.replace('%20', ' ')		
		intDirName = option.intDirName.replace('%20', ' ')		
	else :
		destDir = option.destDirNB.replace('%20', ' ')
		ndDir = option.numDupDirNB.replace('%20', ' ')
		selDir = option.selectedDirNB.replace('%20', ' ')
		suffix = option.suffixNB.replace('%20', ' ')
		intDirName = option.intDirName.replace('%20', ' ')			

        hashN = os.path.normpath(ndDir+os.sep+intDirName+os.sep+"NUM_Hash_File.hashfile")
	hashD =	os.path.normpath(ndDir+os.sep+intDirName+os.sep+"DUP_Hash_File.hashfile")

	fhn = open (hashN, mode='r')
	fhd = open (hashD, mode='r')

        newForm = destDir +os.sep
        if (os.path.exists(newForm)) :
                print "The specified output directory already exists: can't over-write. Returning",numDirname
                return
        else :
                os.mkdir(newForm)


	fileId = 0
        for line in fhn :
		paths = line.strip().split()
		source = paths[0]
		hashNumber = paths[1]
		line3 = fhd.readline()
		paths3 = line3.strip().split()

		if (paths3[0] != source):
			print "Don't match! ", paths3[0], " ",source 
			os._exit(1)

		hashDup = paths3[1]			

		#destFileNames = os.path.split(source)
		sourceFile = os.path.normpath(selDir+os.sep+source)
		destFile = os.path.normpath(destDir+os.sep+source)
##		ext = os.path.splitext( source )
##		destFile = os.path.normpath(destDir+os.sep+ext[0].replace(' ','_') + "_ID_NGENE"+ ext[1])
              
		newFormatOfFile(sourceFile,destFile,hashNumber,hashDup,fileId)
		fileId += 1

	fhn.close()
	fhd.close()
	return

def newFormatOfFile(source,destFile,hashNumber,hashDup,fileId):

	noBreakList = {}
	# List of words that don't cause sentence termination
	noBreakList["U.S."]=''; noBreakList["[U.S."]='' ; noBreakList["(U.S."]=''	
	noBreakList["St."]=''; noBreakList["[St."]='' ;	noBreakList["(St."]='' ; noBreakList["-St."]=''	
	noBreakList["Rush-Presbyterian-St."]=''		
	noBreakList["Dr."]='' ;	noBreakList["[Dr."]='' ; noBreakList["(Dr."]=''	
	noBreakList["r.p.m."]='' ; noBreakList["(r.p.m."]='' ; noBreakList["[r.p.m."]=''		
	noBreakList["p.p.m."]='' ; noBreakList["(p.p.m."]='' ; noBreakList["[p.p.m."]=''		
	noBreakList["Jan."]=''	; noBreakList["[Jan."]='' ; noBreakList["(Jan."]='' 
	noBreakList["Feb."]='' ; noBreakList["(Feb."]='' ; noBreakList["[Feb."]=''
	noBreakList["Mar."]='' ; noBreakList["(Mar."]='' ; noBreakList["[Mar."]=''
	#noBreakList["April."]=''	
	noBreakList["May."]='' ; noBreakList["(May."]='' ; noBreakList["[May."]=''	
	noBreakList["Jun."]='' ; noBreakList["(Jun."]='' ; noBreakList["[Jun."]=''
	noBreakList["C-Jun."]='' ; noBreakList["c-Jun."]=''
	noBreakList["Jul."]='' ; noBreakList["(Jul."]='' ; noBreakList["[Jul."]=''
	noBreakList["Aug."]='' ; noBreakList["[Aug."]='' ; noBreakList["(Aug."]=''
	#noBreakList["September."]=''
	noBreakList["Oct."]='' ; noBreakList["[Oct."]='' ; noBreakList["(Oct."]=''
	noBreakList["Nov."]='' ; noBreakList["[Nov."]='' ; noBreakList["(Nov."]=''	
	noBreakList["Dec."]='' ; noBreakList["[Dec."]='' ; noBreakList["(Dec."]=''		
	noBreakList["a.m."]='' ; noBreakList["(a.m."]='' ; noBreakList["[a.m."]=''		
	noBreakList["p.m."]='' ; noBreakList["(p.m."]='' ; noBreakList["[p.m."]=''			
	noBreakList["Mrs."]='' ; noBreakList["(Mrs."]='' ; noBreakList["[Mrs."]=''
	noBreakList["Rep."]='' ; noBreakList["'Rep."]='' ; noBreakList["(Rep."]=''; noBreakList["('Rep."]='' ; noBreakList["[Rep."]=''
	noBreakList["c.p.m."]='' ; noBreakList["(c.p.m."]='' ; noBreakList["[c.p.m."]='' ; noBreakList["C.p.m."]='' ; noBreakList["(C.p.m."]=''	; noBreakList["[C.p.m."]='' ; noBreakList["stimulation/C.p.m."]=''						

        f = open (source, mode='r')
	fnum = open (hashNumber, mode='r')
	fdup = open (hashDup, mode='r')
	line2 = fnum.readline(); line3 = fdup.readline() #Read the first line that contains the toal number of rows
	fd = open (destFile, mode='w')

	sentenceCount = 0
	for line in f :
		for word in line.strip().split() :
#			fd.write(word+" ")		
			if ( (noBreakList.has_key(word) == False) and (word.endswith("!") or word.endswith("?") or word.endswith(";") or word.endswith(".") or word.endswith("|") or word.endswith("?\"") or word.endswith("!\"") or word.endswith(".\"") ) ):
				number = fnum.readline();	
				fd.write(str(fileId)+"."+str(sentenceCount)+ " "+number.strip()+"\n")		
				sentenceCount += 1
#		fd.write("\n")

        f.close()
	fnum.close()
	fdup.close()
	fd.close()
	return           

if __name__ == "__main__":
	# Someone is launching this directly
	main()
