from xml.etree.ElementTree import ElementTree
from optparse import OptionParser
import os
import subprocess

def main():
        p = OptionParser()

##	p.add_option("--sourceDirName", dest="srcDirNameNB", default="F:\\Text_Selection\\", help="Absolute path of the directory where the selected texts are stored")
	p.add_option("--sourceDirName", dest="srcDirNameNB", default="F:\\Text_Selection_JEWS_ABBD\\", help="Absolute path of the directory where the selected texts are stored")
	p.add_option("--finalDirName", dest="finDirNameNB", default="F:\\Text_Selection_JEWS_with_info_ABBD\\", help="Absolute path of the directory where the selected texts are stored")
        p.add_option("--intermediate", "-i", dest="intermediateDirNameNB", default="Intermediate", help="Name of the directory where to store the intermediary processing files (Ex. data.dat)")
	p.add_option("--hashfileName", dest="hashFileName", default="Hash_File.hashfile", help="Name of a file in which each line has two entries: the name of the selected file and the name of the weights")	
	p.add_option("--ratio", "-r", dest="ratioNB", default="100", help="Ratio of the original text included in summarization")
	p.add_option("--linux", "-l", dest="linuxOrNot", default="linux", help="If not set -> working under Windows; if set to linux working under Linux")
	
        option, arguments = p.parse_args()

	if option.linuxOrNot == "linux" :
		srcDirName = option.srcDirNameNB.replace('%20', ' ')
		srcDirName = srcDirName.replace("F:\\", "/media/DATI/")
		srcDirName = srcDirName.replace('\\', '/')		
		finDirName = option.finDirNameNB.replace('%20', ' ')
		finDirName = finDirName.replace("F:\\", "/media/DATI/")
		finDirName = finDirName.replace('\\', '/')		
		intermediateDirName = option.intermediateDirNameNB.replace('%20', ' ')
		ratio = option.ratioNB.replace('%20', '')
	else :
		srcDirName = option.srcDirNameNB.replace('%20', ' ')
		finDirName = option.finDirNameNB.replace('%20', ' ')
		intermediateDirName = option.intermediateDirNameNB.replace('%20', ' ')
		ratio = option.ratioNB.replace('%20', '')

	num = 20

	print "Summarizing ", srcDirName
	print "Ratio ", ratio
	print 

	noBreakList = {}
	# List of words that don't cause sentence termination
	noBreakList["U.S."]=''; noBreakList["[U.S."]='' ; noBreakList["(U.S."]=''	
	noBreakList["St."]=''; noBreakList["[St."]='' ;	noBreakList["(St."]='' ; noBreakList["-St."]=''	
	noBreakList["Rush-Presbyterian-St."]=''		
	noBreakList["Dr."]='' ;	noBreakList["[Dr."]='' ; noBreakList["(Dr."]=''	
	noBreakList["r.p.m."]='' ; noBreakList["(r.p.m."]='' ; noBreakList["[r.p.m."]=''		
	noBreakList["p.p.m."]='' ; noBreakList["(p.p.m."]='' ; noBreakList["[p.p.m."]=''		
	noBreakList["Jan."]=''	; noBreakList["[Jan."]='' ; noBreakList["(Jan."]='' 
	noBreakList["Feb."]='' ; noBreakList["(Feb."]='' ; noBreakList["[Feb."]=''
	noBreakList["Mar."]='' ; noBreakList["(Mar."]='' ; noBreakList["[Mar."]=''
	#noBreakList["April."]=''	
	noBreakList["May."]='' ; noBreakList["(May."]='' ; noBreakList["[May."]=''	
	noBreakList["Jun."]='' ; noBreakList["(Jun."]='' ; noBreakList["[Jun."]=''
	noBreakList["C-Jun."]='' ; noBreakList["c-Jun."]=''
	noBreakList["Jul."]='' ; noBreakList["(Jul."]='' ; noBreakList["[Jul."]=''
	noBreakList["Aug."]='' ; noBreakList["[Aug."]='' ; noBreakList["(Aug."]=''
	#noBreakList["September."]=''
	noBreakList["Oct."]='' ; noBreakList["[Oct."]='' ; noBreakList["(Oct."]=''
	noBreakList["Nov."]='' ; noBreakList["[Nov."]='' ; noBreakList["(Nov."]=''	
	noBreakList["Dec."]='' ; noBreakList["[Dec."]='' ; noBreakList["(Dec."]=''		
	noBreakList["a.m."]='' ; noBreakList["(a.m."]='' ; noBreakList["[a.m."]=''		
	noBreakList["p.m."]='' ; noBreakList["(p.m."]='' ; noBreakList["[p.m."]=''			
	noBreakList["Mrs."]='' ; noBreakList["(Mrs."]='' ; noBreakList["[Mrs."]=''
	noBreakList["Rep."]='' ; noBreakList["'Rep."]='' ; noBreakList["(Rep."]=''; noBreakList["('Rep."]='' ; noBreakList["[Rep."]=''
	noBreakList["c.p.m."]='' ; noBreakList["(c.p.m."]='' ; noBreakList["[c.p.m."]='' ; noBreakList["C.p.m."]='' ; noBreakList["(C.p.m."]=''	; noBreakList["[C.p.m."]='' ; noBreakList["stimulation/C.p.m."]=''						


	# Reading the file Hash_file.hashfile and creating a dictionary where the keys are the name of the texts files and the values 
	# are the names of the weight files.
	hashfilePath = os.path.normpath(srcDirName+os.sep+intermediateDirName+os.sep+option.hashFileName)
	fh = open(hashfilePath, 'r');
	fileWeightMatch = {}
	for line in fh :
		listPaht = line.strip().split()
		fileWeightMatch[listPaht[0]] = listPaht[1]
		
	fh.close()
	
	# Using OTS on the files contained in F:\\Text_Selection_JEWS_ABBD\\; store the summary obtained in /media/DATI/ID_GENUM
        for fileName in os.listdir(srcDirName) :
		if (fileName != intermediateDirName) :
			ext = os.path.splitext( fileName )
		        finalSummaryName = "/media/DATI/ID_GENUM"+os.sep+ext[0].replace(' ','_') + "_Summary"+ ext[1]
		        summaryFilePath = os.path.normpath(finalSummaryName)
			weightfile = ""
			weightfile = fileWeightMatch[fileName]
			filePath = os.path.normpath(srcDirName+os.sep+fileName)		
			if weightfile == "" :
				print "Error "+ filePath 
			#arguments = "--ratio "+ ratio +" --weight "+weightfile+ " >> "+ summaryFilePath
			arguments = "--ratio "+ ratio +" >> "+ summaryFilePath
			commandLine = "ots "+ filePath + " " + arguments
		        p = subprocess.Popen(commandLine , shell=True)
		        p.wait()
		        if p.returncode < 0:
		        	print "Program killed by a signal", p.returncode
		        else:
				print " --- Progam 'ots' returned code ", p.returncode, " ---" 

	step = 1.0/num
	bucketThsld = []

	print "Steps: ",
	for i in range(0,num+1) :
		bucketThsld.append(i*step)	
		print bucketThsld[i], " " ,
	print 

	print "Max: ",
	
	# Processing the summary in /media/DATI/ID_GENUM (the files whose name conatins _Summary); extract the score and the word count 
	# Thanks to the score derive the bucket in which to put the sentence and store "SCORE BUCKET WRD_COUNT" in a file with suffix _SBW
	# (contained in /media/DATI/ID_GENUM)
	for fileName in os.listdir("/media/DATI/ID_GENUM/") :
		if (fileName.find("_Summary") != -1) :
			dictBuck = {'1':1, '2':1, '3':1, '4':1, '5':1, '6':1,'7':1, '8':1, '9':1,'10':1,'11':1, '12':1, '13':1, '14':1, '15':1, '16':1,'17':1, '18':1, '19':1,'20':1}
	
			fr = open("/media/DATI/ID_GENUM/"+fileName, 'r')
			ext = os.path.splitext( fileName )
#		        suName = "/media/DATI/ID_GENUM"+os.sep+ext[0].replace(' ','_') + "_MOD"+ ext[1]
		        suName = "/media/DATI/ID_GENUM"+os.sep+fileName[:fileName.find("_Summary")]+"_SBW"+ext[1]
			fw = open(suName, 'w')
		
			listToSort = []
			listNotSorted = []
			sentence = ""
			for line in fr :
#				if line.strip() == "" or line.strip() == " ":
#					continue

				if (line.find("[[POINT =") != -1) : 
				#if (line.find("[[SCORE =") != -1) : 
					#found the last line
					values = line.strip().split("[[POINT = ")
					
					#values = line.strip().split("[[SCORE = ")
					# values[0] = sentence values[1]= everything after score
					words = values[0].strip()
					sentence += words

					values2 = values[1].strip().split("]]")
					val = int(values2[0])

					index = values2[1].strip().find(" [[WRD_COUNT = ")+ 15
					#print values2[1].strip(), "; ",values2[1].strip()[index:]
					wordCount = int(values2[1].strip()[index:])
					token = [sentence, val, wordCount]
					listToSort.append(token)
					listNotSorted.append(token)
					sentence = ""
				else :
					sentence += line

			listToSort.sort(myCompare)
			print listToSort[0][1], " ", 
			for i in range(0, len(listNotSorted)) :
				maximum = listToSort[0][1]
				bucket = findBucket(listNotSorted[i][1], maximum, bucketThsld,num)
				if (bucket == 0):
					print "Bucket can't be 0" 
					os._exit(1)
#				bucket = 1
				dictBuck[str(bucket)] += 1
#				fw.write(str(listNotSorted[i][0])+" [[SCORE="+str(listNotSorted[i][1])+"]] [[BUCK="+str(bucket)+"]] "+listNotSorted[i][2]+"]]\n")

				# Writes Score Bucket Word count
				fw.write(str(listNotSorted[i][1])+" "+str(bucket)+" "+str(listNotSorted[i][2])+"\n")
			
			fr.close()
##		        for k, v in dictBuck.iteritems():
##		                fw.write("Key = "+str(k) +"; Val = "+str(v) +"\n")                
			fw.close()
			dictBuck.clear()

	#Process the clean texts stored in F:\\Text_Selection_JEWS_ABBD\\; take from /media/DATI/ID_GENUM two files: one with the same name
	# of the processed one (that contains ID and GENE NUMBER) one with the same name and suffix SBW (that contains SCORE BUCKET WRD_COUNT)
	#Write a new version of the orginal text with the normal sentence and at the end of each one {{{ID, WRD_COUNT, GENE_NUMBER, BUCKET}}}
	#Store the results in the newly created directory F:\\Text_Selection_JEWS_with_info_ABBD\\

        definitive = finDirName +os.sep
        if (os.path.exists(definitive)) :
                print "The specified output directory already exists: can't over-write. Returning",finDirName
                return
        else :
                os.mkdir(definitive)


        for fileName in os.listdir(srcDirName) :
		if (fileName != intermediateDirName) :
			ext = os.path.splitext( fileName )
			source = os.path.normpath(srcDirName+os.sep+fileName)
			file_SBW = os.path.normpath("/media/DATI/ID_GENUM"+os.sep+ext[0]+ "_SBW"+ ext[1])
			file_ID_GENE = os.path.normpath("/media/DATI/ID_GENUM"+os.sep+fileName)
			file_dest = os.path.normpath(finDirName+os.sep+fileName)

		        f = open (source, mode='r')
			fs = open (file_SBW, mode='r')
			fi = open (file_ID_GENE, mode='r')
			fd = open (file_dest, mode='w')

			for line in f :

				for word in line.strip().split() :
					fd.write(word+ " ")
					if ( (noBreakList.has_key(word) == False) and (word.endswith("!") or word.endswith("?") or word.endswith(";") or word.endswith(".") or word.endswith("|") or word.endswith("?\"") or word.endswith("!\"") or word.endswith(".\"") ) ):
						# Retrieve ID and gene number
						lineFI = fi.readline()
						numbers = lineFI.strip().split();	
						sentId = numbers[0].strip()
						sentGeneNum = numbers[1].strip()												
						# Retrieve Bucket and wordCount
						lineFS = fs.readline()
						numbersFS = lineFS.strip().split();	
						bucket = numbersFS[1].strip()
						wrd_cnt = numbersFS[2].strip()
						fd.write("{{{"+str(sentId)+", "+str(wrd_cnt) +", "+str(sentGeneNum)+", "+str(bucket)+"}}}\n\n")		

				fd.write("\n")

		        f.close()
			fs.close()
			fi.close()
			fd.close()

	return
                       
def myCompare(token1, token2):

	int1 = int(token1[1])
	int2 = int(token2[1])
	return cmp (int2,int1)

               
def findBucket(value, maximum, bucketThsld,num): 
	normalized = value*1.0/maximum	
	if normalized == 1.0: 
		return num
	for i in range (1, num+1): 
		#print "N ", normalized, " i-1 ", bucketThsld[i-1], " i ", bucketThsld[i]
		if (normalized >= bucketThsld[i-1] and normalized < bucketThsld[i]):
			return i

	return 0

if __name__ == "__main__":
	# Someone is launching this directly
	main()
