from xml.etree.ElementTree import ElementTree
from optparse import OptionParser
import os
import subprocess

def main():
        p = OptionParser()
        p.add_option("--work", "-w", dest="workDirNameNB", default="F:\\Experimental_Results_BIO\\", help="Absolute path of the directory where pieces of the framework are stored")
	p.add_option("--sourceDirName", dest="srcDirNameNB", default="F:\\Text_Selection_BIO_ABBD\\", help="Absolute path of the directory where the selected texts are stored")
        p.add_option("--intermediate", "-i", dest="intermediateDirNameNB", default="Intermediate", help="Name of the directory where to store the intermediary processing files (Ex. data.dat)")
	p.add_option("--summFileName", "-n", dest="summaryFileNameNB", default="Summary.txt", help="Name of the summary file")
	p.add_option("--summSorted", "-r", dest="summarySortedNB", default="Summary_Sorted.txt", help="Name of the summary file")
	p.add_option("--linux", "-l", dest="linuxOrNot", default="linux", help="If not set -> working under Windows; if set to linux working under Linux")
	
        option, arguments = p.parse_args()

	if option.linuxOrNot == "linux" :
		workDirName = option.workDirNameNB.replace('%20', ' ')
		workDirName = workDirName.replace("F:\\", "/media/DATI/")
		workDirName = workDirName.replace('\\', '/')
		srcDirName = option.srcDirNameNB.replace('%20', ' ')
		srcDirName = srcDirName.replace("F:\\", "/media/DATI/")
		srcDirName = srcDirName.replace('\\', '/')		
		intermediateDirName = option.intermediateDirNameNB.replace('%20', ' ')
		summaryFileName = option.summaryFileNameNB.replace('%20', ' ')
		summarySorted = option.summarySortedNB.replace('%20', ' ')
	else :
		workDirName = option.workDirNameNB.replace('%20', ' ')
		srcDirName = option.srcDirNameNB.replace('%20', ' ')
		intermediateDirName = option.intermediateDirNameNB.replace('%20', ' ')
		summaryFileName = option.summaryFileNameNB.replace('%20', ' ')
		summarySorted = option.summarySortedNB.replace('%20', ' ')

	print "Summarizing ", workDirName
	print 

        for fileName in os.listdir(workDirName) :
		if (fileName != intermediateDirName) :
                	clusterDir = os.path.normpath(workDirName+os.sep+fileName+os.sep)
			ext = os.path.splitext( summaryFileName )
			extS = os.path.splitext( summarySorted )
                	originalSummaryName = workDirName+os.sep+fileName+os.sep + ext[0].replace(' ','_') + "_" + fileName +ext[1]
                	originalSummaryFilePath = os.path.normpath(originalSummaryName)
			summaryName = workDirName+os.sep+fileName+os.sep + extS[0].replace(' ','_') + "_" + fileName +extS[1]
                	summaryFilePath = os.path.normpath(summaryName)

			summarySorter(clusterDir, originalSummaryFilePath, summaryFilePath)
		

	return
               
def summarySorter(clusterDir, orSummaryFile,summaryFile) :
	fr = open(orSummaryFile, 'r');
	fw = open(summaryFile, 'w');
		
	listToSort = []
	sentence = ""
	for line in fr :
		if line.strip() == "------------------------------":
			continue
		if line.strip() == "" or line.strip() == " ":
			continue

		if (line.find("[[SCORE =") != -1) : 
		#if (line.find("[[POINT =") != -1) : 
			#found the last line
			sentence += line
			values = line.strip().split("[[SCORE = ")
			#values = line.strip().split("[[POINT = ")
			values2 = values[1].strip().split("]]")
			val = int(values2[0])
			token = [sentence, val]
			listToSort.append(token)
			sentence = ""
		else :
			sentence += line

	listToSort.sort(myCompare)
	
	for i in range(0, len(listToSort)) :
		fw.write(str(listToSort[i][0])+"\n")
			
	fr.close()
	fw.close()
	return

def myCompare(token1, token2):
	int1 = int(token1[1])
	int2 = int(token2[1])
	return cmp (int2,int1)


if __name__ == "__main__":
	# Someone is launching this directly
	main()
