from xml.etree.ElementTree import ElementTree
from optparse import OptionParser
import os

def main():
        p = OptionParser()
        p.add_option("--work", "-w", dest="workDirNameNB", default="F:\Preprocessing_Results\\", help="Absolute path of the directory where results are stored")
        p.add_option("--attFileName", "-a", dest="attrFileNameNB", default="attribute.aml", help="Name of the file where Rapid Miner must store the attributes")   
        p.add_option("--name", "-n", dest="colFileNameNB", default="ColLabels.clabel", help="Name of the file in which the labels of the columns of the matrix generated by RM are stored")
        option, arguments = p.parse_args()

        workDirName = option.workDirNameNB.replace('%20', ' ')        
        colFileName = option.colFileNameNB.replace('%20', ' ')
        attrFileName = option.attrFileNameNB.replace('%20', ' ')

        source = os.path.normpath(workDirName + os.sep + attrFileName)
        dest = os.path.normpath(workDirName + os.sep + colFileName)
        print 'Source: ', source, '\nDest: ', dest
        parserFunction(source,dest)
        return

def parserFunction(sourceFile,destFile):
        
        tree = ElementTree()
        found_title = 0
        try:
            tree.parse(sourceFile)
        except Exception, inst:
            print "Unexpected error opening %s: %s" % (sourceFile, inst)
            return

        f = open (destFile, mode='w')

        treeIterator = tree.getiterator()
        for el in treeIterator:
                if el.tag == "attribute" :
                        if el.attrib['valuetype']!="nominal" :
                                text = el.attrib['name']
				f.write(text.encode('ascii','ignore') + "\n")        
                                #f.write(text.encode('latin-1','ignore') + "\n")        
        f.close()
        return                

if __name__ == "__main__":
	# Someone is launching this directly
	main()
