from optparse import OptionParser
import os

def main():
        p = OptionParser()
        p.add_option("--path", "-p", dest="dirnameNB", default="F:\Preprocessing_Results\\", help="Absolute path of the directory where articles are stored")
        p.add_option("--name", "-n", dest="fileNameNB", default="data.dat", help="Name of the source to be processed")
        p.add_option("--suff", "-s", dest="suffixNB", default="cleaned", help="Suffix to be added to the processed article name")
        p.add_option("--rowLabelFileName", "-r", dest="rowFileNameNB", default="RowLabels.rlabel", help="Name of the file in which the labels of the rows of the matrix generated by RM are stored")
        option, arguments = p.parse_args()

        dirname = option.dirnameNB.replace('%20', ' ')        
        fileName = option.fileNameNB.replace('%20', ' ')
        suffix = option.suffixNB.replace('%20', ' ')
        rowFileName = option.rowFileNameNB.replace('%20', ' ')       

        
        source  = dirname + os.sep + fileName
        source = os.path.normpath(source)
        ext = os.path.splitext( source )
        dest = ext[0].replace(' ','_') +"_"+suffix+ext[1]
        dest = os.path.normpath(dest)
        labelFile = dirname + os.sep + rowFileName
        labelFile = os.path.normpath(labelFile)

        print "--- Working files ---"
        print
        print source
        print dest
        print labelFile

        newFormat(source, dest, labelFile)
                
        return

def newFormat(sourceFile, destFile, labelFile) :
        

        fs = open (sourceFile, mode='r')
        fl = open (labelFile, mode='w')

        rowCounter = 0
        columnCounter = 0
        
        for line in fs :
                words = line.strip().split()
                if rowCounter == 0 :
                        for word in words[0:-1] : #all the columns but the last one                        
                                columnCounter += 1                        
                fl.write(words[len(words)-1]+"\n")                                
                rowCounter += 1

        fs.close()        
        fl.close()

        fs = open (sourceFile, mode='r')
        fd = open (destFile, mode='w')
        fd.write(str(rowCounter) + " " + str(columnCounter) +"\n")

        for line in fs :
                words = line.strip().split()
                for word in words[0:-1] : #all the columns but the last one                                                
                        fd.write(word+" ")                
                fd.write("\n")                
        
        fd.close()        
        
        return
                

if __name__ == "__main__":
	# Someone is launching this directly
	main()
