from xml.etree.ElementTree import ElementTree
from optparse import OptionParser
import os
import shutil
import subprocess

def main():
        p = OptionParser()
        p.add_option("--work", "-w", dest="workDirNameNB", default="F:\\Experimental_Results\\", help="Absolute path of the directory where pieces of the framework are stored")
	p.add_option("--sourceDirName", dest="srcDirNameNB", default="F:\\Text_Selection\\", help="Absolute path of the directory where the selected texts are stored")
        p.add_option("--intermediate", "-i", dest="intermediateDirNameNB", default="Intermediate", help="Name of the directory where to store the intermediary processing files (Ex. data.dat)")
	p.add_option("--hashfileName", dest="hashFileName", default="Hash_File.hashfile", help="Name of a file in which each line has two entries: the name of the selected file and the name of the weights")	
	p.add_option("--summFileName", "-n", dest="summaryFileNameNB", default="summ", help="Name of the summary file")
	p.add_option("--dictionary", "-v", dest="dictionaryFileNameNB", default="F:\\@_Lorenzo\\@_Tesi\\@_Framework_Parts\\gene_dictionary_ID.txt", help="Absolute path of the file with the genes and proteins dictionary")
        p.add_option("--stopDictionary", "-p", dest="stopWordsFileNameNB", default="F:\\@_Lorenzo\\@_Tesi\\@_Framework_Parts\\stopWords.txt", help="Absolute path of the file with the stopwords dictionary")        
	p.add_option("--transaction", "-t", dest="transFileNameNB", default="F:\\Transaction\\transaction_summ.txt", help="Absolute path of the file with the transactions")
	p.add_option("--ratio", "-r", dest="ratioNB", default="20", help="Ratio of the original text included in summarization")
	p.add_option("--linux", "-l", dest="linuxOrNot", default="linux", help="If not set -> working under Windows; if set to linux working under Linux")
	
        option, arguments = p.parse_args()

	if option.linuxOrNot == "linux" :
		workDirName = option.workDirNameNB.replace('%20', ' ')
		workDirName = workDirName.replace("F:\\", "/media/DATI/")
		workDirName = workDirName.replace('\\', '/')
		srcDirName = option.srcDirNameNB.replace('%20', ' ')
		srcDirName = srcDirName.replace("F:\\", "/media/DATI/")
		srcDirName = srcDirName.replace('\\', '/')
		dictionaryFileName = option.dictionaryFileNameNB.replace('%20', ' ')
		dictionaryFileName = dictionaryFileName.replace("F:\\", "/media/DATI/")
		dictionaryFileName = dictionaryFileName.replace('\\', '/')		
		stopWordsFileName = option.stopWordsFileNameNB.replace('%20', ' ')
		stopWordsFileName = stopWordsFileName.replace("F:\\", "/media/DATI/")
		stopWordsFileName = stopWordsFileName.replace('\\', '/')
		transFileName = option.transFileNameNB.replace('%20', ' ')
		transFileName = transFileName.replace("F:\\", "/media/DATI/")
		transFileName = transFileName.replace('\\', '/')
		intermediateDirName = option.intermediateDirNameNB.replace('%20', ' ')
		summaryFileName = option.summaryFileNameNB.replace('%20', ' ')
		ratio = option.ratioNB.replace('%20', '')
	else :
		workDirName = option.workDirNameNB.replace('%20', ' ')
		srcDirName = option.srcDirNameNB.replace('%20', ' ')
		intermediateDirName = option.intermediateDirNameNB.replace('%20', ' ')
		dictionaryFileName = option.dictionaryFileNameNB.replace('%20', ' ')
		stopWordsFileName = option.stopWordsFileNameNB.replace('%20', ' ')
		transFileName = option.transFileNameNB.replace('%20', ' ')
		summaryFileName = option.summaryFileNameNB.replace('%20', ' ')
		ratio = option.ratioNB.replace('%20', '')

	print "Summarizing ", workDirName
	print "Ratio ", ratio
	print 

	intDirPath = os.path.normpath(workDirName+os.sep+intermediateDirName)
        os.mkdir(intDirPath)

        for fileName in os.listdir(workDirName) :
                source = os.path.normpath(workDirName+os.sep+fileName)
                if os.path.isfile(source) and source.find(".txt") == -1:
                      shutil.move(source,intDirPath)


	# Reading the file Hash_file.hashfile and creating a dictionary where the keys are the name of the texts files and the values 
	# are the names of the weight files.
	hashfilePath = os.path.normpath(workDirName+os.sep+intermediateDirName+os.sep+option.hashFileName)
	fh = open(hashfilePath, 'r');
	fileWeightMatch = {}
	for line in fh :
		listPaht = line.strip().split()
		fileWeightMatch[listPaht[0]] = listPaht[1]		
	fh.close()

	f = open (stopWordsFileName, mode='r')
        stopDict ={}        
        for line in f :
                words = line.strip()
                stopDict[words] = ''
        f.close()
        
        f = open (dictionaryFileName, mode='r')
        geneDict ={}        
        for line in f :
                words = line.strip().split()
		word = words[1]
		value = words[0]
                if ( (word.strip().isdigit() == False) and (stopDict.has_key(word.strip()) == 0) and (word[0].isdigit() == False) and (word[0] != '#') and (word[0] != '-')) :
                        geneDict[word.strip()] = value
        f.close()

        index = 600
        for fileName in os.listdir(workDirName) :
		if (fileName != intermediateDirName) :
                	sourceFile = os.path.normpath(workDirName+os.sep+fileName)
			ext = os.path.splitext( fileName )
                	finalSummaryName = workDirName+os.sep + ext[0].replace(' ','_') + "_" + summaryFileName +ext[1]
                	summaryFilePath = os.path.normpath(finalSummaryName)
			weightfile = ""
			weightfile = fileWeightMatch[fileName]
			callingOTS(sourceFile, summaryFilePath, ratio, weightfile, geneDict, transFileName)
			index += 1
	return
               
def callingOTS(sourceFile, summaryFile, ratio, weightfile, geneDict, transactions) :

	if weightfile == "" :
		print "Error "+ sourceFile 
		os._exit(1)

	arguments = "--ratio "+ ratio +" --weight "+weightfile+ " > "+ summaryFile
	commandLine = "ots "+ sourceFile + " " + arguments
	p = subprocess.Popen(commandLine , shell=True)
	p.wait()
        if p.returncode != 0:
        	print " --- Progam 'OTS': Abnormal termination (code ", p.returncode, ") ---"
		os._exit(1)

	f = open(summaryFile, 'r');

	itemsets ={}        
	counter = 0

	for line in f :
		for word in line.strip().split() :
			if geneOrNot (geneDict,word,itemsets) == 1 :
				counter += 1
	#print sourceFile +": Found ", counter, " genes" 
	f.close()

	ft = open(transactions, 'a')
	printItemsets(itemsets, ft)
	ft.close()
	return


def geneOrNot (geneDict,word,itemsets):

	if ( geneDict.has_key(word) ) :
		val = geneDict[word]
		itemsets[val] = ''
		return 1

	if ( word.endswith("!") or word.endswith("?") or word.endswith(";") or word.endswith(".") or word.endswith("|")  ):
		if (geneDict.has_key(word[:-1]) ) :
			val = geneDict[word[:-1]]
			itemsets[val] = ''
			return 1
	if ( word.endswith("?\"") or word.endswith("!\"") or word.endswith(".\"") or word.endswith("?)") or word.endswith("!)") or word.endswith(".)") or word.endswith(")?") or word.endswith(")!") or word.endswith(").") or word.endswith(");") or word.endswith("):") or word.endswith(")-") ):
		if (geneDict.has_key(word[:-2]) ) :
			val = geneDict[word[:-2]]
			itemsets[val] = ''
			return 1
	if ( word.startswith("!") or word.startswith("?") or word.startswith(";") or word.startswith(".") or word.startswith("|")  ):
		if (geneDict.has_key(word[1:]) ) :
			val = geneDict[word[1:]]
			itemsets[val] = ''
			return 1
	if ( word.startswith("?\"") or word.startswith("!\"") or word.startswith(".\"") or word.startswith("?)") or word.startswith("!)") or word.startswith(".)") or word.startswith(")?") or word.startswith(")!") or word.startswith(").") or word.startswith(");") or word.startswith("):") or word.startswith(")-") ) :
		if (geneDict.has_key(word[2:]) ) :
			val = geneDict[word[2:]]
			itemsets[val] = ''
			return 1
	return 0



def printItemsets(itemsets, ft) :

 	itlist = []
	for entry in itemsets.keys():
                itlist.append(entry)

	itlist.sort()	
		
	for i in range(0, len(itlist)) :
		ft.write (itlist[i] + " ")
	if (len(itlist) != 0) :
		ft.write("\n")	
	return



if __name__ == "__main__":
	# Someone is launching this directly
	main()
