from xml.etree.ElementTree import ElementTree
from optparse import OptionParser
import os
import shutil

def main():
        p = OptionParser()
        p.add_option("--sourcePath", "-s", dest="dirnameNB", default="F:\\pubmed\\BMC Bioinformatics\\", help="Absolute path of the directory where articles are stored")
        p.add_option("--destPath", "-d", dest="destDirnameNB", default="F:\\Cleaned_Texts\\", help="Absolute path of the directory where the cleaned articles are stored")
        p.add_option("--copyDirectory", dest="copyDirnameNB", default="F:\\pubmed\\Articles%20Keywords\\", help="Absolute path of the directory where to copy the articles with keywords if needed")
        p.add_option("--dictionary", "-v", dest="dictionaryFileNameNB", default="F:\\@_Lorenzo\\@_Tesi\\@_Framework_Parts\\Frequent_Itemsets\\gene_dictionary_ID.txt", help="Absolute path of the file with the genes and proteins dictionary")
        p.add_option("--stopDictionary", "-p", dest="stopWordsFileNameNB", default="F:\\@_Lorenzo\\@_Tesi\\@_Framework_Parts\\Dictionary_and_Stopwords\\stopWords.txt", help="Absolute path of the file with the stopwords dictionary")        
	p.add_option("--transaction", dest="transFileNameNB", default="F:\\Transaction\\transaction.txt", help="Absolute path of the file with the transactions")
        p.add_option("--statistics", "-t", dest="statFileNameNB", default="Text_Statistics.txt", help="Absolute path of the file where the final statistics are stored")
	p.add_option("--gnFoundFileName", dest="gnFoundFileNameNB", default="DocGenes.txt", help="Absolute path of the file where all the files wih genes (and the corresponding number of genes) are stored")
        p.add_option("--suffix", "-n", dest="suffixNB", default="cleaned", help="Suffix to be added to the processed article name")
        p.add_option("--copyArticles", dest="copyArticles", default="copy", help="Says whether to copy the articles with keywords in a specified directory")
	p.add_option("--alfa", dest="alfa", default="2.0", help="Value of the alfa parameter of the grading function")
	p.add_option("--beta", dest="beta", default="0.1", help="Value of the beta parameter of the grading function")
	p.add_option("--gamma", dest="gamma", default="0.1", help="Value of the gamma parameter of the grading function")
        p.add_option("--linux", "-l", dest="linuxOrNot", default="", help="If not set -> working under Windows; if set to linux working under Linux")
        
        option, arguments = p.parse_args()

        if option.linuxOrNot == "linux" :
                dirname = option.dirnameNB.replace('%20', ' ')
		dirname = dirname.replace("F:\\", "/media/DATI/")
		dirname = dirname.replace('\\', '/')
		destDirname = option.destDirnameNB.replace('%20', ' ')
		destDirname = destDirname.replace("F:\\", "/media/DATI/")
		destDirname = destDirname.replace('\\', '/')
		copyDirname = option.copyDirnameNB.replace('%20', ' ')
		copyDirname = copyDirname.replace("F:\\", "/media/DATI/")
		copyDirname = copyDirname.replace('\\', '/')
		dictionaryFileName = option.dictionaryFileNameNB.replace('%20', ' ')
		dictionaryFileName = dictionaryFileName.replace("F:\\", "/media/DATI/")
		dictionaryFileName = dictionaryFileName.replace('\\', '/')		
		transFileName = option.transFileNameNB.replace('%20', ' ')
		transFileName = transFileName.replace("F:\\", "/media/DATI/")
		transFileName = transFileName.replace('\\', '/')		
		suffix = option.suffixNB.replace('%20', ' ')
		stopWordsFileName = option.stopWordsFileNameNB.replace('%20', ' ')
		stopWordsFileName = stopWordsFileName.replace("F:\\", "/media/DATI/")
		stopWordsFileName = stopWordsFileName.replace('\\', '/')
		statisticsFileName = option.statFileNameNB.replace('%20', ' ')		
		gnFoundFileName = option.gnFoundFileNameNB.replace('%20', ' ')		
		
	else :
                dirname = option.dirnameNB.replace('%20', ' ')
		destDirname = option.destDirnameNB.replace('%20', ' ')
		copyDirname = option.copyDirnameNB.replace('%20', ' ')		
		dictionaryFileName = option.dictionaryFileNameNB.replace('%20', ' ')
		suffix = option.suffixNB.replace('%20', ' ')
		stopWordsFileName = option.stopWordsFileNameNB.replace('%20', ' ')
        	statisticsFileName = option.statFileNameNB.replace('%20', ' ')
		gnFoundFileName = option.gnFoundFileNameNB.replace('%20', ' ')		
        	
        
        outputDirName = destDirname + os.sep
        if (os.path.exists(outputDirName)) :
                print "The specified output directory already exists: can't over-write. Returning"
                return
        else :
                os.mkdir(outputDirName)

        print 
        print "PHASE 1 TEXTS CLEANING"
        print

        print " --- List of the processed files --- "
        print
        i = 1
        counterDocKeywords = 0
        for fileName in os.listdir(dirname) :
                
                # Absolute path and name of the source file
                source = os.path.normpath(dirname+os.sep+fileName)
                # Absolute path and name of the destination file
                ext = os.path.splitext( fileName )
                dest = outputDirName + ext[0].replace(' ','_') + "_" + suffix +".txt"
                dest = os.path.normpath(dest)
                
                #print str(i)+ ")"
                #print "Source: " + source
                #print "Destination: " + dest
                i += 1
                k = 0
                k = parserFunction(source,dest)
                if k == 1 :
                      counterDocKeywords+=1
                      if option.copyArticles == "copy" :
                              copyDest = os.path.normpath(copyDirname+os.sep+fileName)
                              shutil.copy(source,copyDest)
                
        print i-1, "texts cleaned"
        print counterDocKeywords, "documents have the keywords"

        print 
        print "PHASE 1 COMPLETED: TEXTS CLEANED"
        print

        print 
        print "PHASE 2: ADDING WEIGTHS"
        print

        sourceDirectory = os.path.normpath(outputDirName)
        vocabulary = os.path.normpath(dictionaryFileName)
        stopWord = os.path.normpath(stopWordsFileName)
	transaction = os.path.normpath(transFileName)
        statistics = os.path.normpath(outputDirName + os.sep + statisticsFileName)
	gnFoundFile = os.path.normpath(outputDirName + os.sep + gnFoundFileName)
        weightsAdding(sourceDirectory,vocabulary,stopWord, statistics, gnFoundFile, transaction) 

        print 
        print "PHASE 2 COMPLETED"
        print
        
        return


def parserFunction(sourceFile,destFile):
        
        tree = ElementTree()
        found_title = 0
        try:
            tree.parse(sourceFile)
        except Exception, inst:
            print "Unexpected error opening %s: %s" % (sourceFile, inst)
            return

        f = open (destFile, mode='w')

        f.write ("<article>\n")
        keywordDict ={}
        i = 0
        numAbstract = 0

        frontElement = tree.find("front")

        if frontElement :

                frontIterator = frontElement.getiterator()
                for frontSubElement in frontIterator:
                        #Text that precedes all child elements (may be None)
                        #if frontSubElement.tag == "title-group" or frontSubElement.tag == "article-categories" or frontSubElement.tag == "abstract" or frontSubElement.tag == "kwd-group":
                        if frontSubElement.tag == "title-group" or frontSubElement.tag == "abstract" or frontSubElement.tag == "kwd-group":
                                if frontSubElement.tag == "title-group" :
                                        f.write("\n<title>\n")
                                if frontSubElement.tag == "abstract" and numAbstract == 0:
                                        numAbstract = 1
                                        f.write("\n<abstract>\n")
                                        
                                if frontSubElement.text:
                                        # if frontSubElement.tag == "article-categories"
                                        if frontSubElement.tag == "kwd-group":                                
						keywordDict[frontSubElement.text.encode('ascii','ignore')] = ''
                                                #keywordDict[frontSubElement.text.encode('latin-1', 'ignore')] = ''
                                        else :
						entireText = frontSubElement.text.encode('ascii','ignore')
                                                #entireText = frontSubElement.text.encode('latin-1', 'ignore')
                                                i = formattedPrint(entireText,f,i)
                                                
                                recursivePrint(frontSubElement, f, keywordDict, i)
                                
                                if frontSubElement.tag == "title-group" :
                                        f.write(".\n</title>\n")

                if numAbstract != 0 :
                        f.write(".\n</abstract>\n")
##        else :
##                f.write ("\n--------No front-----------\n")

        
        f.write("\n<body>\n")       
        bodyElement = tree.find("body")
        if bodyElement :

                bodyIterator = bodyElement.getiterator()
                for bodySubElement in bodyIterator:
                        
                        #Text that precedes all child elements (may be None)
                        if bodySubElement.tag == "title" or bodySubElement.tag == "p" :
                                if bodySubElement.tag == "title" :
                                                i =0
                                                f.write("\n")                      
                                if bodySubElement.text:
                                        
					entireText = bodySubElement.text.encode('ascii','ignore')
                                        #entireText = bodySubElement.text.encode('latin-1', 'ignore')
                                        i = formattedPrint(entireText,f,i)
                                
                                recursivePrint(bodySubElement, f, keywordDict, i)
                                if bodySubElement.tag == "title" :
                                                i = 0
                                                f.write("\n")                        
                                #f.write("\n")
##        else :                
##                f.write ("\n--------No Body-----------\n")                        
        f.write(".\n</body>\n")

  
        backElement = tree.find("back")
        #print backElement.tag
        if backElement :
                backIterator = backElement.getiterator()
                for backSubElement in backIterator:
                        #Text that precedes all child elements (may be None)
                        if backSubElement.tag == "glossary" :                        
                                if backSubElement.text:
                                        entireText = backSubElement.text.encode('ascii','ignore')
                                        #entireText = backSubElement.text.encode('latin-1', 'ignore')
                                        i = formattedPrint(entireText,f,i)
                                        
                                recursivePrint(backSubElement, f, keywordDict,i)
                                #f.write("\n")
##        else :
##                f.write ("\n--------No Back-----------\n")                        
                        
        f.write("\n<keywords>\n")
        i = 0
        for kwd in keywordDict.keys():
                i += 1
                f.write(kwd +"\n")                
        f.write("\n</keywords>\n")
        keywords = 0
        if i >0 :
                keywords = 1
        else :
                keywords = 0
        f.close()
        return keywords

def recursivePrint(elemento, f, keywordDict, i) :
        if elemento.getchildren():
                #Can also use: "for child in element.getchildren():"
                for child in elemento:
                        if child.tag != "math" and child.tag != "table":
                                
                                if child.tag == "title" :
                                        f.write("\n")
                                        i = 0
                                if child.text :
                                        #if elemento.tag == "article-categories" or child.tag == "subject" or child.tag == "term" or
                                        if elemento.tag == "kwd" or child.tag == "kwd":  
                                                keywordDict[child.text.encode('ascii','ignore')] = ''                                              
                                                #keywordDict[child.text.encode('latin-1', 'ignore')] = ''
                                        else :
						entireText = child.text.encode('ascii','ignore')
                                                #entireText = child.text.encode('latin-1', 'ignore')
                                                i = formattedPrint(entireText,f,i)
                                                
                                #The "tail" on each child element consists of the text
                                #that comes after it in the parent element content, but
                                #before its next sibling.
                                if child.tail:
					entireText = child.tail.encode('ascii','ignore')
                                        #entireText = child.tail.encode('latin-1', 'ignore')
                                        i = formattedPrint(entireText,f,i)                                        
                                        
                                if child.tag == "title" :
                                        i = 0
                                        f.write(".\n")
                                #print "Call rec I'm " + child.tag
                                recursivePrint(child,f, keywordDict, i)
                                
                        else :
                                if child.tail:
					entireText = child.tail.encode('ascii','ignore')
                                        #entireText = child.tail.encode('latin-1', 'ignore')
                                        i = formattedPrint(entireText,f,i)
        return

def formattedPrint(entireText,f,i):
        tot = i
        for word in entireText.strip().split() :
                tot += len(word)+1
                if (tot <= 80) :
                        f.write(word+" ")                                                                
                else :
                        tot =   len(word)+1
                        f.write("\n"+word+" ")
        return tot

def weightsAdding(sourceDirectory,vocabulary, stopWord, statistics, gnFoundFile, transaction):

        print 
        print "PHASE 2.1: Filling the vocabulary"
        print

        f = open (stopWord, mode='r')
        

        stopDict ={}
        
        for line in f :
                words = line.strip()
                stopDict[words] = ''

        f.close()
        
        f = open (vocabulary, mode='r')
        

        geneDict ={}
        
        for line in f :
                words = line.strip().split()
		word = words[1]
		#print word
		value = words[0]
                if ( (word.strip().isdigit() == False) and (stopDict.has_key(word.strip()) == 0) and (word[0].isdigit() == False) and (word[0] != '#') and (word[0] != '-')) :
                        geneDict[word.strip()] = value
			#print word.strip() +" "+ geneDict[word.strip()]
                

        f.close()

        print 
        print "PHASE 2.1 ENDED: vocabulary filled"
        print

        print 
        print "PHASE 2.2: adding the weights to each file"
        print

        foundGenes = {}
		
	noBreakList = {}
	noBreakList["U.S."]=''
	noBreakList["[U.S."]=''
	noBreakList["(U.S."]=''	
	noBreakList["St."]=''	
	noBreakList["[St."]=''	
	noBreakList["(St."]=''	
	noBreakList["-St."]=''	
	noBreakList["Rush-Presbyterian-St."]=''		
	noBreakList["Dr."]=''	
	noBreakList["[Dr."]=''	
	noBreakList["(Dr."]=''	
	noBreakList["r.p.m."]=''		
	noBreakList["(r.p.m."]=''		
	noBreakList["[r.p.m."]=''		
	noBreakList["p.p.m."]=''		
	noBreakList["(p.p.m."]=''		
	noBreakList["[p.p.m."]=''		
	noBreakList["Jan."]=''	
	noBreakList["[Jan."]=''	
	noBreakList["(Jan."]=''	
	noBreakList["Feb."]=''
	noBreakList["(Feb."]=''
	noBreakList["[Feb."]=''
	noBreakList["Mar."]=''
	noBreakList["(Mar."]=''
	noBreakList["[Mar."]=''
	#noBreakList["April."]=''	
	noBreakList["May."]=''	
	noBreakList["(May."]=''	
	noBreakList["[May."]=''	
	noBreakList["Jun."]=''
	noBreakList["(Jun."]=''
	noBreakList["[Jun."]=''
	noBreakList["C-Jun."]=''
	noBreakList["c-Jun."]=''
	noBreakList["Jul."]=''
	noBreakList["(Jul."]=''
	noBreakList["[Jul."]=''
	noBreakList["Aug."]=''
	noBreakList["[Aug."]=''
	noBreakList["(Aug."]=''
	#noBreakList["September."]=''
	noBreakList["Oct."]=''
	noBreakList["[Oct."]=''
	noBreakList["(Oct."]=''
	noBreakList["Nov."]=''	
	noBreakList["[Nov."]=''	
	noBreakList["(Nov."]=''	
	noBreakList["Dec."]=''	
	noBreakList["[Dec."]=''
	noBreakList["(Dec."]=''		
	noBreakList["a.m."]=''		
	noBreakList["(a.m."]=''		
	noBreakList["[a.m."]=''		
	noBreakList["p.m."]=''		
	noBreakList["(p.m."]=''		
	noBreakList["[p.m."]=''			
	noBreakList["Mrs."]=''		
	noBreakList["(Mrs."]=''		
	noBreakList["[Mrs."]=''
	noBreakList["Rep."]=''					
	noBreakList["'Rep."]=''					
	noBreakList["(Rep."]=''					
	noBreakList["('Rep."]=''					
	noBreakList["[Rep."]=''					
	noBreakList["c.p.m."]=''						
	noBreakList["(c.p.m."]=''						
	noBreakList["[c.p.m."]=''						
	noBreakList["C.p.m."]=''						
	noBreakList["(C.p.m."]=''						
	noBreakList["[C.p.m."]=''						
	noBreakList["stimulation/C.p.m."]=''						

        grandTotal = 0
        fgenes = open (gnFoundFile, mode='w')
        for fileName in os.listdir(sourceDirectory) :
		itemsets = {}
                
                # Absolute path and name of the source file
                source = os.path.normpath(sourceDirectory+os.sep+fileName)                
                weights = [[],[],[]]

		# Splitting in sentences, counting the number of genes for each sentence, and giving 
		# weigths to each sentence (1.0 if no genes, 2.0 + (0.1 * num of genes) if genes are found)
		gnCount = 0
                gnCount = geneCounter(source,weights,geneDict, foundGenes, noBreakList, itemsets)
                if (gnCount > 0) :
			fgenes.write( source+" "+str(gnCount)+ "\n")	# Recording all files with genes in a file		
                grandTotal += gnCount
		
		# Modifiy the source file by adding the xml tags related to the weights
                f = open (source, mode='a')
                f.write ("\n<weights>\n")
                for i in range(0,len(weights)) :
                        if i == 0 :
                                if (len(weights[i]) != 0) :
                                        f.write ("\n<TitleWeights>\n")
                                        for item in weights[i] :
                                                f.write (str(item)+" ")                                
                                        f.write ("\n</TitleWeights>\n")
                        if i == 1 :
                                if (len(weights[i]) != 0) :
                                        f.write ("\n<AbstractWeights>\n")
                                        for item in weights[i] :
                                                f.write (str(item)+" ")                                
                                        f.write ("\n</AbstractWeights>\n")
                        if i == 2 :
                                if (len(weights[i]) != 0) :
                                        f.write ("\n<BodyWeights>\n")                                        
                                        for item in weights[i] :
                                                f.write (str(item)+" ")
                                        f.write ("\n</BodyWeights>\n")
                                
                f.write ("\n</weights>\n")                
                f.write ("\n</article>\n")                
                f.close()

		ft = open(transaction, 'a')
		printItemsets(itemsets, ft)
		ft.close()

	fgenes.close()

        print 
        print "PHASE 2.2 ENDED: weights added to each file"
        print

        print 
        print "PHASE 2.3: writing the statistics file"
        print

        f = open (statistics, mode='w')
        counter = 0
        frequentGenes = {}	
        for entry in foundGenes.keys():
                if foundGenes[entry] >= 10 :
                        ##f.write(entry +"    "+str(foundGenes[entry])+" FREQUENT\n")
                        frequentGenes[entry] = foundGenes[entry]                        
                else :
                        f.write(entry +"    "+str(foundGenes[entry])+"\n")
                counter+=1

        f.write("\n ----- FREQUENT GENES (more than 10 matches) -----\n")
        for entry in frequentGenes.keys():
                f.write(entry +"    "+str(foundGenes[entry])+"\n")

        f.write("\n\n ----- FINAL STATISTICS -----\n\n")
        f.write(" - Number of distinct entries (genes) found in the texts: "+str(counter) +"\n")
        f.write(" - Grand Total (total number of occurrences): "+str(grandTotal) +"\n")

        
        f.close()

        print 
        print "PHASE 2.3 ENDED: statistics file written"
        print
                
        return

def geneCounter (source,weights,geneDict,foundGenes, noBreakList, itemsets) :
        f = open (source, mode='r')
	#fw = open (source+"DEBUGDEBUG", mode='w')
        #print source
        t = 0
        a = 0
        b = 0
        geneNumber = 0
        totCounter = 0
        sentenceEnd = 0
        for line in f :
                if line.strip() == "<title>" :
                        title = []
                        t = 1
                        continue
                if line.strip() == "</title>" :
                        if sentenceEnd != 1 :
                                title.append(giveScore(geneNumber))
				#fw.write("<spanAdded>")
                                geneNumber = 0                                
                        weights[0]=title
                        sentenceEnd = 0
                        t = 0
                        continue
                if line.strip() == "<body>" :
                        body = []
                        b = 1
                        continue
                if line.strip() == "</body>" :
                        if sentenceEnd != 1 :
                                body.append(giveScore(geneNumber))
				#fw.write("<spanAdded>")
                                geneNumber = 0
                        weights[2]=body
                        sentenceEnd = 0
                        b = 0
                        continue
                if line.strip() == "<abstract>" :
                        abstract = []
                        a = 1
                        continue
                if line.strip() == "</abstract>" :
                        if sentenceEnd != 1 :
				#fw.write("<spanAdded>")
                                abstract.append(giveScore(geneNumber))
                                geneNumber = 0
                        weights[1]=abstract
                        sentenceEnd = 0
                        a = 0
                        continue
                
                if t == 1 :
                        for word in line.strip().split() :
				#fw.write(word+" ")				
                                if ( (noBreakList.has_key(word) == False) and (word.endswith("!") or word.endswith("?") or word.endswith(";") or word.endswith(".") or word.endswith("|") or word.endswith("?\"") or word.endswith("!\"") or word.endswith(".\"") ) ):
					if ( geneOrNot(geneDict,word, itemsets) == 1 ) :
                                                geneStatistics (word[:-1], foundGenes)
                                                totCounter += 1
                                                geneNumber+=1
					#fw.write("<span>\n")
                                        title.append(giveScore(geneNumber))
                                        geneNumber = 0
                                        sentenceEnd = 1
                                else :
                                        word = word.replace('(','')
                                        word = word.replace(')','')
                                        sentenceEnd = 0
                                        if ( geneOrNot(geneDict,word, itemsets) == 1 ) :
                                                geneNumber+=1
                                                geneStatistics (word, foundGenes)
                                                totCounter += 1
			#fw.write("\n")
                                                
                if a == 1 :
                        for word in line.strip().split() :
				#fw.write(word+" ")
                                if ( (noBreakList.has_key(word) == False) and (word.endswith("!") or word.endswith("?") or word.endswith(";") or word.endswith(".") or word.endswith("|") or word.endswith("?\"") or word.endswith("!\"") or word.endswith(".\"") ) ):                                
                                        if ( geneOrNot(geneDict,word, itemsets) == 1 ) :
                                                geneNumber+=1
                                                geneStatistics (word[:-1], foundGenes)
                                                totCounter += 1
					#fw.write("<span>\n")
                                        abstract.append(giveScore(geneNumber))
                                        geneNumber = 0
                                        sentenceEnd = 1
                                else :
                                        word = word.replace('(','')
                                        word = word.replace(')','')
                                        sentenceEnd = 0
                                        if ( geneOrNot(geneDict,word, itemsets) == 1 ) :
                                                geneNumber+=1                                                
                                                geneStatistics (word, foundGenes)
                                                totCounter += 1
			#fw.write("\n")
                                                
                if b == 1 :
                        for word in line.strip().split() :
				#fw.write(word+" ")
				if ( (noBreakList.has_key(word) == False) and (word.endswith("!") or word.endswith("?") or word.endswith(";") or word.endswith(".") or word.endswith("|") or word.endswith("?\"") or word.endswith("!\"") or word.endswith(".\"") ) ):
					if ( geneOrNot(geneDict,word, itemsets) == 1 ) :
                                                geneStatistics (word[:-1], foundGenes)
                                                totCounter += 1
                                                geneNumber+=1                                                
					#fw.write("<span>\n")
                                        body.append(giveScore(geneNumber))
                                        geneNumber = 0
                                        sentenceEnd = 1
                                else :
                                        word = word.replace('(','')
                                        word = word.replace(')','')
                                        sentenceEnd = 0           
                                        if ( geneOrNot(geneDict,word, itemsets) == 1 ) :
                                                geneStatistics (word, foundGenes)
                                                totCounter += 1
                                                geneNumber+=1                      
			#fw.write("\n")

        f.close()        
	#fw.close()
        return totCounter 

def giveScore(geneNumber):
        
        if geneNumber == 0:
                score = 1.0
        else :
                score = 2.0 + ((geneNumber-1)*0.1)
                
        return score

def printItemsets(itemsets, ft) :

 	itlist = []
	for entry in itemsets.keys():
                itlist.append(entry)

	itlist.sort()	
		
	for i in range(0, len(itlist)) :
		ft.write (itlist[i] + " ")
	if (len(itlist) != 0) :
		ft.write("\n")	
	return



def geneStatistics (word, foundGenes) :        
        if foundGenes.has_key(word) :
                foundGenes[word]+=1
        else :
                foundGenes[word] = 1
        return

def geneOrNot (geneDict,word,itemsets):

	if ( geneDict.has_key(word) ) :
		val = geneDict[word]
		itemsets[val] = ''
		return 1

	if ( word.endswith("!") or word.endswith("?") or word.endswith(";") or word.endswith(".") or word.endswith("|")  ):
		if (geneDict.has_key(word[:-1]) ) :
			val = geneDict[word[:-1]]
			itemsets[val] = ''
			return 1
	if ( word.endswith("?\"") or word.endswith("!\"") or word.endswith(".\"") or word.endswith("?)") or word.endswith("!)") or word.endswith(".)") or word.endswith(")?") or word.endswith(")!") or word.endswith(").") or word.endswith(");") or word.endswith("):") or word.endswith(")-") ):
		if (geneDict.has_key(word[:-2]) ) :
			val = geneDict[word[:-2]]
			itemsets[val] = ''
			return 1
	if ( word.startswith("!") or word.startswith("?") or word.startswith(";") or word.startswith(".") or word.startswith("|")  ):
		if (geneDict.has_key(word[1:]) ) :
			val = geneDict[word[1:]]
			itemsets[val] = ''
			return 1
	if ( word.startswith("?\"") or word.startswith("!\"") or word.startswith(".\"") or word.startswith("?)") or word.startswith("!)") or word.startswith(".)") or word.startswith(")?") or word.startswith(")!") or word.startswith(").") or word.startswith(");") or word.startswith("):") or word.startswith(")-") ) :
		if (geneDict.has_key(word[2:]) ) :
			val = geneDict[word[2:]]
			itemsets[val] = ''
			return 1
	return 0
                

if __name__ == "__main__":
	# Someone is launching this directly
	main()
