#!/usr/bin/python
from optparse import OptionParser
import tempfile, os, numpy, operator
import time
import shutil
from subprocess import *
from numpy import *
from pylab import *
from matplotlib.lines import Line2D

# main
def main():

        p = OptionParser()
 
        p.add_option("--programPath", "-p",   dest="absolutePathW",            default="F:\\@_Lorenzo\\@_Tesi\\@_Framework_Parts\\Framework.py", help="Absolute path of the directory pieces of the framework are stored")
	p.add_option("--runCleaner",            dest="runCleaner",              default="N", help="If not set -> don't run XML_Text_Cleaner.py; if set to 'Y' run it")
        p.add_option("--runSelector",           dest="runSelector",             default="N", help="If not set -> don't run Text_Selector.py; if set to 'Y' run it")
        p.add_option("--runRapidminer",         dest="runRapidminer",           default="N", help="If not set -> don't run rapidminer; if set to 'Y' run it")
        p.add_option("--runCopier",             dest="runCopier",               default="Y", help="If not set -> don't run Text_Copier.py; if set to 'Y' run it")
        p.add_option("--RMManager",             dest="RMManager",               default="Y", help="If not set -> what in srcDirName\Intermediated\ will be used; if set to 'copy' what in destDirName will be used by cluto; if set to 'N' nothing will be done")
        p.add_option("--runCluto",              dest="runCluto",                default="Y", help="If not set -> don't run Cluto; if set to 'Y' run it")
        p.add_option("--runOrganizer",          dest="runOrganizer",            default="Y", help="If not set -> don't run Result_organizer.py; if set to 'Y' run it")
        p.add_option("--runSummarizer",         dest="runSummarizer",           default="Y", help="If not set -> don't run Summarizer.py; if set to 'Y' run it")
	p.add_option('--ratio',			dest="ratio",			default="52", help="Maximum ratio of the original text included in summarization")
	p.add_option('--stride',		dest="stride",			default="4", help="Step: if 10 -> n = 10, 20, 30, 40")
	p.add_option('--lowratio',		dest="lowratio",		default="4", help="Starting point")	
	p.add_option('--title',			dest="title",			default="Summarization Ratio Impact")
	p.add_option("--linux",                 dest="linuxOrNot",              default="linux", help="If not set -> working under Windows; if set to linux working under Linux")

        option, arguments = p.parse_args()	

	if option.linuxOrNot == "linux" :
		absolutePath = option.absolutePathW.replace("F:\\", "/media/DATI/")
		absolutePath = absolutePath.replace('\\', '/')
		
	else :
		absolutePath = option.absolutePathW

	lowratio = int(option.lowratio)
	ratio = int(option.ratio)
	stride = int(option.stride)

	time_bioinfo = []
	time_BC = []
	time_art_kwd = []
	time_CRI = []	
	summ_percentage = []

	header = "T_Cleaner\tINC_to_Cleaner\tT_Selector\tINC_to_Selector\tT_Copier\tINC_to_Copier\tT_RM\tINC_to_RM\tT_Pre_Cluto\tINC_to_Pre_Cluto\t T_RMMan\tINC_to_RMMan\tT_Cluto\tINC_to_Cluto\tT_Res_Org\tINC_to_Res_Org\tT_Summ\tTotal_Time\n"
	fp = open ("/media/DATI/Performances_BIO.txt", mode='w')
	fp.write(header+"\n")
	fp.close()
	fp = open ("/media/DATI/Performances_BC.txt", mode='w')
	fp.write(header+"\n")
	fp.close()
	fp = open ("/media/DATI/Performances_KWD.txt", mode='w')
	fp.write(header+"\n")
	fp.close()
	fp = open ("/media/DATI/Performances_CRIT.txt", mode='w')
	fp.write(header+"\n")
	fp.close()
	
	argsBIO = "-c /media/DATI/Cleaned_Texts_BIO/ -s /media/DATI/Text_Selection_BIO_ABBD/ -d /media/DATI/Experimental_Results_BIO/ --perfFileName /media/DATI/Performances_BIO.txt --cluPerFileName /media/DATI/Cluster_BIO.txt --summPerFileName /media/DATI/Summ_BIO.txt --clusterNumber 15 "
	argsBC = "-c /media/DATI/Cleaned_Texts_BC/ -s /media/DATI/Text_Selection_BC_ABBD/ -d /media/DATI/Experimental_Results_BC/ --perfFileName /media/DATI/Performances_BC.txt --cluPerFileName /media/DATI/Cluster_BC.txt --summPerFileName /media/DATI/Summ_BC.txt --clusterNumber 45 "
	argsKWD = "-c /media/DATI/Cleaned_Texts_KWD/ -s /media/DATI/Text_Selection_KWD_ABBD/ -d /media/DATI/Experimental_Results_KWD/ --perfFileName /media/DATI/Performances_KWD.txt --cluPerFileName /media/DATI/Cluster_KWD.txt --summPerFileName /media/DATI/Summ_KWD.txt --clusterNumber 90 "
	argsCRI = "-c /media/DATI/Cleaned_Texts_CRIT/ -s /media/DATI/Text_Selection_CRIT_ABBD/ -d /media/DATI/Experimental_Results_CRIT/ --perfFileName /media/DATI/Performances_CRIT.txt --cluPerFileName /media/DATI/Cluster_CRIT.txt --summPerFileName /media/DATI/Summ_CRIT.txt --clusterNumber 140 "
	argsCommon = "--runCleaner "+ option.runCleaner +" --runSelector "+option.runSelector+" --runRapidminer "+ option.runRapidminer+" --runCopier "+option.runCopier +" --RMManager "+option.RMManager+" --runCluto "+option.runCluto+" --runOrganizer "+option.runOrganizer+" --runSummarizer "+option.runSummarizer		

	for i in range(lowratio, ratio+1, stride) :		
		# Run the framework for Bioinformation
		str_time_bioinfo = time.time()
		run_framework (absolutePath, argsBIO+" "+argsCommon, i)
		end_time_bioinfo = time.time()
		# Run the framework for Breast Cancer
		str_time_bc = time.time()
		run_framework (absolutePath, argsBC+" "+argsCommon, i)
		end_time_bc = time.time()
		# Run the framework for the articles with keywords
		str_time_art_kwd = time.time()
		run_framework (absolutePath, argsKWD+" "+argsCommon, i)
		end_time_art_kwd = time.time()		
		# Run the framework for Crit Care
		str_time_CRI = time.time()
		run_framework (absolutePath, argsCRI+" "+argsCommon, i)
		end_time_CRI = time.time()					
		
		# Update the time lists with the results of the above runs
		time_bioinfo.append(end_time_bioinfo-str_time_bioinfo)		
		time_BC.append(end_time_bc-str_time_bc)		
		time_art_kwd.append(end_time_art_kwd-str_time_art_kwd)		
		time_CRI.append(end_time_CRI-str_time_CRI)
		summ_percentage.append(i)

		remove_data("/media/DATI/Experimental_Results_BIO_1/", "/media/DATI/Experimental_Results_BC_1/", "/media/DATI/Experimental_Results_KWD_1/", "/media/DATI/Experimental_Results_CRIT_1/")	

	f = open ("/media/DATI/Execution_Results.txt", mode='w')
	f.write ("Summariz_Percentage\tBioinformatics\tBreast_Cancer\tArticles_Keyword\tCrit_care\n")
	k = 0
	for i in range(lowratio, ratio+1, stride) :				
		f.write (str(summ_percentage[k])+"\t"+ str(time_bioinfo[k])+ "\t"+ str(time_BC[k])+ "\t"+ str(time_art_kwd[k]) + "\t"+str(time_CRI[k])+ "\n")
		k += 1
	f.close()

	plotting(summ_percentage, time_bioinfo, time_BC, time_art_kwd, time_CRI, option.title)	

	return

# Run the Framework
def run_framework (path_absolute, arguments, summariz_percentage):

	args = " "+ arguments +  " --ratio " + str(summariz_percentage) + " >> FRAM_TMP_PERF.txt "
	try:
		print "Run ", path_absolute + args
		print 
		p = Popen("python2.5 "+ path_absolute + args , shell=True)
		p.wait()
		if p.returncode != 0:
                                print " --- Framework : Abnormal termination (code ", p.returncode, ") ---"
				os._exit(1)
		else:
			print "Framework returned", p.returncode

	except OSError, e:
		print "Execution failed:", e
	
	return

# Plotting function for silhouete values
def plotting (s, t_b, t_bc, t_k, t_c, plot_title):
	plot (s, t_b, 'r')
	plot (s, t_bc, 'k')
	plot (s, t_k, 'b')
	plot (s, t_c, 'g')
	line1 = Line2D(range(10), range(10), linestyle='-', color='r')
	line2 = Line2D(range(10), range(10), linestyle='-', color='k')
	line3 = Line2D(range(10), range(10), linestyle='-', color='b')	
	line4 = Line2D(range(10), range(10), linestyle='-', color='g')
	legend((line1,line2,line3,line4), ('Bioinformation','Breast_Cancer','Articles with Keywords','Crit Care'), loc=0)
	title(plot_title)
	xlabel('Summarization Percentage')
	ylabel('Time [s]')
	#axis ([0,max(s)+1])
	show()
	return

# Remove tmp files
def remove_data(bio, bc, kwd, crit):
	print 
	print "--- Run over "
	shutil.rmtree(bio)
	print "Removed ", bio
	shutil.rmtree(bc)
	print "Removed ", bc
	shutil.rmtree(kwd)
	print "Removed ", kwd
	shutil.rmtree(crit)
	print "Removed ", crit
	print 
	return 

if __name__ == '__main__':
	main()
