#!/usr/bin/python
from optparse import OptionParser
import tempfile, os, numpy, operator
import time
import shutil
import math
import random
from subprocess import *
from numpy import *
from pylab import *
from matplotlib.lines import Line2D

# main
def main():
	# Measures the performances of clustering by changing the number of clusters. It uses a fixed number of documents all belonging to the same 
	# collection
        p = OptionParser()
 
        p.add_option("--programPath", "-p",	dest="absolutePathW",            default="F:\\@_Lorenzo\\@_Tesi\\@_Framework_Parts\\Framework.py", help="Absolute path of the directory pieces of the framework are stored")
	p.add_option("--runCleaner",            dest="runCleaner",              default="N", help="If not set -> don't run XML_Text_Cleaner.py; if set to 'Y' run it")
        p.add_option("--runSelector",           dest="runSelector",             default="N", help="If not set -> don't run Text_Selector.py; if set to 'Y' run it")
        p.add_option("--runRapidminer",         dest="runRapidminer",           default="N", help="If not set -> don't run rapidminer; if set to 'Y' run it")
        p.add_option("--runCopier",             dest="runCopier",               default="Y", help="If not set -> don't run Text_Copier.py; if set to 'Y' run it")
        p.add_option("--RMManager",             dest="RMManager",               default="Y", help="If not set -> what in srcDirName\Intermediated\ will be used; if set to 'copy' what in destDirName will be used by cluto; if set to 'N' nothing will be done")
        p.add_option("--runCluto",              dest="runCluto",                default="Y", help="If not set -> don't run Cluto; if set to 'Y' run it")
        p.add_option("--runOrganizer",          dest="runOrganizer",            default="Y", help="If not set -> don't run Result_organizer.py; if set to 'Y' run it")
        p.add_option("--runSummarizer",         dest="runSummarizer",           default="N", help="If not set -> don't run Summarizer.py; if set to 'Y' run it")
	p.add_option('--maximum',		dest="maxDoc",			default="1000", help="Maximum number of documents to cluster")
	p.add_option('--nCluster',		dest="nCluster",		default="220", help="Maximum number of clusters")
	p.add_option('--stride',		dest="stride",			default="10", help="Step: if 10 -> n = 10, 20, 30, 40")
	p.add_option('--lownCluster',		dest="lownCluster",		default="10", help="Starting point")	
	p.add_option('--seed',			dest="seedForRun",		default="50019589", help="Seed for the random number generator")
	p.add_option('--title',			dest="title",			default="Clustering performances")
	p.add_option("--linux",                 dest="linuxOrNot",              default="linux", help="If not set -> working under Windows; if set to linux working under Linux")

        option, arguments = p.parse_args()	

	if option.linuxOrNot == "linux" :
		absolutePath = option.absolutePathW.replace("F:\\", "/media/DATI/")
		absolutePath = absolutePath.replace('\\', '/')		
	else :
		absolutePath = option.absolutePathW

	maxDoc = int(option.maxDoc)
	seedForRun = long(option.seedForRun)
	seed(50019589)

	lownCluster = int(option.lownCluster)
	nCluster = int(option.nCluster)
	stride = int(option.stride)

	docCounter = 0
	while docCounter < maxDoc :
		for fileName in os.listdir("/media/DATI/pubmed/Crit Care_Source/") :
			p = random()
			if (p >= 0.5):
				if docCounter < maxDoc:
					filePath = os.path.normpath("/media/DATI/pubmed/Crit Care_Source/"+fileName)				
					filePathDest = os.path.normpath("/media/DATI/pubmed/Crit Care/"+fileName)				
					shutil.move(filePath, filePathDest)					
					docCounter += 1
					if (docCounter == maxDoc):
						break
				else :
					break
	print docCounter, " Documents selected"

	argsCRI = "-c /media/DATI/Cleaned_Texts_CRIT_"+str(seedForRun)+"/ -s /media/DATI/Text_Selection_CRIT_"+str(seedForRun)+"_ABBD/ -d /media/DATI/Experimental_Results_CRIT_"+str(seedForRun)+"/"
	argsCommon = "--runCleaner Y --runSelector Y --runRapidminer Y --runCopier Y --RMManager copy --runCluto N --runOrganizer N --runSummarizer N"
	run_framework (absolutePath, argsCRI+" "+argsCommon, -1)
	print " ****Preliminary run done**** "

	header = "T_Cleaner\tINC_to_Cleaner\tT_Selector\tINC_to_Selector\tT_Copier\tINC_to_Copier\tT_RM\tINC_to_RM\tT_Pre_Cluto\tINC_to_Pre_Cluto\t T_RMMan\tINC_to_RMMan\tT_Cluto\tINC_to_Cluto\tT_Res_Org\tINC_to_Res_Org\tT_Summ\tT_INC_to_Summ\tT_Sort\tTotal_Time\n"
	fp = open ("/media/DATI/Performances_CRIT_"+str(seedForRun)+".txt", mode='w')
	fp.write(header+"\n")
	fp.close()
	
	argsCRI = "-c /media/DATI/Cleaned_Texts_CRIT_"+str(seedForRun)+"/ -s /media/DATI/Text_Selection_CRIT_"+str(seedForRun)+"_ABBD/ -d /media/DATI/Experimental_Results_CRIT_"+str(seedForRun)+"/ --perfFileName /media/DATI/Performances_CRIT_"+str(seedForRun)+".txt --cluPerFileName /media/DATI/Cluster_CRIT_"+str(seedForRun)+".txt"
	argsCommon = "--runCleaner "+ option.runCleaner +" --runSelector "+option.runSelector+" --runRapidminer "+ option.runRapidminer+" --runCopier "+option.runCopier +" --RMManager "+option.RMManager+" --runCluto "+option.runCluto+" --runOrganizer "+option.runOrganizer+" --runSummarizer "+option.runSummarizer

	time_CRI = []	
	clu_n = []
	
	for i in range(lownCluster, nCluster+1, stride) :		
		# Run the framework for Crit Care
		str_time_CRI = time.time()
		run_framework (absolutePath, argsCRI+" "+argsCommon, i)
		end_time_CRI = time.time()					
		
		# Update the time lists with the results of the above runs
		time_CRI.append(end_time_CRI-str_time_CRI)
		clu_n.append(i)

		remove_data("/media/DATI/Experimental_Results_CRIT_"+str(seedForRun)+"_1/")	

	f = open ("/media/DATI/Execution_Results.txt", mode='w')
	f.write ("Clu_num\tTime\n")

	k = 0
	for i in range(lownCluster, nCluster+1, stride) :				
		f.write (str(clu_n[k])+"\t"+str(time_CRI[k])+ "\n")
		k += 1
	f.close()

	plotting(clu_n, time_CRI, option.title)	

	numberFiles = 0
	for fileName in os.listdir("/media/DATI/pubmed/Crit Care/") :
		numberFiles += 1	
		filePath = os.path.normpath("/media/DATI/pubmed/Crit Care/"+fileName)				
		filePathDest = os.path.normpath("/media/DATI/pubmed/Crit Care_Source/"+fileName)				
		shutil.move(filePath, filePathDest)					
	print numberFiles, " Moved"	

	return

# Run the Framework
def run_framework (path_absolute, arguments, cluster_num):

	if cluster_num == -1:
		print "Run for the first time"
		args = " "+ arguments + " >> FRAM_TMP_PERF.txt "
		#args = " "+ arguments 
	else :
		args = " "+ arguments +  " --clusterNumber " + str(cluster_num) + " >> FRAM_TMP_PERF.txt "
	try:
		print "Run ", path_absolute + args
		print 
		p = Popen("python2.5 "+ path_absolute + args , shell=True)
		p.wait()
		if p.returncode != 0:
                                print " --- Framework : Abnormal termination (code ", p.returncode, ") ---"
				os._exit(1)
		else:
			print "Framework returned", p.returncode

	except OSError, e:
		print "Execution failed:", e
	
	return

# Plotting function for silhouete values
def plotting (s, t_c, plot_title):
	plot (s, t_c, 'k')
	line2 = Line2D(range(10), range(10), linestyle='-', color='k')
	#legend( (line2), ('Crit Care'), loc=0)
	title(plot_title)
	xlabel('Cluster Number')
	ylabel('Time [s]')
	#axis ([0,max(s)+1])
	show()
	return

# Remove tmp files
def remove_data(exp):
	print 
	print "--- Run over "
	shutil.rmtree(exp)
	print "Removed ", exp
	print 
	return 

if __name__ == '__main__':
	main()
