#!/usr/bin/python
from optparse import OptionParser
import tempfile, os, numpy, operator
import time
import shutil
import math
import random
from subprocess import *
from numpy import *
from pylab import *
from matplotlib.lines import Line2D
import subprocess

# main
def main():
	# Measures the performances of summarization when the number of documents in the cluster changes. It starts with 1400 documents and 
	# then halves the number until 5 is reached.
        p = OptionParser()
 
        p.add_option("--programPath", "-p",	dest="absolutePathW",            default="F:\\@_Lorenzo\\@_Tesi\\@_Framework_Parts\\Framework.py", help="Absolute path of the directory pieces of the framework are stored")
	p.add_option('--maximum',		dest="maxDoc",			default="1400", help="Maximum number of documents to cluster")
	p.add_option('--minimum',		dest="minDoc",			default="4", help="Maximum number of documents to cluster")
	p.add_option('--seed',			dest="seedForRun",		default="22858999", help="Seed for the random number generator")
	p.add_option('--title',			dest="title",			default="Summarization performances")
	p.add_option("--ratio", "-r",		dest="ratio",			default="20", help="Ratio of the original text included in summarization")
	p.add_option("--linux",                 dest="linuxOrNot",              default="linux", help="If not set -> working under Windows; if set to linux working under Linux")

        option, arguments = p.parse_args()	

	if option.linuxOrNot == "linux" :
		absolutePath = option.absolutePathW.replace("F:\\", "/media/DATI/")
		absolutePath = absolutePath.replace('\\', '/')		
	else :
		absolutePath = option.absolutePathW

	maxDoc = int(option.maxDoc)
	minDoc = int(option.minDoc)
	seedForRun = long(option.seedForRun)
	seed(22858999)

	time_CRI = []	
	clu_n = []

	currentDoc = maxDoc
	srcFolder = "/media/DATI/Experimental_Results_CRIT/"
	dstFolder = "/media/DATI/"+str(currentDoc)+"/"
	os.mkdir(dstFolder)
	print "*** Run ", currentDoc
	documentMover(srcFolder,dstFolder,currentDoc)
	str_time_CRI = time.time()
	run_summary (currentDoc,option.ratio)	
	end_time_CRI = time.time()	
	documentCopyBack(dstFolder,srcFolder)				
	time_CRI.append(end_time_CRI-str_time_CRI)
	clu_n.append(currentDoc)
	
	oldDoc = currentDoc
	currentDoc = int(currentDoc/2)

	while (currentDoc >= minDoc):

		scrFolder = "/media/DATI/"+str(oldDoc)+"/"
		dstFolder = "/media/DATI/"+str(currentDoc)+"/"
		os.mkdir(dstFolder)
		print "*** Run ", currentDoc
		documentMover(srcFolder,dstFolder,currentDoc)
		str_time_CRI = time.time()
		run_summary (currentDoc,option.ratio)
		end_time_CRI = time.time()				
		documentCopyBack(dstFolder,srcFolder)
		time_CRI.append(end_time_CRI-str_time_CRI)
		clu_n.append(currentDoc)
		oldDoc = currentDoc
		currentDoc = int(currentDoc/2)


	f = open ("/media/DATI/Execution_Results.txt", mode='w')
	f.write ("Doc_Num\tTime\n")

	for i in range(0, len(clu_n)) :				
		f.write (str(clu_n[i])+"\t"+str(time_CRI[i])+ "\n")
	f.close()

	plotting(clu_n, time_CRI, option.title)	

	# Writing the file sorted
	fs = open ("/media/DATI/Execution_Results_Sorted.txt", mode='w')
	fs.write ("Doc_Num\tTime\n")

	for i in range(0, len(clu_n)) :				
		fs.write (str(clu_n[len(clu_n)-1-i])+"\t"+str(time_CRI[len(clu_n)-1-i])+ "\n")
	fs.close()


	return

#Moves the documents from source to destination
def documentMover(srcFolder,dstFolder,totDocuments):
	docCounter = 0
	while docCounter < totDocuments :
		for fileName in os.listdir(srcFolder) :
			if fileName != "Intermediate" and fileName.find("Summary") == -1 :
				p = random()
				if (p >= 0.5):
					if docCounter < totDocuments:
						filePath = os.path.normpath(srcFolder+os.sep+fileName)				
						filePathDest = os.path.normpath(dstFolder+os.sep+fileName)				
						shutil.move(filePath, filePathDest)					
						docCounter += 1
						if (docCounter == totDocuments):
							break
					else :
						break
	print docCounter, " Documents selected; ::: ", 
	return

def documentCopyBack(srcFolder,dstFolder):
	numberFiles = 0
	for fileName in os.listdir(srcFolder) :
		if fileName != "Intermediate" and fileName.find("Summary") == -1 :
			numberFiles += 1	
			filePath = os.path.normpath(srcFolder+os.sep+fileName)				
			filePathDest = os.path.normpath(dstFolder+os.sep+fileName)				
			shutil.copy(filePath, filePathDest)					
	print numberFiles, " Copied Back"
	print
	return

# Run the Framework
def run_summary (curr_doc,ratio):

	# Reading the file Hash_file.hashfile and creating a dictionary where the keys are the name of the texts files and the values 
	# are the names of the weight files.
	hashfilePath = os.path.normpath("/media/DATI/Experimental_Results_CRIT/Intermediate/Hash_File.hashfile")
	fh = open(hashfilePath, 'r');
	fileWeightMatch = {}
	for line in fh :
		listPaht = line.strip().split()
		fileWeightMatch[listPaht[0]] = listPaht[1]		
	fh.close()

	clusterDir = os.path.normpath("/media/DATI/"+str(curr_doc)+"/")		
	ext = os.path.splitext( "Summary.txt" )
	extS = os.path.splitext( "Summary_Sort.txt" )

      	finalSummaryName = "/media/DATI/"+str(curr_doc)+"/" + ext[0].replace(' ','_') + "_" + str(curr_doc) +ext[1]
       	summaryFilePath = os.path.normpath(finalSummaryName)  # File where the final summary (not sorted) is stored
			
	summarySortedName = "/media/DATI/"+str(curr_doc)+"/" + extS[0].replace(' ','_') + "_" + str(curr_doc) +extS[1]
       	summarySortedFilePath = os.path.normpath(summarySortedName)
			
	finalSummSuffName = "/media/DATI/"+str(curr_doc)+"/" + ext[0].replace(' ','_') + "_" + str(curr_doc) +"_Sort" +ext[1]
	summarySuffixFilePath = os.path.normpath(finalSummSuffName)  # File where the final summary (not sorted) is stored

	summarySortSuffName = "/media/DATI/"+str(curr_doc)+"/" + extS[0].replace(' ','_') + "_" + str(curr_doc) +"_Sort" +extS[1]
       	summarySortSuffFilePath = os.path.normpath(summarySortSuffName)
	index = 600
	callingOTS(clusterDir,index, fileWeightMatch, ratio, summaryFilePath, summarySortedFilePath, summarySuffixFilePath, summarySortSuffFilePath)
	return

def callingOTS(clusterDir, index, fileWeightMatch, ratio, summaryFile, summarySorted, summaryFileSuff, summarySortedSuff ) :
	
	print " Summarizing ::: " ,

	if ( index <= 200 ):
		print "Summarizing directory: ", clusterDir	

	summaryFileTMP = os.path.normpath("/media/DATI/TMP_Summary.txt") # File where the temporary summary is stored
	globalList = [] #Contains all the sentences in the whole summary

	# Using OTS on all the files in the cluster
	enter = 0
	success = 0
	for fileName in os.listdir(clusterDir) :
		enter = 1
		weightfile = ""
		weightfile = fileWeightMatch[fileName]
		filePath = os.path.normpath(clusterDir+os.sep+fileName)	# file to summarize
		if weightfile == "" :
			print "Error "+ filePath 
			return 1
		arguments = "--ratio "+ str(ratio) +" --weight "+weightfile+ " > "+ summaryFileTMP #The output is written in the tmp file
		#arguments = "--ratio "+ ratio +" > "+ summaryFileTMP # Used for the original OTS without weight files
		commandLine = "ots "+ filePath + " " + arguments
	        p = subprocess.Popen(commandLine , shell=True)
	        p.wait()

		if p.returncode != 0:
			print " --- Abnormal termination (code ", p.returncode, ") ---"
			return 1
		else:
			success += 1
		
		# Reading the tmp file to retrieve the sentences, store them in the list and modify their score (normalizing)
		fr = open(summaryFileTMP, 'r') #Open the tmp file to normalize the scores
		listSentencesInFile = [] #List of all the sentences in the single document
		sentence = ""
		maxScore = 0
		for line in fr :
			if line.strip() == "" or line.strip() == " ":
				continue

			#if (line.find("[[POINT =") != -1) : #found the last line (End of Sentence) (For old OTS)
			if (line.find("[[SCORE =") != -1) : #found the last line (End of Sentence)				
				#values = line.strip().split("[[POINT = ")
				values = line.strip().split("[[SCORE = ")
				words = values[0].strip() # All the words before [[SCORE = 
				sentence += words
				values2 = values[1].strip().split("]]")

				score = int(values2[0])
				if score > maxScore:
					maxScore = score

				indexWC = values2[1].strip().find(" [[WRD_COUNT = ")+ 15
				wordCount = int(values2[1].strip()[indexWC:])

				token = [sentence, score, wordCount]
				listSentencesInFile.append(token)										
				sentence = ""
			else :
				sentence += line
		fr.close()

		fw = open(summaryFile, 'a') # Append the sentences in the file with the (not sorted) summary (no scores)
		if summaryFileSuff != "" and summarySortedSuff != "":
			fwsuff = open(summaryFileSuff, 'a') # Append the sentences with the normalized scores in the file with the (not sorted) summary
		for i in range (0, len(listSentencesInFile)):
			if len(listSentencesInFile) <= 1:
				listSentencesInFile[i][1] = 0.0
			else :
				listSentencesInFile[i][1] = (listSentencesInFile[i][1]*1.0)/maxScore
			fw.write(str(listSentencesInFile[i][0])+"\n\n")
			if summaryFileSuff != "" and summarySortedSuff != "":
				fwsuff.write(str(listSentencesInFile[i][0])+" [[SCORE="+str(listSentencesInFile[i][1])+"]] [[WRD_COUNT = "+str(listSentencesInFile[i][2])+"]]\n\n")
		fw.write("\n ------------------------------\n")
		fw.close()	
		if summaryFileSuff != "" and summarySortedSuff != "":
			fwsuff.write("\n ------------------------------\n")
			fwsuff.close()	
		os.remove(summaryFileTMP)

		globalList.extend(listSentencesInFile) #In global list I have the sentences of all the summary
		del listSentencesInFile[0:]

	if (enter != 0) :	
		if ( index <= 200 ):
			print " --- Progam 'ots' returned (",success, " times); code in all cases  ", p.returncode, " ---"                        


	# All the files were summarized so the global list now contains all the sentences in the summary
	print "Writing the sorted file ::: ", 
	globalList.sort(myCompareFloatScore) # sort the list 
	
	sentRatio = float(ratio) # retrieve the desired ratio

	fsorted = open(summarySorted, 'w')
	if summaryFileSuff != "" and summarySortedSuff != "":		
		fsortedSuff = open(summarySortedSuff, 'w')		
	maxSent = int((len(globalList)*sentRatio)/100.0) # Maximum number of sentence of the summary that I must take

	for i in range(0, maxSent) :			
		fsorted.write(str(globalList[i][0])+"\n\n")
		if summaryFileSuff != "" and summarySortedSuff != "":
			fullSentence = str(globalList[i][0])+" [[SCORE="+str(globalList[i][1])+"]] [[WRD_COUNT = "+str(globalList[i][2])+"]]"
			fsortedSuff.write(fullSentence+"\n\n")

	fsorted.close()			
	if summaryFileSuff != "" and summarySortedSuff != "":
		fsortedSuff.close()			
	return

def myCompareFloatScore(token1, token2):

	score1 = float(token1[1])
	score2 = float(token2[1])
	return cmp(score2,score1)



# Plotting function for silhouete values
def plotting (s, t_c, plot_title):
	plot (s, t_c, 'k')
	line2 = Line2D(range(10), range(10), linestyle='-', color='k')
	#legend( (line2), ('Crit Care'), loc=0)
	title(plot_title)
	xlabel('Number of documents in the cluster')
	ylabel('Time [s]')
	#axis ([0,max(s)+1])
	show()
	return

# Remove tmp files
def remove_data(exp):
	print 
	print "--- Run over "
	shutil.rmtree(exp)
	print "Removed ", exp
	print 
	return 

if __name__ == '__main__':
	main()
