from xml.etree.ElementTree import ElementTree
from optparse import OptionParser
import os
import shutil

def main():
        p = OptionParser()
        p.add_option("--RMManager", dest="RMManager", default="copy", help="If not set -> what in srcDirName\Intermediated\ will be used; if set to 'copy' what in destDirName will be used by cluto")
        p.add_option("--srcDirectory", "-s", dest="dirnameNB", default="F:\\Text_Selection\\", help="Absolute path of the directory where articles (after having been processed by the cleaner) are stored")
        p.add_option("--dstDirectory", "-d", dest="destDirnameNB", default="F:\\Experimental_Results\\", help="Absolute path of the directory where the selected parts of the articles are stored")
        p.add_option("--intDirectory", "-i", dest="intermediateDirName", default="Intermediate", help="Name of the directory where to store the intermediary processing files (Ex. data.dat)")
        p.add_option("--suffix", "-n", dest="suffix", default="clean", help="Suffix to be added to the processed article name")        
        p.add_option("--attFileName", "-a", dest="attrFileName", default="attribute.aml", help="Name of the file where Rapid Miner must store the attributes")
        p.add_option("--dataFileName", "-f", dest="dataFileName", default="data.dat", help="Name of the file where Rapid Miner must store the data")
        p.add_option("--rowLabel", "-r", dest="rowLabelFileName", default="RowLabels.rlabel", help="Name of the file in which the labels of the rows of the matrix generated by RM are stored")
        p.add_option("--colLabel", "-c", dest="colLabelFileName", default="ColLabels.clabel", help="Name of the file in which the labels of the columns of the matrix generated by RM are stored")        
	p.add_option("--hashfileName", dest="hashFileName", default="Hash_File.hashfile", help="Name of a file in which each line has two entries: the name of the selected file and the name of the weights")	
        p.add_option("--linux", "-l", dest="linuxOrNot", default="", help="If not set -> working under Windows; if set to linux working under Linux")
        
        option, arguments = p.parse_args()

        if option.linuxOrNot == "linux" :
                dirname = option.dirnameNB.replace('%20', ' ')
		dirname = dirname.replace("F:\\", "/media/DATI/")
		dirname = dirname.replace('\\', '/')
		destDirname = option.destDirnameNB.replace('%20', ' ')
		destDirname = destDirname.replace("F:\\", "/media/DATI/")
		destDirname = destDirname.replace('\\', '/')
	else :
                dirname = option.dirnameNB.replace('%20', ' ')
		destDirname = option.destDirnameNB.replace('%20', ' ')

        ext = os.path.splitext( option.dataFileName )
        dataFileNameCleaned = ext[0].replace(' ','_') +"_"+option.suffix + ext[1]
        
	if (option.RMManager == "copy") :
                # Copy from <destDirName>(Ex experimental results) to <dirname>(Ex Text selction)\<intermediate>
                srcDir = destDirname
                dstDir = dirname+os.sep+option.intermediateDirName+os.sep
                print "Copy from ", srcDir, " to ", dstDir
                i = 0
                for fn in os.listdir(srcDir) :
                        #if ( (fn == dataFileNameCleaned) or (fn == option.dataFileName) or (fn == option.attrFileName) or (fn == option.rowLabelFileName) or (fn == option.colLabelFileName) ) :
			if ( (fn == dataFileNameCleaned) or (fn == option.attrFileName) or (fn == option.rowLabelFileName) or (fn == option.colLabelFileName) ) :
                                # Absolute path and name of the source file
                                source = os.path.normpath(srcDir+os.sep+fn)
                                # Absolute path and name of the destination file
                                dest = os.path.normpath(dstDir+os.sep+fn)
                                #shutil.copy(source,dest)    
                                #os.remove(source)            
                                i += 1

		pathHashSrc = os.path.normpath(dstDir+os.sep+option.hashFileName)
		pathHashDst = os.path.normpath(srcDir+os.sep+option.hashFileName)
		if (os.path.exists(pathHashSrc)) :
			i+=1
			shutil.copy(pathHashSrc,pathHashDst)                
		else :
			print "Hash file not copied"


                print i , "files were copied"
                print
        else :
                # Copy from <dirname>(Ex Text Selection)\<intermediate> to <destDirName>(Ex experimental Results)
                srcDir = dirname+os.sep+option.intermediateDirName+os.sep
                dstDir = destDirname
                print "Copy from ", srcDir, " to ", dstDir
                i = 0
                for fn in os.listdir(srcDir) :
                        #if ( (fn == dataFileNameCleaned) or (fn == option.dataFileName) or (fn == option.attrFileName) or (fn == option.rowLabelFileName) or (fn == option.colLabelFileName) ) :
			if ( (fn == dataFileNameCleaned) or (fn == option.attrFileName) or (fn == option.rowLabelFileName) or (fn == option.colLabelFileName) or (fn == option.hashFileName) ) :
                                # Absolute path and name of the source file
                                source = os.path.normpath(srcDir+os.sep+fn)
                                # Absolute path and name of the destination file
                                dest = os.path.normpath(dstDir+os.sep+fn)
                                shutil.copy(source,dest)
                                shutil.remove(source)               
                                i += 1

                print i , "files were copied"
                print 
                
        return


if __name__ == "__main__":
	# Someone is launching this directly
	main()
