#!/usr/bin/python
from optparse import OptionParser
import tempfile, os, numpy, operator
from subprocess import *
from numpy import *
from pylab import *
from matplotlib.lines import Line2D

# run clustering algorithm (Cluto)
def run_clustering (path_absolute,path_dataset, ncluster, clutoOptions):
	print path_dataset
	args = " "+ path_dataset +  " " + str(ncluster)
	try:
		print "run vcluster with clusters ", ncluster
		optionCluto = " -clmethod=rbr -showfeatures -nfeatures=10 -plotformat=gif -plotclusters=a.gif -clabelfile=a.txt -rlabelfile=b.txt"
		print path_absolute + args
		p = Popen(path_absolute + optionCluto+ args , shell=True)
		p.wait()
		if p.returncode != 0:
			print "Vcluster returnes by signal", p.returncode
		else:
			print "Vcluster returned", p.returncode
	except OSError, e:
		print "Execution failed:", e


# calcola il combinatorio (n 2)
def comb (n):
	fatt =  lambda n:reduce(lambda a,b:a*(b+1),range(n),1)
	if n == 1:
		c = 0
	else:
		c = fatt(n) /( fatt(2) * fatt(n-2) )
	return c

# calcola il rand index per un dato numero di cluster
def run_index (train, test):
	cluster_train = {}
	cluster_test = {}
	f_train = open (train, mode='r')
	f_test = open (test, mode='r')
	k = 1
	for line in f_train:
		cluster_train.setdefault (line.strip(), []).append(k)
		k +=1
	n_tot = k-1
	k = 1
	for line in f_test:
		cluster_test.setdefault (line.strip(), []).append(k)
		k +=1
# calcolo di b1 sul train
	b1 = 0
	for item in cluster_train.values():
		b1 += comb ( len(item) )
#	print b1
# calcolo di c1 sul test
	c1 = 0
	for item in cluster_test.values():
		c1 += comb ( len(item) )
#	print c1
# calcolo di a 
	a = 0
	for item_train in cluster_train.values():
		for item_test in cluster_test.values():
			a += comb ( len( set(item_train).intersection( set(item_test) ) ) )
	#print a
	b = b1 - a
	c = c1 - a
	d = comb(n_tot) - a -b -c
#	print d
	return  (float(a+d)/float(a+b+c+d))



#plotting function for silhouete values
def plotting (k, ri_a, ri_b, ri_ab, titolo):
	plot (k, ri_a, 'r')
	plot (k, ri_b, 'b')
	plot (k, ri_ab, 'g')
	line1 = Line2D(range(10), range(10), linestyle='-', color='r')
	line2 = Line2D(range(10), range(10), linestyle='-', color='b')	
	line3 = Line2D(range(10), range(10), linestyle='-', color='g')
	legend((line1,line2,line3), ('Abstract','Body','Abstract and Body'), loc=4)
	title(titolo)
	xlabel('Number of clusters')
	ylabel('Rand Index')
	axis ([0,max(k)+1, 0,1])
	show()

	# rimuove i file temporanei
def remove_data(kwdFile, absFile, bdyFile, absbdyFile, i):
	files = kwdFile + ".clustering." + str(i) + " " + absFile + ".clustering." + str(i) + " " + bdyFile + ".clustering." + str(i) + " " + absbdyFile + ".clustering." + str(i)
	try:
		p = Popen("rm " + files, shell=True)
		p.wait()
		if p.returncode < 0:
			print "rm returnes by signal", p.returncode
	except OSError, e:
		print "Execution failed:", e

# main
def main():
        p = OptionParser()
        p.add_option('--kwdFile', dest="kwdFileNameW", default="F:\\Rand\\data_clean_k.dat", help="Matrix related to the kwd only")
        p.add_option('--absFile', dest="absFileNameW", default="F:\\Rand\\data_clean_ab.dat", help="Matrix related to the abstract only")
	p.add_option('--bdyFile', dest="bdyFileNameW", default="F:\\Rand\\data_clean_b.dat", help="Matrix related to the body onlt")
        p.add_option('--absbdyFile', dest="absbdyFileNameW", default="F:\\Rand\\data_clean_abbd.dat", help="Matrix related to the abstract and to the body")
	p.add_option('--cluster', '-k', dest="cluster", default="200", help="Maximum number of desired clusters")
	p.add_option('--stride', '-s', dest="stride", default="5", help="Step: if 10 -> n = 10, 20, 30, 40")
	p.add_option('--lowcluster', '-l', dest="lowcluster", default="5", help="Starting point")
	p.add_option('--clutoOptions', dest="clutoOptions", default="-clmethod=rbr -showfeatures -nfeatures=10 ")
	p.add_option('--path', '-p', dest="path", default="F:\\@_Lorenzo\\@_Tesi\\@_Framework_Parts\\vcluster", help="Path clustering program (Cluto)")
	p.add_option('--title', '-t', dest="title", default="Rand Index J_Key")
	
	option, arguments = p.parse_args()

	kwdFileName = option.kwdFileNameW.replace("F:\\", "/media/DATI/")
	kwdFileName = kwdFileName.replace('\\', '/')
	absFileName = option.absFileNameW.replace("F:\\", "/media/DATI/")
	absFileName = absFileName.replace('\\', '/')
	bdyFileName = option.bdyFileNameW.replace("F:\\", "/media/DATI/")
	bdyFileName = bdyFileName.replace('\\', '/')
	absbdyFileName = option.absbdyFileNameW.replace("F:\\", "/media/DATI/")
	absbdyFileName = absbdyFileName.replace('\\', '/')
	path_absolute = option.path.replace("F:\\", "/media/DATI/")
	path_absolute = path_absolute.replace('\\', '/')
	print path_absolute
	lowcluster = int(option.lowcluster)
	cluster = int(option.cluster)
	stride = int(option.stride)
	
	rand_index_abs = []
	rand_index_body = []
	rand_index_absbody = []
	k = []
	
	for i in range(lowcluster, cluster+1, stride):
		run_clustering (path_absolute,kwdFileName, i, option.clutoOptions)
		run_clustering (path_absolute,absFileName, i, option.clutoOptions)
		run_clustering (path_absolute,bdyFileName, i, option.clutoOptions)
		run_clustering (path_absolute,absbdyFileName, i, option.clutoOptions)
		rand_index_abs.append(run_index (kwdFileName + '.clustering.' + str(i), absFileName + '.clustering.' + str(i) ))
		rand_index_body.append(run_index (kwdFileName + '.clustering.' + str(i), bdyFileName + '.clustering.' + str(i) ))
		rand_index_absbody.append(run_index (kwdFileName + '.clustering.' + str(i), absbdyFileName + '.clustering.' + str(i) ))		
		k.append(i)
		remove_data(kwdFileName, absFileName, bdyFileName, absbdyFileName, i)
	#print rand_index

	plotting(k, rand_index_abs,rand_index_body, rand_index_absbody, option.title)

	fres = open ("/media/DATI/Rand_Index_Breast_Cancer.txt", mode='w')
	fres.write ("Cluster\tAbstract\tBody\t\tAbstract_Body\n")

	ind = 0
	for i in range(lowcluster, cluster+1, stride):
		fres.write ( str(k[ind])+"\t"+ str(rand_index_abs[ind])+ "\t"+ str(rand_index_body[ind])+ "\t"+ str(rand_index_absbody[ind]) + "\n")
		ind += 1
	fres.close()

	return



if __name__ == '__main__':
	main()
