from xml.etree.ElementTree import ElementTree
from optparse import OptionParser
import os
import shutil

def main():
        p = OptionParser()
        p.add_option("--work", "-w", dest="workDirNameNB", default="F:\\Experimental_Results_BIO\\", help="Absolute path of the directory where results are stored")
	p.add_option("--default", "-d", dest="defDirNameNB", default="F:\\Experimental_Results_BIO\\", help="Absolute path of the default name of the directory where results are stored")
        p.add_option("--intermediate", "-i", dest="intermediateDirNameNB", default="Intermediate", help="Name of the directory where to store the intermediary processing files (Ex. data.dat)")
        p.add_option("--clusterNumer", "-n", dest="clusterNumberNB", default="10", help="Number of clusters produced by cluto")
        p.add_option("--outputCluto", "-o", dest="outputClutoFileNameNB", default="CLUTO_10_clusters.dat", help="Name of the file in which the results (clusters) of CLUTo measures ar stored")
        p.add_option("--rowLabel", "-r", dest="rowLabelFileNameNB", default="RowLabels.rlabel", help="Name of the file in which the labels of the rows of the matrix generated by RM are stored")

        option, arguments = p.parse_args()

        workDirName = option.workDirNameNB.replace('%20', ' ')
	defDirName = option.defDirNameNB.replace('%20', ' ')
        intermediateDirName = option.intermediateDirNameNB.replace('%20', ' ')
        clusterNumber = int(option.clusterNumberNB.replace('%20', ' '))
        outputClutoFileName = option.outputClutoFileNameNB.replace('%20', ' ')
        rowLabelFileName = option.rowLabelFileNameNB.replace('%20', ' ')

        intDirPath = os.path.normpath(workDirName+os.sep+intermediateDirName)
        os.mkdir(intDirPath)

	print "RO"+workDirName
	
	#Sposto tutti i file meno i txt da Experimental_Results... a ExpRes.../Intermediate
        for fileName in os.listdir(workDirName) :
                source = os.path.normpath(workDirName+os.sep+fileName)
                #dest = os.path.normpath(intDirPath+os.sep+fileName)
                if os.path.isfile(source) and source.find(".txt")==-1:
                	shutil.move(source,intDirPath)

	#Creo le directory per i vari cluster
        for i in range(0, clusterNumber) :
                clustDirPath = os.path.normpath(workDirName+os.sep+str(i))
                os.mkdir(clustDirPath)


        outputClutoFilePath = os.path.normpath(intDirPath+os.sep+outputClutoFileName)
        rowLabelFilePath = os.path.normpath(intDirPath+os.sep+rowLabelFileName)

        fcluster = open (outputClutoFilePath, mode='r')
        flabel = open (rowLabelFilePath, mode='r')
	#print 'fcluster: ', outputClutoFilePath, 'flabel: ', rowLabelFilePath
        for lineCluster in fcluster :
        	lineLabel = flabel.readline()
		lineLabel = lineLabel.replace(defDirName,workDirName)
                #print 'lC: ', lineCluster, '\nLL: ', lineLabel
                source = os.path.normpath(lineLabel.strip()).replace('\"','')
                dest = os.path.normpath(workDirName+os.sep+lineCluster.strip())
                if os.path.exists(source):
                	shutil.move(source,dest)

        fcluster.close()
        flabel.close()
        
if __name__ == "__main__":
	# Someone is launching this directly
	main()
