from xml.etree.ElementTree import ElementTree
from optparse import OptionParser
import os
import subprocess
import bibtexparse

def main():
        p = OptionParser()
        p.add_option("--work", "-w", dest="workDirNameNB", default="F:\\Experimental_Results\\", help="Absolute path of the directory where pieces of the framework are stored")
##        p.add_option("--work", "-w", dest="workDirNameNB", default="F:\\Experimental_Results_BC\\", help="Absolute path of the directory where pieces of the framework are stored")
	p.add_option("--sourceDirName", dest="srcDirNameNB", default="F:\\Text_Selection\\", help="Absolute path of the directory where the selected texts are stored")
##	p.add_option("--sourceDirName", dest="srcDirNameNB", default="F:\\Text_Selection_BC_ABBD\\", help="Absolute path of the directory where the selected texts are stored")
        p.add_option("--intermediate", "-i", dest="intermediateDirNameNB", default="Intermediate", help="Name of the directory where to store the intermediary processing files (Ex. data.dat)")
	p.add_option("--hashfileName", dest="hashFileName", default="Hash_File.hashfile", help="Name of a file in which each line has two entries: the name of the selected file and the name of the weights")	
	p.add_option("--summFileName", "-n", dest="summaryFileNameNB", default="Summary.txt", help="Name of the summary file")
	p.add_option("--summSorted", dest="summarySortedNB", default="Summary_Sorted.txt", help="Name of the summary file")
	p.add_option("--ratio", "-r", dest="ratioNB", default="20", help="Ratio of the original text included in summarization")
	p.add_option("--scoreSummSuffix", dest="scoreSummSuffix", default="Scores", help="Suffix to be added to the summary files sorted and not sorted when they also report scores")
	p.add_option("--score", dest="scoreOrNot", default="Y", help="If set to 'Y' two more files (sorted and not sorted) with also the scores for each sentences will be produced; If not set these two files won't be produced")
	p.add_option("--linux", "-l", dest="linuxOrNot", default="linux", help="If not set -> working under Windows; if set to linux working under Linux")
	
        option, arguments = p.parse_args()

	if option.linuxOrNot == "linux" :
		workDirName = option.workDirNameNB.replace('%20', ' ')
		workDirName = workDirName.replace("F:\\", "/media/DATI/")
		workDirName = workDirName.replace('\\', '/')
		srcDirName = option.srcDirNameNB.replace('%20', ' ')
		srcDirName = srcDirName.replace("F:\\", "/media/DATI/")
		srcDirName = srcDirName.replace('\\', '/')		
		intermediateDirName = option.intermediateDirNameNB.replace('%20', ' ')
		summaryFileName = option.summaryFileNameNB.replace('%20', ' ')
		summarySorted = option.summarySortedNB.replace('%20', ' ')
		ratio = option.ratioNB.replace('%20', '')
	else :
		workDirName = option.workDirNameNB.replace('%20', ' ')
		srcDirName = option.srcDirNameNB.replace('%20', ' ')
		intermediateDirName = option.intermediateDirNameNB.replace('%20', ' ')
		summaryFileName = option.summaryFileNameNB.replace('%20', ' ')
		ratio = option.ratioNB.replace('%20', '')
		summarySorted = option.summarySortedNB.replace('%20', ' ')

	print "Summarizing ", workDirName
	print "Ratio ", ratio
	print 

	# Reading the file Hash_file.hashfile and creating a dictionary where the keys are the name of the texts files and the values 
	# are the names of the weight files.
	hashfilePath = os.path.normpath(workDirName+os.sep+intermediateDirName+os.sep+option.hashFileName)
	fh = open(hashfilePath, 'r');
	fileWeightMatch = {}
	for line in fh :
		listPaht = line.strip().split()
		fileWeightMatch[listPaht[0]] = listPaht[1]		
	fh.close()

        index = 600
        for fileName in os.listdir(workDirName) :
		if (fileName != intermediateDirName) and fileName.find('txt') == -1:
                	clusterDir = os.path.normpath(workDirName+os.sep+fileName+os.sep)
                	#if not os.path.exists(clusterDir):
	                #	os.mkdir(clusterDir+'/')
			ext = os.path.splitext( summaryFileName )
			extS = os.path.splitext( summarySorted )

                	finalSummaryName = workDirName+os.sep+fileName+os.sep + ext[0].replace(' ','_') + "_" + fileName +ext[1]
                	summaryFilePath = os.path.normpath(finalSummaryName)  # File where the final summary (not sorted) is stored
			#print 'SFP: ', summaryFilePath
			summarySortedName = workDirName+os.sep+fileName+os.sep + extS[0].replace(' ','_') + "_" + fileName +extS[1]
                	summarySortedFilePath = os.path.normpath(summarySortedName)
			#print 'SSFP: ', summarySortedFilePath
			summarySuffixFilePath = ""
			summarySortSuffFilePath = ""
			if option.scoreOrNot == "Y":
				finalSummSuffName = workDirName+os.sep+fileName+os.sep + ext[0].replace(' ','_') + "_" + fileName +"_"+option.scoreSummSuffix +ext[1]
              			summarySuffixFilePath = os.path.normpath(finalSummSuffName)  # File where the final summary (not sorted) is stored

				summarySortSuffName = workDirName+os.sep+fileName+os.sep + extS[0].replace(' ','_') + "_" + fileName +"_"+option.scoreSummSuffix +extS[1]
	                	summarySortSuffFilePath = os.path.normpath(summarySortSuffName)

			callingOTS(clusterDir,index, fileWeightMatch, ratio, summaryFilePath, summarySortedFilePath, summarySuffixFilePath, summarySortSuffFilePath)
			index += 1 # Used to decide what to print on stdout

	return
               
def callingOTS(clusterDir, index, fileWeightMatch, ratio, summaryFile, summarySorted, summaryFileSuff, summarySortedSuff ) :

	if ( index <= 200 ):
		print "Summarizing directory: ", clusterDir	

	summaryFileTMP = os.path.normpath("./BioSumm/DATI/TMP_Summary.txt") # File where the temporary summary is stored
	globalList = [] #Contains all the sentences in the whole summary

	# Using OTS on all the files in the cluster
	enter = 0
	success = 0
	try:
		bibTdic = bibtexparse.bibteximport('./ref.bib')
	except UnboundLocalError, TypeError:
		bibTdic = []
		print 'unboundLocalError'
		
	for fileName in os.listdir(clusterDir) :
		enter = 1
		weightfile = ""
		weightfile = fileWeightMatch[fileName]
		filePath = os.path.normpath(clusterDir+os.sep+fileName)	# file to summarize
		if weightfile == "" :
			print "Error "+ filePath 
			return 1
		
		arguments = "--ratio "+ str(ratio) +" --weight "+weightfile+ " > "+ summaryFileTMP #The output is written in the tmp file
		commandLine = "./BioSumm/@_Framework_Parts/ots-0.5.0/src/ots "+ filePath + " " + arguments
		p = subprocess.Popen(commandLine , shell=True)
	        p.wait()
	        if not os.path.exists(clusterDir+'/html/'):
	        	os.mkdir(clusterDir+'/html/')
		arguments = "--ratio "+ str(ratio) +" --weight "+weightfile+" --html > "+clusterDir+'/html/'+fileName +".html" #The output is written in the tmp file
		#arguments = "--ratio "+ ratio +" > "+ summaryFileTMP # Used for the original OTS without weight files
		commandLine = "./BioSumm/@_Framework_Parts/ots-0.5.0/src/ots "+ filePath + " " + arguments
		#print 'CL: ', commandLine
	        p = subprocess.Popen(commandLine , shell=True)
	        p.wait()

		if p.returncode != 0:
			print " --- Abnormal termination (code ", p.returncode, ") ---"
			return 1
		else:
			success += 1
		
		# Reading the tmp file to retrieve the sentences, store them in the list and modify their score (normalizing)
		fr = open(summaryFileTMP, 'r') #Open the tmp file to normalize the scores
		listSentencesInFile = [] #List of all the sentences in the single document
		sentence = ""
		maxScore = 0
		for line in fr :
			if line.strip() == "" or line.strip() == " ":
				continue

			#if (line.find("[[POINT =") != -1) : #found the last line (End of Sentence) (For old OTS)
			if (line.find("[[SCORE =") != -1) : #found the last line (End of Sentence)				
				#values = line.strip().split("[[POINT = ")
				values = line.strip().split("[[SCORE = ")
				words = values[0].strip() # All the words before [[SCORE = 
				sentence += words
				values2 = values[1].strip().split("]]")

				score = int(values2[0])
				if score > maxScore:
					maxScore = score

				indexWC = values2[1].strip().find(" [[WRD_COUNT = ")+ 15
				wordCount = int(values2[1].strip()[indexWC:])
				fN = fileName.split('.txt')
				token = [sentence, score, wordCount, fN[0]]
				listSentencesInFile.append(token)										
				sentence = ""
			else :
				sentence += line
		fr.close()

		fw = open(summaryFile, 'a') # Append the sentences in the file with the (not sorted) summary (no scores)
		if summaryFileSuff != "" and summarySortedSuff != "":
			fwsuff = open(summaryFileSuff, 'a') # Append the sentences with the normalized scores in the file with the (not sorted) summary
		for i in range (0, len(listSentencesInFile)):
			fN = fileName.split('.txt')
			elID = '0'
			for dicts in bibTdic:
				if fN[0] in bibTdic[dicts]['key']:
					elID = bibTdic[dicts]['id']
			if len(listSentencesInFile) <= 1:
				listSentencesInFile[i][1] = 0.0
			else :
				listSentencesInFile[i][1] = (listSentencesInFile[i][1]*1.0)/maxScore
			fw.write(str(listSentencesInFile[i][0])+"<b><sup> "+elID+"</sup></b><br>")
			if summaryFileSuff != "" and summarySortedSuff != "":
				fwsuff.write(str(listSentencesInFile[i][0])+"<b><sup> "+elID+"</sup></b><br><font color=#6D7B8D> [[SCORE="+str(listSentencesInFile[i][1])+"]] [[WRD_COUNT = "+str(listSentencesInFile[i][2])+"]]</font><hr>")
		#fw.write("\n ------------------------------\n")
		fw.close()	
		if summaryFileSuff != "" and summarySortedSuff != "":
			#fwsuff.write("\n ------------------------------\n")
			fwsuff.close()	
		os.remove(summaryFileTMP)

		globalList.extend(listSentencesInFile) #In global list I have the sentences of all the summary
		del listSentencesInFile[0:]

	if (enter != 0) :	
		if ( index <= 200 ):
			print " --- Progam 'ots' returned (",success, " times); code in all cases  ", p.returncode, " ---"                        


	# All the files were summarized so the global list now contains all the sentences in the summary
	globalList.sort(myCompareFloatScore) # sort the list 

	sentRatio = float(ratio) # retrieve the desired ratio
	fsorted = open(summarySorted, 'w')
	if summaryFileSuff != "" and summarySortedSuff != "":		
		fsortedSuff = open(summarySortedSuff, 'w')		
	maxSent = int(round((len(globalList)*sentRatio/100.0), 0)) # Maximum number of sentence of the summary that I must take
	if maxSent == 0:
		maxSent = 1
	maxSent = len(globalList)
#	print maxSent
	for i in range(0, maxSent) :			
		elID = '0'
		for dicts in bibTdic:
			if str(globalList[i][3]) in bibTdic[dicts]['key']:
				elID = bibTdic[dicts]['id']
		fsorted.write(str(globalList[i][0])+"<b><sup> "+elID+"</sup></b><br>")

		if summaryFileSuff != "" and summarySortedSuff != "":
			fullSentence = str(globalList[i][0])+"<b><sup> "+elID+"</sup></b><br><font color=#6D7B8D>[[SCORE="+str(globalList[i][1])+"]] [[WRD_COUNT = "+str(globalList[i][2])+"]]</font>"
			fsortedSuff.write(fullSentence+"<hr>")

	fsorted.close()			
	if summaryFileSuff != "" and summarySortedSuff != "":
		fsortedSuff.close()			
	return

def myCompareFloatScore(token1, token2):

	score1 = float(token1[1])
	score2 = float(token2[1])
	return cmp(score2,score1)


if __name__ == "__main__":
	# Someone is launching this directly
	main()
