from xml.etree.ElementTree import ElementTree
from optparse import OptionParser
import os

def main():
        p = OptionParser()        
        p.add_option("--srcDirectory", "-s", dest="dirnameNB", default="F:\\Cleaned_Texts\\", help="Absolute path of the directory where articles (after having been processed by the cleaner) are stored")
        p.add_option("--dstDirectory", "-d", dest="destDirnameNB", default="F:\\Text_Selection\\", help="Absolute path of the directory where the selected parts of the articles are stored")
	p.add_option("--fileNumDirectory", dest="fileNumDirnameNB", default="F:\\FileNumFiles_JEWS\\", help="Absolute path of the directory where the files NUM and DUP containing number of distinct and duplicated genes are stored")
        p.add_option("--intDirectory", "-i", dest="intermediateDirName", default="Intermediate", help="Name of the directory where to store the intermediary processing files (Ex. data.dat)")
        p.add_option("--suffix", "-n", dest="wSuffixNB", default="W_FN", help="Suffix to be added to the weight file related to the processed article")
	p.add_option("--hashfileName", dest="hashFileName", default="Hash_File.hashfile", help="Name of a file in which each line has two entries: the name of the selected file and the name of the weights")	
	p.add_option("--statistics", dest="statFileName", default="Text_Statistics.txt", help="Absolute path of the file where the final statistics are stored")
	p.add_option("--gnFoundFileName", dest="gnFoundFileName", default="DocGenes.txt", help="Absolute path of the file where all the files wih genes (and the corresponding number of genes) are stored")        
        p.add_option("--title", dest="titleOrNot", default="", help="If not set ('') the title must not be taken; if set to 'Y' grab the title")
        p.add_option("--abstract", dest="abstractOrNot", default="", help="If not set ('') the abstract must not be taken; if set to 'Y' grab the abstract")
        p.add_option("--body", dest="bodyOrNot", default="", help="If not set ('') the body must not be taken; if set to 'Y' grab the body")
        p.add_option("--kwd", dest="kwdOrNot", default="", help="If not set ('') the keywords must not be taken; if set to 'Y' grab the keywords")        
        p.add_option("--all", dest="allOrNot", default="", help="If set to 'Y' the whole text must be taken")
        p.add_option("--numberAndDuplicates", dest="numAndDupOrNot", default="N", help="If set to Y the files NUM and DUP with the number of distinct and duplicated genes will be produced. If not set nothing will be done")
        p.add_option("--linux", "-l", dest="linuxOrNot", default="", help="If not set -> working under Windows; if set to linux working under Linux")
        
        option, arguments = p.parse_args()

        if option.linuxOrNot == "linux" :
                dirname = option.dirnameNB.replace('%20', ' ')
		dirname = dirname.replace("F:\\", "/media/DATI/")
		dirname = dirname.replace('\\', '/')
		destDirname = option.destDirnameNB.replace('%20', ' ')
		destDirname = destDirname.replace("F:\\", "/media/DATI/")
		destDirname = destDirname.replace('\\', '/')
		fileNumDirname = option.fileNumDirnameNB.replace('%20', ' ')
		fileNumDirname = fileNumDirname.replace("F:\\", "/media/DATI/")
		fileNumDirname = fileNumDirname.replace('\\', '/')
		wSuffix = option.wSuffixNB.replace('%20', ' ')		
	else :
                dirname = option.dirnameNB.replace('%20', ' ')
		destDirname = option.destDirnameNB.replace('%20', ' ')
		fileNumDirname = option.fileNumDirnameNB.replace('%20', ' ')
		wSuffix = option.wSuffixNB.replace('%20', ' ')

        titl = abst = body = kywd = 0

        if (option.titleOrNot == "Y" or option.allOrNot == "Y") :
                titl = 1
                suffix = "tit"
        if (option.abstractOrNot == "Y" or option.allOrNot == "Y") :
                abst = 1
                if titl == 1 :
                        suffix += "ab"
                else :
                        suffix = "ab"                
        if (option.bodyOrNot == "Y" or option.allOrNot == "Y") :
                body = 1
                if (titl == 1 or abst == 1) :
                        suffix += "bd"
                else :
                        suffix = "bd"
        if (option.kwdOrNot == "Y" or option.allOrNot == "Y") :
                kywd = 1
                if (titl == 1 or abst == 1 or body == 1) :
                        suffix += "k"
                else :
                        suffix = "k"
                        
        if option.allOrNot == "Y" :
                suffix = "all"
        
        
        outputDirName = destDirname +os.sep
        if (os.path.exists(outputDirName)) :
                print "The specified output directory already exists: can't over-write. Returning",outputDirName
                return
        else :
                os.mkdir(outputDirName)

        intDirName = destDirname +os.sep + option.intermediateDirName + os.sep
	hashFile = intDirName + option.hashFileName
        if (os.path.exists(intDirName)) :
                print intDirName, " already exists. It won't be created again"                
        else :
                os.mkdir(intDirName)      


	if option.numAndDupOrNot == "Y":
		numDirname = fileNumDirname +os.sep
		if (os.path.exists(numDirname)) :
		        print "The specified output directory already exists: can't over-write. Returning",numDirname
		        return
		else :
		        os.mkdir(numDirname)

		intDirName = fileNumDirname +os.sep + option.intermediateDirName + os.sep
		hashFileNum = intDirName + "NUM_"+option.hashFileName
		hashFileDup = intDirName + "DUP_"+option.hashFileName
	        if (os.path.exists(intDirName)) :
	                print intDirName, " already exists. It won't be created again"                
	        else :
	                os.mkdir(intDirName)      


	print " --- List of the processed files --- "
        print

        fh = open (hashFile, mode='w')
	if option.numAndDupOrNot == "Y":
	        fhn = open (hashFileNum, mode='w')
	        fhd = open (hashFileDup, mode='w')

        i = 1
	print dirname
        for fileName in os.listdir(dirname) :
		if ( (fileName.find(wSuffix) == -1) and  (fileName != option.statFileName) and (fileName != option.gnFoundFileName) and (fileName.find("DEBUGDEBUG") == -1)) :
                
                        # Absolute path and name of the source file
                        source = os.path.normpath(dirname+os.sep+fileName)
                        # Absolute path and name of the destination file
                        ext = os.path.splitext( fileName )
			destName = ext[0].replace(' ','_') + "_" + suffix +".txt"
                        dest = outputDirName + destName
                        dest = os.path.normpath(dest)
                        # Absolute path and name of the destination file (weight file)
                        wDest = dirname + ext[0].replace(' ','_') + "_" + suffix+ "_"+wSuffix +".txt"
                        wDest = os.path.normpath(wDest)
			fh.write(destName+ " "+wDest+"\n")

			if option.numAndDupOrNot == "Y":
				# Absolute path and name of the destination file (num & dup file)
		                nDest = fileNumDirname + ext[0].replace(' ','_') + "_" + suffix+ "_NUM.txt"
		                nDest = os.path.normpath(nDest)
		                dDest = fileNumDirname + ext[0].replace(' ','_') + "_" + suffix+ "_DUP.txt"
		                dDest = os.path.normpath(dDest)
				fhn.write(destName+ " "+nDest+"\n")
				fhd.write(destName+ " "+dDest+"\n")
			else: 
				dDest = ""; nDest = ""
			                        
                        #print str(i)+ ")"
                        #print "Source: " + source
                        #print "Destination: " + dest
                        #print "Destination (weight file): " + wDest
	                i += 1                               
		
                        selector(source,dest,wDest,titl, abst, body , kywd,dDest,nDest)

        print i, "files analyzed" 
	fh.close()
	if option.numAndDupOrNot == "Y":
		fhn.close()
		fhd.close()
        
        return


def selector( source, dest, wDest, titl, abst, body, kywd,dDest,nDest ) :
        
        f = open (source, mode='r')
        ft = open (dest, mode='w') ; fw = open (wDest, mode='w')
        counterWeights = 0; counterNum = 0; counterDup = 0
	lineTit = ""; lineAbs = ""; lineBdy = ""; linenTit = ""; linenAbs = ""; linenBdy = ""; linedTit = ""; linedAbs = ""; linedBdy = "" 
        t = a = b = k = tw = aw = bw = tn = an = bn = td = ad = bd = 0

        for line in f :
                
                if line.strip() == "<title>" :
                        t = 1
                        continue
                if line.strip() == "</title>" :        
                        t = 0
                        continue
                if line.strip() == "<body>" :
                        b = 1
                        continue
                if line.strip() == "</body>" :
                        b = 0
                        continue
                if line.strip() == "<abstract>" :
                        a = 1
                        continue
                if line.strip() == "<keywords>" :
                        k = 1
                        continue
                if line.strip() == "</keywords>" :
                        k = 0
                        continue
                if line.strip() == "</abstract>" :
                        a = 0
                        continue
                if line.strip() == "<TitleWeights>" :
                        tw = 1
                        continue                
                if line.strip() == "</TitleWeights>" :        
                        tw = 0
                        continue
                if line.strip() == "<BodyWeights>" :
                        bw = 1
                        continue
                if line.strip() == "</BodyWeights>" :
                        bw = 0
                        continue
                if line.strip() == "<AbstractWeights>" :
                        aw = 1
                        continue
                if line.strip() == "</AbstractWeights>" :
                        aw = 0
                        continue

		if line.strip() == "<TitleNumbers>" :
                        tn = 1
                        continue                
                if line.strip() == "</TitleNumbers>" :        
                        tn = 0
                        continue
                if line.strip() == "<BodyNumbers>" :
                        bn = 1
                        continue
                if line.strip() == "</BodyNumbers>" :
                        bn = 0
                        continue
                if line.strip() == "<AbstractNumbers>" :
                        an = 1
                        continue
                if line.strip() == "</AbstractNumbers>" :
                        an = 0
                        continue

		if line.strip() == "<TitleDuplicates>" :
                        td = 1
                        continue                
                if line.strip() == "</TitleDuplicates>" :        
                        td = 0
                        continue
                if line.strip() == "<BodyDuplicates>" :
                        bd = 1
                        continue
                if line.strip() == "</BodyDuplicates>" :
                        bd = 0
                        continue
                if line.strip() == "<AbstractDuplicates>" :
                        ad = 1
                        continue
                if line.strip() == "</AbstractDuplicates>" :
                        ad = 0
                        continue
                
                if t == 1 :
                        if (titl == 1) :
                                ft.write(line)                                                
                if a == 1 :
                        if (abst == 1) :
                                ft.write(line)
                        
                if b == 1 :
                        if (body == 1) :
                                ft.write(line)

                if k == 1 :
                        if (kywd == 1) :
                                ft.write(line)
                        
                if tw == 1 :
                        if (titl == 1) :
				counterWeights+=( len(line.strip().split()) )
				lineTit = line			
                                                
                if aw == 1 :
                        if (abst == 1) :
				counterWeights+=( len(line.strip().split()) )
				lineAbs = line
                        
                if bw == 1 :
                        if (body == 1) :
				counterWeights+=( len(line.strip().split()) )
				lineBdy = line

		# The following lines are useful only if the user wants the files wwith number od distinct and duplicate genes
		if tn == 1 :
                        if (titl == 1) :
				counterNum+=( len(line.strip().split()) )
				linenTit = line                                                
                if an == 1 :
                        if (abst == 1) :
				counterNum+=( len(line.strip().split()) )
				linenAbs = line                        
                if bn == 1 :
                        if (body == 1) :
				counterNum+=( len(line.strip().split()) )
				linenBdy = line
		
		if td == 1 :
                        if (titl == 1) :
				counterDup+=( len(line.strip().split()) )
				linedTit = line			                                               
                if ad == 1 :
                        if (abst == 1) :
				counterDup+=( len(line.strip().split()) )
				linedAbs = line                       
                if bd == 1 :
                        if (body == 1) :
				counterDup+=( len(line.strip().split()) )
				linedBdy = line



	fw.write(str(counterWeights) +"\n")
	if (titl == 1) :
		for word in lineTit.strip().split() :
			fw.write(word.strip()+"\n")
		
	if (abst == 1) :
		for word in lineAbs.strip().split() :
			fw.write(word.strip()+"\n")		

	if (body == 1) :
		for word in lineBdy.strip().split() :
			fw.write(word.strip()+"\n")


	if (dDest != "" and nDest != ""):
		fd = open (dDest, mode='w'); fn = open (nDest, mode='w')

		fn.write(str(counterNum) +"\n")
		if (titl == 1) :
			for word in linenTit.strip().split() :
				fn.write(word.strip()+"\n")
		
		if (abst == 1) :
			for word in linenAbs.strip().split() :
				fn.write(word.strip()+"\n")		

		if (body == 1) :
			for word in linenBdy.strip().split() :
				fn.write(word.strip()+"\n")
	

		fd.write(str(counterDup) +"\n")
		if (titl == 1) :
			for word in linedTit.strip().split() :
				fd.write(word.strip()+"\n")
		
		if (abst == 1) :
			for word in linedAbs.strip().split() :
				fd.write(word.strip()+"\n")		

		if (body == 1) :
			for word in linedBdy.strip().split() :
				fd.write(word.strip()+"\n")
		
		fd.close(); fn.close()
	
                        
        f.close()
        ft.close()
        fw.close()
        return 

                

if __name__ == "__main__":
	# Someone is launching this directly
	main()
