from optparse import OptionParser
import os

def main():
        p = OptionParser()
        p.add_option("--path", "-p", dest="dirnameNB", default="F:\@_Lorenzo\@_Tesi\@_Framework_Parts\\", help="Absolute path of the directory where XML file is stored")
        p.add_option("--name", "-n", dest="fileNameNB", default="Preprocessor.xml", help="Name of the source to be processed")
        p.add_option("--suff", "-s", dest="suffixNB", default="cleaned", help="Suffix to be added to the processed article name")
        p.add_option("--texts", "-t", dest="textsNB", default="F:\pubmed\Acta Crystallogr Sect F Struct Biol Cryst Commun\\", help="Absolute path of the directory where articles are stored")
        p.add_option("--destDir", "-d", dest="destDirNB", default="F:\Preprocessing_Results\\", help="Directory where the attribute and data files are stored")
        p.add_option("--attFileName", "-a", dest="attrFileNameNB", default="attribute.aml", help="Name of the file where Rapid Miner must store the attributes")
        p.add_option("--dataFileName", "-f", dest="dataFileNameNB", default="data.dat", help="Name of the file where Rapid Miner must store the data")
        option, arguments = p.parse_args()

        dirname = option.dirnameNB.replace('%20', ' ')
        fileName = option.fileNameNB.replace('%20', ' ')
        suffix = option.suffixNB.replace('%20', ' ')
        texts = option.textsNB.replace('%20', ' ')
        texts = os.path.normpath(texts)
        destDir = option.destDirNB.replace('%20', ' ')
        attrFileName = option.attrFileNameNB.replace('%20', ' ')
        dataFileName = option.dataFileNameNB.replace('%20', ' ')
        
        source  = dirname + os.sep + fileName
        source = os.path.normpath(source)
        ext = os.path.splitext( source )
        dest = ext[0].replace(' ','_') +"_" + suffix + ext[1]
        dest = os.path.normpath(dest)

        print "--- Working files ---"
        print
        print source
        print dest

        newXMLProcessFile(source, dest, texts, destDir, attrFileName, dataFileName )
                
        return

def newXMLProcessFile(sourceFile, destFile,textsDir, destDir, attrFileName, dataFileName) :        

        fs = open (sourceFile, mode='r')
        fd = open (destFile, mode='w')
	#print textsDir, destDir, attrFileName, dataFileName
	i=0
	sourceTextsString = ''

	sourceTextsString += "<parameter key=\"label\" value=\"" + textsDir + "\"/>\n"
#	for el in os.listdir(textsDir):
#		if el.find('.txt') != -1:
#	        	sourceTextsString += "<parameter key=\"" + el + "\" value=\"" + textsDir + "\"/>\n"
#       		i+=1
        #sourceTextsString = "<parameter key=\""+'boh'+"\" value=\""+ textsDir +"\"/>\n"
        attrPath = os.path.normpath(destDir+os.sep+os.sep+attrFileName)
        dataPath = os.path.normpath(destDir+os.sep+os.sep+dataFileName)
        #os.mkdir(os.path.dirname(attrPath))
        #os.mkdir(os.path.dirname(dataPath))
        attDescTextsString ="<parameter key=\"attribute_description_file\" value=\""+attrPath+"\"/>\n" 
        datadatTextsString ="<parameter key=\"example_set_file\" value=\""+dataPath+"\"/>\n"

        sourceTexts = 0
        attdata = 0

        for line in fs :
                if ( line.find("<list key=\"texts\">") != -1)  :
                        sourceTexts = 1
                        fd.write(line)
                        continue
                if ( line.find("<operator name=\"ExampleSetWriter\" class=\"ExampleSetWriter\">") != -1)  :
                        attdata = 2
                        fd.write(line)
                        continue
                if (sourceTexts == 1) :
                        fd.write(sourceTextsString)
                        sourceTexts = 0
                        continue
                else :
                        if (attdata != 0) :
                                if (attdata == 2) :
                                        fd.write (attDescTextsString)
                                        attdata -= 1
                                        continue
                                if (attdata == 1) :
                                        fd.write (datadatTextsString)
					fd.write("<parameter key=\"format\" value=\"dense\"/>\n")
					fd.write("<parameter key=\"fraction_digits\" value=\"-1\"/>\n")
					fd.write("<parameter key=\"quote_nominal_values\" value=\"true\"/>\n")
					fd.write("<parameter key=\"zipped\" value=\"false\"/>\n")
					fd.write("<parameter key=\"overwrite_mode\" value=\"overwrite\"/>\n")
                                        attdata = 0
                                        continue
                        else :
                                fd.write(line)

        fs.close()
        fd.close()     
        return

                

if __name__ == "__main__":
	# Someone is launching this directly
	main()
