#! /usr/bin/env python

import sys
import time
import gobject
import string
import os
import threading
import shutil
import subprocess
import gtkhtml2
import urllib
import urlparse


from urllib import urlretrieve
try:  
    import pygtk  
    pygtk.require("2.0")  
except:
    pass  
try:  
    import gtk  
    import gtk.glade  
except:  
    print("GTK Not Availible")
    sys.exit(1)

sys.path.append('./scripts/')

from setdate import setdate
from google_retrieve import GoogleScholarSearch
from PubMedRetrieve import PubMedRetrieve
from downloadText import downloadText, GoogleResultParser
import bibtexparse

opener = urllib.FancyURLopener()
currentUrl = None

class search():
	
    wTree = None

    def __init__( self ):
    	self.i = 0
    	self.currentDir = os.getcwd()
        self.wTree = gtk.glade.XML( "main.glade" )
	self.window = self.wTree.get_widget("SearchTool")
	self.records = {}
	self.n = -1
	
	self.isPopulated = False
	
	# Variables used for the Articles List
	self.checked = 0
	self.cTitle = 1
	self.cAuthor = 2
	self.cJournal = 3
	self.cYear = 4
	self.cID = 5
	self.sChecked = ""	
	self.sTitle = "Title"
	self.sAuthor = "Author"
	self.sJournal = "Journal"
	self.sYear = "Year"
	self.sID = "Pub ID"
	self.notLocal = True	
	
	self.sel = True
			
	#Get the treeView from the widget Tree
	self.articleview = self.wTree.get_widget("articleview")
	self.pbar = self.wTree.get_widget('progressbar1')

	#Create the listStore Model to use with the articleview
	self.articlelist = gtk.ListStore(bool, str, str, str, str, str, str, str, int)
	#Attach the model to the treeView
	self.articleview.set_model(self.articlelist)
	#self.articlelist.append([ True , 'Title!', 'Author!', 'Journal!', 'Year!'])
	
	#Add all of the List Columns to the articleview
	self.AddArticleListColumn(self.sChecked, self.checked)
	self.AddArticleListColumn(self.sTitle, self.cTitle)
	self.AddArticleListColumn(self.sAuthor, self.cAuthor)
	self.AddArticleListColumn(self.sJournal, self.cJournal)
	self.AddArticleListColumn(self.sYear, self.cYear)
	self.AddArticleListColumn(self.sID, self.cID)
	self.articleview.columns_autosize()
	
	self.isAlreadyLocal = False
	self.isDownloading = False
	self.status=-1
	
	#Load settings
	self.set_saved_settings()
	
	self.okFiles = False

	if (self.window):
		self.window.connect("destroy", gtk.main_quit)

        dic = {
            
            "on_buttonSearch_clicked" : self.threadSearchStarter,
	    "on_buttonClear_clicked" : self.clear,
            "on_buttonQuit_clicked" : self.quit,
            "on_SearchTool_destroy" : self.quit,
            "on_exit_menu_activate" : self.quit,
            "on_menuinfo_activate" : self.info,
            "on_menuHelp_activate" : self.help,
            "on_articleview_row_activated" : self.printAbstract,
            "on_buttondata_clicked" : setdate(self.wTree).setdata,
            "on_buttonDownload_clicked" : self.threadDownloadStarter,
            "on_buttonSelect_clicked" : self.selectAll,
            "on_buttonLoadLocal_clicked" : self.loadDir,
    	    "on_fileOK_released" : self.getLocal,
    	    "on_buttonSaveTxt_clicked" : self.saveTxt,
    	    "on_ClearTxt_activate" : self.clearTxt,
    	    "on_settsOK_clicked" : self.saveSettings,
    	    "on_Preferences_activate" : self.settings,
    	    "on_clusterCB_toggled": self.editClust,
    	    "on_buttonDefault_clicked": self.defSettings,
    	    "on_buttonSummarize_clicked": self.threadSummarizeStarter,
    	    "on_Search_Tool_destroy": self.quit,
    	    "on_beta_value_changed": self.setSliders,
    	    "on_gamma_value_changed": self.setSliders,
    	    
        }

        self.wTree.signal_autoconnect( dic )
        
        self.wTree.get_widget('statsTable').hide()
        self.wTree.get_widget('alignmentSumm').set_sensitive(False)
	self.progress_bar = self.wTree.get_widget('progressbar1')
	self.ttd = 0      

	
	# Start thread that updates progress bar
	self.thread1 = threading.Thread(target=self.workerThread1)
	self.thread1.start()
	
	self.thread_finished = False
        self.endDownload = False



    def AddArticleListColumn(self, title, columnId):
    	'''
    	This function adds a column to the list view.
    	First it create the gtk.TreeViewColumn and then set
    	some needed properties
    	'''
	if title != "":
		column = gtk.TreeViewColumn(title, gtk.CellRendererText(), text=columnId, background=6)
		if title == "Title": column.set_fixed_width(300)
		else: column.set_fixed_width(80)
		column.set_resizable(True)

	else:
		gt = gtk.CellRendererToggle()
		gt.connect('toggled', self.toggled_callback, self.articlelist)
		column = gtk.TreeViewColumn(title, gt, active=0)
		column.set_fixed_width(30)

	#column.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
	column.set_sort_column_id(columnId)
	self.articleview.append_column(column)

	
    def toggled_callback(self, cell, path, model=None):
	iter = model.get_iter(path)
	model.set_value(iter, 0, not cell.get_active())



    def workerThread1(self):
    	'''
    	This function works as a separate thread. Depending on the current status,
    	it updates the progress bar and show a message on it.
    	'''
    	sleeptime = 0.15
    	while True:
    		if self.status==0:
	    		self.progress_bar.pulse()
	    	if self.status==1:
	    		self.progress_bar.set_fraction(1.0)
	    		time.sleep(1.0)
	    		self.threadSearch.join()
	    	if self.status==2:
	    		if self.n == 2 and hasattr(self, "ttd"):
	    			self.ttd = self.ttd - sleeptime
	    			if self.ttd < 3.0:
	    				self.ttd += sleeptime/2
	    			if self.ttd < 2.0:
	    				self.ttd += sleeptime*5/12
	    			self.progress_bar.set_text('Downloading... Extimated remaining time: ' + str(int(self.ttd)) + ' s')
	    		elif self.n == 1 and self.okFiles:
	    			if not os.path.getsize('./scripts/toDownload.tmp') == 0:
		    			f = open('./scripts/toDownload.tmp', 'r')
		    			tbd = int(f.readline())
		    			step = f.readline()
		    			f.close()
		    			if 'D' in step: self.progress_bar.set_text('Downloading files...')
		    			else: self.progress_bar.set_text('Parsing. '+str(tbd)+' files remaining')
	    			
	    		self.progress_bar.pulse()
	    	if self.status==3:
	    		self.progress_bar.set_fraction(1.0)
	    		time.sleep(1.0)
	    		self.threadDownload.join()		
	    	if self.status==4:
	    		self.progress_bar.pulse()
	    		f=open('./BioSumm/status.txt','r')
	    		ph = f.read().replace('\n','')
			f.close()
			self.progress_bar.set_text('Summarizing... Part '+ph)
			#if '11/11' in ph:
			#	time.sleep(2.0) 
	    	if self.status==5:
	    		self.progress_bar.set_fraction(1.0)
	    		#gtk.main_iteration()
	    		time.sleep(5.0)
	    		#self.threadSummarize.join()
    		time.sleep(sleeptime)
    
    
    
    def settings(self, widget):
    	'''
    	This function manages the settings window
    	'''
    	fcd = self.wTree.get_widget('settingsWindow')
    	fcd.run()
    	fcd.hide()    	
    
    
    def saveSettings(self, widget):
    	'''
    	Called when the user edit new settings in the setting window.
    	The function saves the new settings that will be kept for future runs of the application
    	'''
    	f = open('./scripts/settings.txt', 'w')
    	self.currentFolder = '.' + os.sep + os.path.relpath(self.wTree.get_widget('filechooserbutton').get_current_folder()) + '/'
	self.currentSummFolder = '.' + os.sep + os.path.relpath(self.wTree.get_widget('filechooserbutton1').get_current_folder()) + '/'
	self.geneDicFile = './' + os.path.relpath(self.wTree.get_widget('geneDictionary').get_filename())
	f.write(self.currentFolder + '\n' + self.currentSummFolder + '\n' + self.geneDicFile + '\n')
	self.doCluster = self.wTree.get_widget('clusterCB').get_active()
	
	if self.doCluster == True: f.write('1\n')
	else: f.write('0\n')
	
	self.numCluster = str(self.wTree.get_widget('clusterNumber').get_value())
    	self.percSumm = str(self.wTree.get_widget('summPerc').get_value())
    	f.write(self.numCluster + '\n' + self.percSumm + '\n')
    	self.order = self.wTree.get_widget('weightOrder').get_active()
    	if self.order == True: f.write('1\n')
    	else: f.write('0\n')
    	self.alfa = self.wTree.get_widget('alfa').get_value()
    	self.beta = self.wTree.get_widget('beta').get_value()
    	self.gamma = self.wTree.get_widget('gamma').get_value()
    	f.write(str(self.alfa) + '\n' + str(self.beta) + '\n' + str(self.gamma) + '\n')
    	f.close()    
    
    
    
    def setSliders(self, widget):
    	'''
    	Keep value of gamma parameter always less or equal to that of beta
    	'''
    	b = self.wTree.get_widget('beta')
    	g = self.wTree.get_widget('gamma')
    	if g.get_value() > b.get_value():
    		g.set_value(b.get_value())


    def editClust(self, widget):
    	'''
    	Called when the check button that indicates whether
    	clustering is active or not changes value.
    	In this way, when clustering is active, the user can
    	choose clusters number.
   	 '''
    	if self.wTree.get_widget('clusterCB').get_active():
    		self.wTree.get_widget('clusterBox').set_sensitive(True)
    	else: self.wTree.get_widget('clusterBox').set_sensitive(False)    
    

    def defSettings(self, widget):
    	'''
    	Load default settings from a default settings file that should not be edited manually
    	'''
    	shutil.copy('./scripts/default_settings.txt','./scripts/settings.txt')
    	self.set_saved_settings()


    def set_saved_settings(self):
    	'''
    	Always called when the program starts.
   	 This function load the settings file and sets the value of the folders
    	and summary options.
    	'''
    	try:
    		f = open('./scripts/settings.txt', 'r')
    		self.currentFolder = f.readline().replace('\n','')
		self.wTree.get_widget('filechooserbutton').set_filename(self.currentFolder)
		self.currentSummFolder = f.readline()
		self.wTree.get_widget('filechooserbutton1').set_filename(self.currentSummFolder)
		self.geneDicFile = f.readline().replace('\n','')
		self.wTree.get_widget('geneDictionary').set_filename(self.geneDicFile)
		self.doCluster = int(f.readline())
		self.wTree.get_widget('clusterCB').set_active(self.doCluster)
		if self.doCluster == 1:
			self.wTree.get_widget('clusterBox').set_sensitive(True)
		self.numCluster = float(f.readline().replace('\n', ''))
		self.wTree.get_widget('clusterNumber').set_value(self.numCluster)
    		self.percSumm = float(f.readline().replace('\n',''))
    		self.wTree.get_widget('summPerc').set_value(self.percSumm)
    		self.order = int(f.readline())
    		if self.order == 0: temp = False
    		else: temp = True
    		self.wTree.get_widget('weightOrder').set_active(temp)
		self.alfa = float(f.readline())
		self.beta = float(f.readline())
		self.gamma = float(f.readline())
		self.wTree.get_widget('alfa').set_value(self.alfa)
		self.wTree.get_widget('beta').set_value(self.beta)
		self.wTree.get_widget('gamma').set_value(self.gamma)
		f.close()
	except ValueError:
	# If there's a problem in some options in the settings file, load default settings
		self.defSettings(gtk.Label())


    def help(self, widget):
    	'''
    	This function manages BioSumm help guide
    	'''
    	# Wait for events on Help and Forward buttons
    	dic3 = {
    		"on_backHelp_clicked": self.backHelp,
    		"on_forwardHelp_clicked": self.forwardHelp,
    		}
    	self.wTree.signal_autoconnect( dic3 )
    	self.history = []
    	self.helpCP = 0
    	self.history.append('./doc/indexhelp.html')

	# If this is the first time the guide is called, creates
	# the document that will render the pages and adds it to
	# the scrolled window widget (helpScrolled)
    	if not hasattr(self, "documentH"):
    		self.documentH = gtkhtml2.Document()
		self.documentH.connect('link_clicked', self.link_clicked)
	
	self.documentH.clear()	
	sW = self.wTree.get_widget('helpScrolled')    	
    	child = sW.get_children()
    	if len(child) == 0:
	    	view = gtkhtml2.View()
	    	view.set_document(self.documentH)
		sW.add(view)
	sW.show_all()
    	
    	# Render the index file in the document
    	self.documentH.open_stream('text/html')
    	f=open('./doc/indexhelp.html')
    	self.documentH.write_stream(f.read())
    	f.close()
    	self.documentH.close_stream()
    	
    	self.wTree.get_widget('helpWindow').run()
    	self.wTree.get_widget('helpWindow').hide()



    def renderHelp(self, link):
    	'''
    	This function displays help content.
   	Takes in input the address of the html file containing the help chapter corresponding to 'link'.
   	'''
	global currentUrl
	try:
        	f = opener.open(link)
	except OSError:
        	print "failed to open", link
	        return
	        
	currentUrl = link
	self.documentH.clear()
	headers = f.info()
	mime = headers.getheader('Content-type').split(';')[0]
	if mime:
		self.documentH.open_stream(mime)
	else:
		self.documentH.open_stream('text/plain')
	self.documentH.write_stream(f.read())
	self.documentH.close_stream()


    def link_clicked(self, document, link):
    	'''
    	When clicking on a link in the help window, this function is called.
    	It manages the history for back/forward buttons, and callrenderHelp(link)
    	to render the new page
    	'''
	self.renderHelp(link)
	self.wTree.get_widget('backHelp').set_sensitive(True)
	self.wTree.get_widget('forwardHelp').set_sensitive(False)
	l = len(self.history)
	self.helpCP += 1
	for el in range(0, l-(self.helpCP)):
		self.history.pop()
	self.history.append(link)


    def backHelp(self, widget):
    	'''
    	When clicking on back button in the help window, this function shows the previously displayed page,
   	managing the history and rendering the new page
    	'''
    	self.wTree.get_widget('forwardHelp').set_sensitive(True)
    	self.helpCP -= 1
	self.renderHelp( self.history[self.helpCP] )
    	if self.helpCP == 0:
    		self.wTree.get_widget('backHelp').set_sensitive(False)

    
    def forwardHelp(self, widget):
    	'''
    	When clicking on forward button in the help window, this function shows the next page in the history,
   	and renders the new page calling renderHelp function
   	'''
    	self.wTree.get_widget('backHelp').set_sensitive(True)
    	self.helpCP += 1
	if self.helpCP == len(self.history)-1:
    		self.wTree.get_widget('forwardHelp').set_sensitive(False)
	self.renderHelp( self.history[self.helpCP] )


    def info(self, widget):
    	'''
    	Shows the info window
   	'''
    	self.wTree.get_widget('aboutdialog1').run()
    	self.wTree.get_widget('aboutdialog1').hide()



    def clear(self, widget):
    	'''
    	Clear all previous results and entries in the main window.
    	After that, a clean window is shown, as it was when the program was first run.
    	It also clears all results and temporary files from previous searches.
    	Used to make a brand new search 
    	'''
    	self.i = 0
        self.wTree.get_widget("entryKey").set_text("")
	self.wTree.get_widget("statsTable").hide()
	self.wTree.get_widget("search_engine").set_active(0)
	self.articlelist.clear()
	self.wTree.get_widget('abstractview').set_buffer(gtk.TextBuffer())
	self.wTree.get_widget('searchingLabel').set_text('')
	self.isPopulated = False
	self.wTree.get_widget('buttonSearch').set_sensitive(True)
	self.wTree.get_widget('arrowSD').set_sensitive(False)
	self.wTree.get_widget('buttonDownload1').set_sensitive(False)
	self.wTree.get_widget('arrowDS').set_sensitive(False)
	self.wTree.get_widget('buttonSummarize').set_sensitive(False)
	self.wTree.get_widget('notebook3').set_current_page(0)
	self.progress_bar.set_text('')
	self.status=-1
	self.progress_bar.set_fraction(0)
	if hasattr(self, "document"):
		self.document.clear()
		self.clComboBox.set_active(0)
		self.summList.clear()

	self.wTree.get_widget('alignmentSumm').set_sensitive(False)
	self.notLocal = True
	
	# Clear temporary and results files 
	self.cleanDirs('./GoogleScholar')
    	self.cleanDirs('./PubMed')
    	self.cleanDirs('./PubMedCentral')
	for el in os.listdir('./BioSumm/'):
    		if '_BC' in el:
    			self.cleanDirs('./BioSumm/'+el+os.sep)
    			shutil.rmtree('./BioSumm/'+el+os.sep)


    def cleanDirs(self, dir):
    	'''
    	this function clears all files in the 'dir' directory
    	'''
    	basedir = dir
    	subdirlist = []
    	for item in os.listdir(dir):
        	if os.path.isfile(os.path.join(basedir,item)):
			os.remove(os.path.join(basedir, item))
    	    	else:
    		        subdirlist.append(os.path.join(basedir, item))
    		for subdir in subdirlist:
    			self.cleanDirs(subdir)



    def threadSearchStarter(self, widget):
    	'''
    	Calls websearch function to be run as a separate thread
    	'''
    	self.threadSearch = threading.Thread(target=self.websearch, args=(self.wTree.get_widget('buttonSearch')))
    	self.threadSearch.start()


    def websearch(self, widget):
    	'''
    	This function takes the query and parameters from the user and perform web search.
    	It then populate the articles list
    	'''
	self.status=0
    	self.wTree.get_widget('statsTable').hide()
    	if self.wTree.get_widget('notebook3').get_current_page() == 1:
    		self.wTree.get_widget('notebook3').set_current_page(0)

    	# Clean files of previous searches
    	self.cleanDirs('./GoogleScholar')
    	self.cleanDirs('./PubMed')
    	self.cleanDirs('./PubMedCentral')
    	
    	# self.n contains the current search engine selected:
    	# 	1 --> Google Scholar
    	# 	2 --> PubMed Central
    	# 	3 --> PubMed
    	self.n = self.wTree.get_widget("search_engine").get_active()
    	
    	# Performs no operation if there's no text in the query field
    	# or no search engine is selected, and no local files are loaded.
    	if (self.wTree.get_widget('entryKey').get_text() == '' or self.n < 1) and self.notLocal:
    		self.status=-1
    		return
    	starttime = time.time()
    	self.wTree.get_widget('buttonSearch').set_sensitive(False)
	self.wTree.get_widget('arrowSD').set_sensitive(True)
    	
    	#If local files are loaded, set stats in the right way
	if not self.notLocal:
		st = ['n.a.','n.a.',self.i]
    	
    	self.progress_bar.set_text('Searching...')
	
	# Used to manage both local files and web search results
	if not self.isAlreadyLocal:
    		self.articlelist.clear()
    	self.isAlreadyLocal = False
    	
    	self.wTree.get_widget('abstractview').set_buffer(gtk.TextBuffer())

	# Gets query
	terms = self.wTree.get_widget("entryKey").get_text()
    	
    	# Settings variable contains:
    	# 	- Number of items
    	# 	- Query terms
    	# 	- Date (optional)
    	
    	# If no data is set
    	if self.wTree.get_widget("startdata").get_text() == '' and self.wTree.get_widget("numdayslab").get_text() == '':
    		settings = [
    				int(self.wTree.get_widget("spinbutton1").get_value()),
    				terms,
    				2 # No data set
    			   ]
    	# If set absolute date
    	elif self.wTree.get_widget("absDate").get_active():
    		settings = [
    				int(self.wTree.get_widget("spinbutton1").get_value()),
    				terms,
    			     	0, # Absolute date (Start - End)
    			     	str(self.wTree.get_widget("startdata").get_text()),
    			     	str(self.wTree.get_widget("enddata").get_text())
    			   ]
    	
    	else:
    		settings = [
    				int(self.wTree.get_widget("spinbutton1").get_value()),
    				terms,
    				1, # Relative date
    				self.wTree.get_widget("numdayslab").get_text()
    			   ]
	# If using use google scholar (that don't support relative date), edit settings variable
	# and calls GoogleScholarSearch() class, that performs websearch with Google Scholar
    	if self.n==1:
    		settings = [
    				int(self.wTree.get_widget("spinbutton1").get_value()),
    				terms.replace(' ', '+'),
    			     	0, # indica che contiene una data assoluta (inizio - fine)
    			     	str(self.wTree.get_widget("startdata").get_text()),
    			     	str(self.wTree.get_widget("enddata").get_text()),
    			     	str(self.wTree.get_widget("journalKey").get_text())
    			   ]
		search = GoogleScholarSearch()
		st, self.records, self.i = search.search(self.wTree, settings, self.articlelist, self.i)
		buff = gtk.TextBuffer()
		buff.set_text('No abstract available for Google Scholar Search!')
		self.wTree.get_widget('abstractview').set_buffer(buff)
	
	# Perform web search with PubMed Central
    	elif self.n==2:
    		self.a = PubMedRetrieve(self.wTree, self.progress_bar, settings)
    		st, self.records, self.i = self.a.PMCSearch(self.articlelist, self.i)
    		buff = gtk.TextBuffer()
		buff.set_text('No abstract available for PubMed Central Search!')
		self.wTree.get_widget('abstractview').set_buffer(buff)
	# Perform web search with PubMed
    	elif self.n==3:
    		self.a = PubMedRetrieve( self.wTree, self.progress_bar, settings )
    		st, self.records, self.i = self.a.PubMedSearch(self.articlelist, self.i)
    				
	self.articleview.columns_autosize()
	
	# Calculate time for web search block and call setStats function
	endtime = time.time()
	self.setStats(st, endtime-starttime)
	f=open('stats.txt', 'a')
	f.write(str(round(endtime-starttime, 2)))
	f.close()
	
	self.wTree.get_widget('arrowSD').set_sensitive(False)
	self.wTree.get_widget('buttonDownload1').set_sensitive(True)
 	self.status = 1
 	self.progress_bar.set_text('Search done!')
 	
 	#raise SystemExit(0)
 	return


    def setStats(self, stats, opTime):
    	'''
    	Display statistics (number of items and time) of the web search block in the main window
    	'''
    	self.wTree.get_widget("statsTable").show()
    	self.wTree.get_widget('labelDownload').hide()
    	self.wTree.get_widget('downloadTimeLabel').hide()

    	self.wTree.get_widget('foundLabel').set_text(str(stats[0]))
    	self.wTree.get_widget('discardedLabel').set_text(str(stats[1]))
    	self.wTree.get_widget('checkedLabel').set_text(str(stats[2]))
    	self.wTree.get_widget('searchTimeLabel').set_text('%.2f' %opTime + ' sec')
    	

    def printAbstract(self, treeview, rec, treeviewcolumn):
    	'''
    	Print abstract of the current selected article in the abstractview
    	'''
    	if self.n > 1:
	    	(tmp_model, tmp_iter) = treeview.get_selection().get_selected()
		pubID = tmp_model.get_value(tmp_iter, 5)
		for element in self.records:
			if self.records[element]['id'] == pubID:
				buff = self.wTree.get_widget('abstractview').get_buffer()
				buff.set_text(self.records[element]['abstract'])
				self.wTree.get_widget('abstractview').set_buffer(buff)


    def selectAll(self, widget):
    	'''
    	Select all or none of the articles.
    	It is called when clicking on the 'Select All' button
    	'''
    	if self.sel == True:
    		self.sel = False
    	else: self.sel = True
    	i = self.articleview.get_model()
    	it = i.get_iter_first()
    	while it != None:
	    	self.articlelist.set_value(it, 0, self.sel)
    		it = i.iter_next(it)


    def loadDir(self, widget):
    	'''
    	Display the file chooser dialog
   	'''
    	fcd = self.wTree.get_widget('filechooserdialog1')
    	fcd.run()
    	fcd.hide()


    def getLocal(self, widget):
    	'''
    	Get selected articles from the file chooser dialog and adds them to the articles list
    	'''
    	# Gets the name of the selected files 
    	listfile = self.wTree.get_widget('filechooserdialog1').get_filenames()
    	self.isAlreadyLocal = True
    	self.isPopulated = False
    	# For each file, adds it to articles list, displaying title, authors, etc..,
    	# if it is a file returned from a previous execution of BioSumm,
    	# otherwise, it just displays file name.
    	for el in listfile:
    		self.i += 1
    		self.isPopulated = True
    		self.notLocal = False
    		#Populate articles list
    		if 'txt' in el or 'nxml' in el:
    			f = open(el, 'r')
    			f.readline()
    			authors = f.readline().replace('\n', ' ')
    			journal = f.readline().replace('\n', ' ')
    			date = f.readline().replace('\n', ' ')
    			title = f.readline().replace('\n', ' ')
    			self.articlelist.append([ True, title, authors, journal, date, el, '#D4E5F6', 'LocalTxt', self.i])
    			f.close()
    		else:
    			self.articlelist.append([True, el, '', '', '', '', '#D4E5F6', 'LocalNonTxt', self.i])	
	if not self.notLocal:
		self.wTree.get_widget('buttonDownload1').set_sensitive(True)
	self.setStats(['n.a.' , 'n.a.' , self.i], 0.0)

	
    def saveTxt(self, widget):
    	'''
    	Copy downloaded files in a folder for future usage with the program.
    	The user can set this folder from the preferences menu.
   	'''
    	if self.isPopulated:
    		if self.n == 1:
    			dir = './GoogleScholar/txt/'
    		elif self.n == 2:
    			dir = './PubMedCentral/txt/'
    		elif self.n == 3:
    			dir = './PubMed/txt/'
    		listf = os.listdir(dir)
    		for el in listf:
    			shutil.copy(os.path.join(dir, el), self.currentFolder+'/'+el)
    
    
    def clearTxt(self, widget):
    	'''
    	Clear all files from the Txt folder, that contains results saved from previous execution of the program
    	'''
	listf = os.listdir(self.currentFolder)
	for el in listf:
		os.remove(os.path.normpath(os.path.join(self.currentFolder, el)))



    def threadDownloadStarter(self, widget):
	self.threadDownload = threading.Thread(target=self.download, args=(self.wTree.get_widget('buttonDownload1')))
    	self.threadDownload.start()
    	
    	
    def download(self, widget):
    	'''
    	This function downloads selected articles from the articles list,
    	parse them in a txt-pseudo-xml format,
   	and saves texts references (in BibTeX format) in the 'ref.bib' file.
    	'''
    	numToDownload = 0
    	self.status=2
    	self.progress_bar.set_text('Downloading...')
    	self.wTree.get_widget('buttonSearch').set_sensitive(False)
	self.wTree.get_widget('buttonSummarize').set_sensitive(False)
    	self.wTree.get_widget('buttonDownload1').set_sensitive(False)
    	self.wTree.get_widget('arrowDS').set_sensitive(True)
    	
    	starttime = time.time()
    	idList = []

    	self.isPopulated = True
    	i = self.articleview.get_model()
    	it = i.get_iter_first()

  	x = 1
    	idlist = []
    	self.thread_finished = False
	bibdic = {}
	
	
    	while it != None:
    		value = i.get_value(it, 0)
    		# For each element in the list, check if it is selected
    		if value == True:
    			numToDownload += 1
    			value = str(i.get_value(it, 5))
    			idList.append(value)
    			# 's' is a specific value for each article that show if the article comes from
    			# a GoogleScholar, PubMed, PMC, local-txt or local-non-txt search
    			s = i.get_value(it, 7)
    			source = i.get_value(it, 5)
    			dest = (self.currentFolder+os.path.basename(source)).replace('\n','')
    			
    			if s == 'GS':
				idlist.append(self.records[x]['link'])
    				self.idlist = idlist
			elif s == 'LocalTxt' and not os.path.exists(dest):
				shutil.copy(source, dest)
			elif s == 'LocalNonTxt':
				source = i.get_value(it, 1)
				dest = (self.currentFolder+os.path.basename(source)+'.txt.nxml').replace('\n','')
				info = {}
				info['author']=''
				info['journal']=''
				info['year']=''
				info['title']=''
				p = GoogleResultParser(self.wTree, info)
				text=''
				if 'pdf' in source:
					text = p.pdftotxt(source)
				elif 'htm' in source:
					text = p.htmltotxt(source)
				f = open(dest, 'w')
				f.write(text+'\n')
				f.close()
			# Gets articles infos
			localID = i.get_value(it, 8)
			title = i.get_value(it, 1)
			if s == 'PM':
				author = i.get_value(it, 2)[1:-2].replace('\'','')
			else:
				author = i.get_value(it, 2).replace('\'','')
			journal = i.get_value(it, 3)
			if s != 'PM':
				date = i.get_value(it, 4)
			else: 
				date = ''
			bibdic[localID]={'title':title, 'author':author, 'year': date, 'journal':journal, 'key': source}
			#print bibdic[localID]
    		x += 1
    		it = i.iter_next(it)
	
	bibList = bibdic.items()
	bibList.sort()
	text = ''
	# Save each article in BibTeX format, and creates ref.bib file
	for el in bibList:
		text += '@article{'+str(el[0])+',\nauthor = {'+el[1]['author']+'},\ntitle = {'+el[1]['title']+'},\njournal = {'+el[1]['journal']+'},\nyear = {'+el[1]['year']+'},\nkey = {'+el[1]['key']+'}\n}\n\n'
	
	f=open('./ref.bib', 'w')
	f.write(text)
	f.close()
	self.bibTexDict = bibdic
	
	# Progress bar setup
	if self.n == 2:
		# Extimate download time
		self.ttd = 34 + int(numToDownload/2)
	elif self.n == 1:
		f = open('./scripts/toDownload.tmp', 'w')
		f.write(str(numToDownload)+'\nD\n')
		f.close()
		self.okFiles = True
	
	
	# Start download phase.
	
	if self.n == 1:
	# Download articles in pdf or html format from Google Scholar search
	# In self.records are stored records infos (title, authors,... and web link to download them them)
		time.sleep(0.1)
		dT = downloadText(self.wTree, idlist, self.records)
		self.thread_finished = dT.download()
    	
    	if self.n == 2:
    	# Download articles from PMC search results
    		self.endDownload = False
    		articleText, abstractText, kwdList = self.a.downloadPMC(idList)

    	if self.n > 1:
    	# This section saves articles in txt-pseudo-xml format, just for articles from PubMed
    	# and PubMed Central. Articles from Google Scholar and local files are already saved
    	# in this format when they are downloaded and processed for better performance
	    	for el in self.records:
	    		if self.records[el]['id'] in idList:
		    		text = '<!DOCTYPE article PUBLIC "-//NLM//DTD Journal Archiving and Interchange DTD v2.3 20070202//EN" "archivearticle.dtd\"><article xmlns:xlink=\"http://www.w3.org/1999/xlink\" xmlns:mml=\"http://www.w3.org/1998/Math/MathML\" article-type=\"research-article\" xml:lang=\"EN\"><head>\n'
		    		if self.n == 2:
					text += self.records[el]['author'] + '\n' + self.records[el]['journal'] + '\n' + self.records[el]['year'] + '\n' + self.records[el]['title'] + '\n</head>\n<front>\n<title-group>\n' + self.records[el]['title'] + '</title-group>\n'
					if self.records[el]['id'] in abstractText:
						text += '<abstract>\n' + abstractText[self.records[el]['id']].replace('<','&lt;')+'\n</abstract>\n'
		    			if kwdList.has_key(self.records[el]['id']):
		    				text += '<kw-group>\n'
		    				for kwds in kwdList[self.records[el]['id']]:
		    					text+= '<kwd>\n'+kwds+'\n</kwd\n>'
		    				text += '</kw-group>\n'
		    			text += '</front>\n'
		    			if self.records[el]['id'] in articleText:
		    				text += '<body>\n<p>\n' + articleText[self.records[el]['id']].replace('<','&lt;') + '\n</p>\n</body>\n'
		    			text += '</article>\n'
		    			#text = text.decode('ascii', 'ignore')
		    			f = open('./PubMedCentral/txt/' + self.records[el]['id'] + '.txt.nxml', 'w')
		    		else:
		    			text += str(self.records[el]['author']) + '\n' + self.records[el]['journal'] + '\n' + str(self.records[el]['year']) + '\n' + self.records[el]['title'] + '\n' + self.records[el]['abstract']
		    			text += '\n' +'</head>\n<front>\n<title-group>\n' + self.records[el]['title']+ '</title-group>\n<abstract>\n'+self.records[el]['abstract']+'\n</abstract>\n</front>\n</article>\n'
		    			f = open('./PubMed/txt/' + self.records[el]['id'] + '.txt.nxml', 'w')
				f.write(text.encode('ascii', 'ignore'))
				f.close()
				self.endDownload = True

	# Download block timing
	endtime = time.time()

	self.wTree.get_widget('labelDownload').show()
	dL = self.wTree.get_widget('downloadTimeLabel')
	dL.set_text('%.2f' %(endtime-starttime) + ' sec')
	dL.show()
	
	f=open('stats.txt', 'a')
	f.write('\t\t' + str(round(endtime-starttime, 2)))
	f.close()
	
	self.wTree.get_widget('arrowDS').set_sensitive(False)
	self.wTree.get_widget('buttonSummarize').set_sensitive(True)
	self.status=3
	self.progress_bar.set_text('Download done...')
	#raise SystemExit(0)
	return
	
	
	
    def threadSummarizeStarter(self, widget):
    	'''
    	This function runs 'summarize' function as a separate thread
    	'''
	self.threadSummarize = threading.Thread(target=self.summarize, args=(self.wTree.get_widget('buttonSummarize')))   
    	self.threadSummarize.start()
  
   
    
    def summarize(self, widget):
    	'''
    	This function launches BioSumm summarizer, waits for results, and
   	displays summaries in the main window.
    	'''
    	starttime = time.time()
    	f=open('./BioSumm/status.txt','w')	
	f.write('0')
	f.close()
    	self.status = 4
    	
    	# Clean program folders from previous executions of Summary block
    	for el in os.listdir('./BioSumm/'):
    		if '_BC' in el:
    			self.cleanDirs('./BioSumm/'+el+os.sep)
    			shutil.rmtree('./BioSumm/'+el+os.sep)
    			
    	# When summary block is executed, always first cluster (or the only one if
    	# clustering is not active) is shown
    	self.wTree.get_widget('scoreCB').set_active(self.doCluster)
    	self.currentCluster = 0
    	
    	# Create dictionary for summary window own buttons and articles list
    	dic = {
    		"on_summaryCB_toggled": self.summaryCB_toggle,
    		"on_scoreCB_toggled": self.scoreCB_toggle,
    		"on_articlesSumm_row_activated": self.showSummHtml,
    		"on_downloadAsHtml_clicked": self.downloadHtml,
    		"on_downloadAsPdf_clicked": self.downloadPdf,
    	}
    	
    	fwPath = os.path.abspath('./BioSumm/@_Framework_Parts/')
    	tempPath = os.path.abspath('./temp/')
    	
    	i = self.articleview.get_model()
    	it = i.get_iter_first()
    	
    	# Create list with path of files to be summarized
    	elPaths = []
    	while it != None:
    		value = i.get_value(it, 0)
    		if value == True:
    			a = str(i.get_value(it, 7))
    			if a == 'GS':
    				elPaths.append('./GoogleScholar/txt/'+i.get_value(it,5)+'.txt.nxml')
    			elif a == 'PMC':
    				elPaths.append('./PubMedCentral/txt/'+i.get_value(it,5)+'.txt.nxml')
    			elif a == 'PM':
    				elPaths.append('./PubMed/txt/'+i.get_value(it, 5)+'.txt.nxml')
    			elif a == 'LocalTxt':
    				elPaths.append(i.get_value(it,5))
    			elif a == 'LocalNonTxt':
    				path = self.currentFolder+os.path.basename(i.get_value(it,1))+'.txt.nxml'
    				path = path.replace('\n', '')
    				elPaths.append(path)
    		it = i.iter_next(it)
    	
    	# Copy all files to summarize in a temporary folder
    	if not os.path.isdir('./temp/'):
    		os.mkdir('./temp/')
    	for el in elPaths:
    		shutil.copy(el, './temp/')
    	
    	# Add (and first remove old version if already present)
    	# a combobox with cluster number as attribute
    	if hasattr(self, "clComboBox"):
    		self.wTree.get_widget('alignment12').remove(self.clComboBox)
    	self.clComboBox = gtk.combo_box_new_text()

	align = self.wTree.get_widget('alignment12')
    	align.add(self.clComboBox)
    	self.clComboBox.set_active(0)
    	align.show_all()
	
	# Run Summarizer
    	programName = "Framework.py"
    	if self.doCluster == 1:
    		clusters = self.numCluster
    		args = ''
    	else:
    		args = ' --runRapidminer N --runCluto N --runOrganizer N'
    		clusters = 1
    	progPath = "python " + fwPath + os.sep + programName
    	args += ' --workDirectory ' + fwPath + os.sep + ' --orgDirectory ' + tempPath + os.sep + ' --ratio ' + str(int(float(self.percSumm))) + ' --clusterNumber ' + str(int(float(clusters))) + ' --alfa ' + str(self.alfa) + ' --beta ' + str(self.beta) + ' --gamma ' + str(self.gamma) + ' --dictionary ' + self.geneDicFile
    	commandLine = progPath + args
	p = subprocess.Popen(commandLine , shell=True)
	p.wait()

	# Show Summary Tab in the main window
	#self.wTree.get_widget('notebook3').set_current_page(1)
        self.wTree.get_widget('alignmentSumm').set_sensitive(True)

	#Clean temporary folder
    	shutil.rmtree(tempPath)
    	
    	# Populate Cluster number combobox
    	self.clComboBox.append_text('-')

    	if not self.doCluster:
    		self.clComboBox.set_active(0)
    		self.clComboBox.set_sensitive(False)
    		#align.show_all()
    	else:
    		self.clComboBox.set_sensitive(True)
    		#align.show_all()
    		for i in range(int(float(self.numCluster))):
			self.clComboBox.append_text('Cluster '+ str(i))
		self.clComboBox.set_active(1)
    	
    	# Populate articles list in summary tab
    	self.articlesSumm = self.wTree.get_widget('articlesSumm')
    	#Create the listStore Model to use with the articlesSumm
	self.summList = gtk.ListStore(int, str, str, str, str, str)
	#Attach the model to the treeView
	self.articlesSumm.set_model(self.summList)
    	colName = ['Ref','Title','Author','Journal','Date','File name ']
    	k=0

    	for el in colName:
	    	column = gtk.TreeViewColumn(el, gtk.CellRendererText(), text=k)
	    	if k==0:
	    		colOrd = column
	    	column.set_fixed_width(40)
    		column.set_sort_column_id(k) 
	    	column.set_resizable(True)
		self.articlesSumm.append_column(column)
		k+=1
    	j=-1
    	for el in os.listdir('./BioSumm/'):
    		if 'Experimental' in el: j+=1
    	if j == 0: j=''
    	else: j='_'+str(j)
    	currentDir = os.path.abspath('./BioSumm/Experimental_Results_BC'+j+os.sep+'0'+os.sep)
    	self.summList.clear()
    	for el in os.listdir(currentDir):
    		if 'clean_abbd' in el:
	    		n = el.split('.')[0]
	    		btd = self.bibTexDict.items()
	    		btd.sort()
	    		for entry in btd:
	    			if n in entry[1]['key']:
			    		self.summList.append([entry[0], entry[1]['title'], entry[1]['author'], entry[1]['journal'], entry[1]['year'], entry[1]['key']])
	# Add document to the summary window that will display summaries
    	if hasattr(self, "sW"):
    		self.sW.remove(self.view)

	self.document = gtkhtml2.Document()
	self.document.clear()
	self.view = gtkhtml2.View()
	self.view.set_document(self.document)
	self.sW = self.wTree.get_widget('summaryBottom')
	self.sW.add(self.view)
	self.sW.show_all()
    	self.status = 5

    	self.progress_bar.set_text('Summarize done!')
    	os.remove('./BioSumm/status.txt')

	# In this part we get the descriptive features for
	# each clusters from CLUTO results report
	if self.doCluster:
		f = open('./BioSumm/Experimental_Results_BC/Intermediate/CLUTO_results.dat','r')
		l = f.readlines()
		f.close()
		self.c=[]
		for line in l:
			if 'Descriptive:' in line:
				b=line.split('      Descriptive:  ')
				self.c.append(b[1].split(', '))
	
	# Count of total words processed from Summarizer
	# calling word count (wc) command
	clFileList=''
	for el in os.listdir(os.path.abspath('./BioSumm/Text_Selection_BC_ABBD')):
		if 'clean' in el:
			clFileList += ' ./BioSumm/Text_Selection_BC_ABBD/' + el
	commandLine = 'wc -w' + clFileList + ' > tempFL.txt'
	p = subprocess.Popen(commandLine, shell=True)
	p.wait()
	f=open('tempFL.txt','r')
	a=f.readlines()
	f.close()
	counts=a[len(a)-1].split(' ')
	if counts[0]!='':
		c=counts[0]
	else: c=counts[1]
	# Remove wc temporary file
	os.remove('tempFL.txt')
	
	# End of summarizing. Summary window setup and performance saving
	self.wTree.signal_autoconnect( dic )
	self.clComboBox.connect("changed", self.clustersCB_change)
	#self.clustersCB_change(self.clComboBox)
	self.wTree.get_widget('summDownloadBB').set_sensitive(True)
	endtime=time.time()
	f=open('stats.txt', 'a')
	f.write('\t\t' + str(round(endtime-starttime, 2)) + '\t\t'+c+'\n')
	f.close()
	self.wTree.get_widget('buttonSearch').set_sensitive(False)
	self.wTree.get_widget('buttonDownload1').set_sensitive(False)
	self.wTree.get_widget('arrowDS').set_sensitive(False)
	self.wTree.get_widget('buttonSummarize').set_sensitive(True)
	time.sleep(1.0)
	self.wTree.get_widget('notebook3').set_current_page(1)
	shutil.copy('./BioSumm/Experimental_Results_BC/Intermediate/Cluster.gif', './Cluster.gif')
	return
	#raise SystemExit()

    
    
    def downloadHtml(self, widget):
    	'''
    	After summary is done, the user can choose to save summaries
    	of current active cluster in HTML format.
   	All files will be saved in the directory specified by the user
    	in the settings, under the '/html/' subfolder.
    	'''
    	self.currentSummFolder = os.path.normpath(self.currentSummFolder.replace('\n',''))
    	if not os.path.isdir(self.currentSummFolder):
    		os.mkdir(os.path.normpath(self.currentSummFolder))
    	if not os.path.isdir(self.currentSummFolder+'/html/'):
    		os.mkdir(os.path.normpath(self.currentSummFolder+'/html/'))

    	if self.currentCluster < 1:
    		clustNumber = '0'
    	else: clustNumber = str(self.currentCluster)
    	if self.wTree.get_widget('scoreCB').get_active():
    		scores='_Scores'
    	else: scores=''
    	currentDir = os.path.abspath('./BioSumm/Experimental_Results_BC'+os.sep+clustNumber)+os.sep
    	if self.wTree.get_widget('summaryCB').get_active():
    		frefs=open('./ref.bib','r')
    		refs=frefs.readlines()
    		frefs.close()
    		text=''
	    	for el in os.listdir(currentDir):
	    		# Some render editing for best fit into PDF file
	    		if 'clean_abbd' in el:
		    		n = el.split('.')[0]
		    		for entry in self.bibTexDict:
		    			if n in self.bibTexDict[entry]['key']:
						text += '@article{' + str(entry) + ',\n'
						text += 'author = {' + self.bibTexDict[entry]['author'] + '},\n'
						text += 'title = {' + self.bibTexDict[entry]['title'] + '},\n'
						text += 'journal = {' + self.bibTexDict[entry]['journal'] + '},\n'
						text += 'year = {'+ self.bibTexDict[entry]['year'] + '}\n}\n\n'

    		fin=open(currentDir+'Summary_Sorted_'+clustNumber+scores+'.txt', 'r')
    		fout=open('./'+self.currentSummFolder+'/html/Summary_Sorted_'+clustNumber+scores+'.html', 'w')
    		fout.write('<h1>Summary</h1><br>'+fin.read()+'<br><br><h1>References</h1><br><big><pre>'+text+'</pre></big><br>')
    		fin.close()
    		fout.close()
    		
    		fin=open(currentDir+'Summary_'+clustNumber+scores+'.txt', 'r')
    		fout=open('./'+self.currentSummFolder+'/html/Summary_'+clustNumber+scores+'.html', 'w')
    		fout.write('<h1>Summary</h1><br>'+fin.read()+'<br><br><h1>References</h1><br><big><pre>'+text+'</pre></big><br>')
    		fin.close()
    		fout.close()
    	else:
    		for el in os.listdir(currentDir+'/html/'):
    			shutil.copy(currentDir+'/html/'+el, self.currentSummFolder+'/html/'+el)
	self.wTree.get_widget('progressbar1').set_text('HTML download done!')
	    			
    			
    def downloadPdf(self, widget):
    	'''
    	This function exports summaries of the current cluster in
    	the folder specified by the user in the options, under
    	the '/pdf/' subfolder, using the Portable Document Format (PDF).
    	'''
    	self.currentSummFolder = os.path.normpath(self.currentSummFolder.replace('\n',''))
    	if not os.path.isdir(self.currentSummFolder):
    		os.mkdir(os.path.normpath(self.currentSummFolder))
    	if not os.path.isdir(self.currentSummFolder+'/temp/'):
    		os.mkdir(os.path.normpath(self.currentSummFolder+'/temp/'))
    	if not os.path.isdir(self.currentSummFolder+'/pdf/'):
    		os.mkdir(os.path.normpath(self.currentSummFolder+'/pdf/'))
    
    	if self.currentCluster < 1:
    		clustNumber = '0'
    	else: clustNumber = str(self.currentCluster)
    	if self.wTree.get_widget('scoreCB').get_active():
    		scores='_Scores'
    	else: scores=''


    	currentDir = os.path.abspath('./BioSumm/Experimental_Results_BC'+os.sep+clustNumber)+os.sep

    	# Copy summaries into HTML form, adding references in BibTeX format at the end
    	if self.wTree.get_widget('summaryCB').get_active():
    		frefs=open('./ref.bib','r')
    		refs=frefs.readlines()
    		frefs.close()
    		text=''
	    	for el in os.listdir(currentDir):
	    		# Some render editing for best fit into PDF file
	    		if 'clean_abbd' in el:
		    		n = el.split('.')[0]
		    		for entry in self.bibTexDict:
		    			if n in self.bibTexDict[entry]['key']:
						text += '@article{' + str(entry) + ',\n'
						text += 'author = {'
						s = len('author = {')
						tokens = self.bibTexDict[entry]['author'].rsplit()
						for t in tokens:
							if s + len(t) < 60:
								text += t + ' '
								s += len(t) + 1
							else:
								text += '\n' + t + ' '
								s = len(t) + 1
						text += '},\n'
						text += 'title = {'
						s = len('title = {')
						tokens = self.bibTexDict[entry]['title'].rsplit()
						for t in tokens:
							if s + len(t) < 60:
								text += t + ' '
								s += len(t) + 1
							else:
								text += '\n' + t + ' '
								s = len(t) + 1
						text += '},\n'
						text += 'journal = {'
						s = len('journal = {')
						tokens = self.bibTexDict[entry]['journal'].rsplit()
						for t in tokens:
							if s + len(t) < 60:
								text += t + ' '
								s += len(t) + 1
							else:
								text += '\n' + t + ' '
								s = len(t) + 1
						text += '},\n'
						text += 'year = {'+ self.bibTexDict[entry]['year'] + '}\n}\n\n'
    		fin=open(currentDir+'Summary_Sorted_'+clustNumber+scores+'.txt', 'r')
    		fout=open('./'+self.currentSummFolder+'/temp/Summary_Sorted_'+clustNumber+scores+'.html', 'w')
    		fout.write('<h1>Summary</h1><br>'+fin.read()+'<br><br><h1>References</h1><br><pre width=30><big>'+text+'</big></pre><br>')
    		fin.close()
    		fout.close()
    		
    		fin=open(currentDir+'Summary_'+clustNumber+scores+'.txt', 'r')
    		fout=open('./'+self.currentSummFolder+'/temp/Summary_'+clustNumber+scores+'.html', 'w')
    		fout.write('<h1>Summary</h1><br>'+fin.read()+'<br><br><h1>References</h1><br><pre width=30><big>'+text+'</big></pre><br>')
    		fin.close()
    		fout.close()
	
    	else:
    	# Single article summary, already in HTML format
    		for el in os.listdir(currentDir+'/html/'):
    			shutil.copy(currentDir+'html/'+el, self.currentSummFolder+'/temp/'+el)
    	
    	# Convert summaries from HTML to PostScript format,
    	# and then from PostScript to PDF
    	for el in os.listdir(self.currentSummFolder+'/temp/'):
    		commandLine = 'html2ps -n -U '+self.currentSummFolder+'/temp/'+el+' > '+self.currentSummFolder+'/temp/'+el+'.ps' 
		p = subprocess.Popen(commandLine , shell=True)
		p.wait()
		commandLine = 'ps2pdf '+self.currentSummFolder+'/temp/'+el+'.ps '+self.currentSummFolder+'/pdf/'+el+'.pdf' 
		p = subprocess.Popen(commandLine , shell=True)
		p.wait()
	
	# Remove temporary HTML and PS files
	for el in os.listdir(self.currentSummFolder+'/temp/'):
		os.remove(self.currentSummFolder+'/temp/'+el)
	self.wTree.get_widget('progressbar1').set_text('PDF download done!')
    	
    	

    def clustersCB_change(self, widget):
    	'''
    	Called when the current active cluster is changed by the user.
    	It updates the articles list with the articles of the new cluster
    	'''
	self.currentCluster = widget.get_active() - 1    	
    	j=-1
    	for el in os.listdir('./BioSumm/'):
    		if 'Experimental' in el:
    			j+=1
    	if j == 0:
    		j=''
    	else: j='_'+str(j)
    	if self.currentCluster < 1:
    		clustNumber = '0'
    	else: clustNumber = str(self.currentCluster)
    	currentDir = os.path.abspath('./BioSumm/Experimental_Results_BC'+j+os.sep+clustNumber)+os.sep
    	
    	if hasattr(self,"summList"):
    	# Clear the articles list
	    	self.summList.clear()
	else:
	# Create a new articles list
    		self.articlesSumm = self.wTree.get_widget('articlesSumm')
    		# Create the listStore Model to use with the articlesSumm
		self.summList = gtk.ListStore(str)
		# Attach the model to the treeView
		self.articlesSumm.set_model(self.summList)
	    	column = gtk.TreeViewColumn('Text', gtk.CellRendererText(), text=0)
		
    	elem = False
    	for el in os.listdir(currentDir):
    	# Populates articles list
    		if 'clean_abbd' in el:
	    		n = el.split('.')[0]
	    		for entry in self.bibTexDict:
	    			if n in self.bibTexDict[entry]['key']:
			    		self.summList.append([entry, self.bibTexDict[entry]['title'], self.bibTexDict[entry]['author'], self.bibTexDict[entry]['journal'], self.bibTexDict[entry]['year'], self.bibTexDict[entry]['key']])

    			elem = True

    	if not elem:
    	# If current cluster has no article in it, display a message to the user
    		self.summList.append([0,'No article in this cluster!','','','',''])
		self.document.clear()
		self.wTree.get_widget('featuresTV').set_buffer(gtk.TextBuffer())
		self.articlesSumm.set_sensitive(False)
    	else:
    	# Update descriptive features of the current cluster and display them 
    		self.articlesSumm.set_sensitive(True)    		
    		self.summaryCB_toggle(self.wTree.get_widget('summaryCB'))
    		text=''
    		for feature in self.c[self.currentCluster]:
    			text += feature.replace(',','') + '\n'
    		buff=gtk.TextBuffer()
    		buff.set_text(text)
    		self.wTree.get_widget('featuresTV').set_buffer(buff)
    	return
   
   
    def summaryCB_toggle(self, widget):
    	'''
    	Called when the user (un)ticks 'Show cluster summary only'
    	check button. It updates the summary window showing the summary of
    	a single article, or the global cluster summary.
    	'''
    	if widget.get_active():
	    	self.wTree.get_widget('downloadAsPdf').set_sensitive(True)
	else:
		self.wTree.get_widget('downloadAsPdf').set_sensitive(False)
    	if not hasattr(self, "document"):
	    	self.document = gtkhtml2.Document()
		self.document.clear()
		self.view = gtkhtml2.View()
		self.view.set_document(self.document)
		self.sW = self.wTree.get_widget('summaryBottom')
		self.sW.add(self.view)
		self.sW.show_all()
    	if widget.get_active():
    		scb = self.wTree.get_widget('scoreCB')
    		scb.set_sensitive(True)
    		self.scoreCB_toggle(scb)
    	else:
    		self.wTree.get_widget('scoreCB').set_sensitive(False)
    		self.document.clear()
    
    
    def scoreCB_toggle(self, widget):
    	'''
    	When the user (un)ticks 'Show phrase score' check button,
    	this function displays the summary in the bottom part of the window
    	with(out) showing phrase scores and word count of such sentences.
    	'''
    	inOrd, sc = '',''
    	if self.order:
    		inOrd = '_Sorted'
    	if widget.get_active():
    		sc = '_Scores'
    	j=-1
    	for el in os.listdir('./BioSumm/'):
    		if 'Experimental' in el: j+=1
    	if j == 0: j=''
    	else: j='_'+str(j)
    	if self.currentCluster < 1:
    		clustNumber = '0'
    	else: clustNumber = str(self.currentCluster)
    	currentDir = os.path.abspath('./BioSumm/Experimental_Results_BC'+j+os.sep+clustNumber)+os.sep
    	fileName = 'Summary' + inOrd + '_' + clustNumber + sc + '.txt'
    	
    	# Display in the summary window the content of the summary file
	self.document.clear()
	self.document.open_stream('text/html')
	p = open(currentDir + fileName, 'r')
	textS = p.read().replace(']]',']]<br>').replace(']]<br> [[',']] [[')
	if textS == '':
		textS = 'No sentence selected for this cluster.'
	self.document.write_stream(textS)
	p.close()
	self.document.close_stream()
	return
     
    
    def showSummHtml(self, widget, rec, treeviewcolumn):
    	'''
    	Called when clicking on an article in the summary window.
   	This function does something only when 'Show cluster summary'
    	is not checked. It displays the article summary, as returned by
    	our summarizer, that is with the full text of the article, with
    	the most important sentences being highlighted.
    	'''
    	if not self.wTree.get_widget('summaryCB').get_active():
    		(tmp_model, tmp_iter) = widget.get_selection().get_selected()
    		pf = os.path.basename(tmp_model.get_value(tmp_iter, 5))
    		if 'nxml' in pf:
    			articleFileName = pf.replace('.nxml', '_clean_abbd.txt.html')
    		else:
			articleFileName = pf + '.txt_clean_abbd.txt.html'
    		self.document.clear()
		self.document.open_stream('text/html')
		j=-1
    		for el in os.listdir('./BioSumm/'):
    			if 'Experimental' in el: j+=1
    		if j == 0: j=''
    		else: j='_'+str(j)
    		if self.currentCluster < 1: clustNumber = '0'
    		else: clustNumber = str(self.currentCluster)
    		currentDir = os.path.abspath('./BioSumm/Experimental_Results_BC'+j+os.sep+clustNumber+os.sep+'html')+os.sep
		p = open(currentDir + articleFileName, 'r')
		textS = p.read().replace('<br>',' ')
		p.close()
		self.document.write_stream(textS)
		self.document.close_stream()     
      	
    
    def quit(self, widget):
    	'''
    	Close the main window and clean all temporary files
    	'''
    	self.cleanDirs('./GoogleScholar')
    	self.cleanDirs('./PubMed')
    	self.cleanDirs('./PubMedCentral')
    	for el in os.listdir('./BioSumm/'):
    		if '_BC' in el:
    			self.cleanDirs('./BioSumm/'+el+os.sep)
    			shutil.rmtree('./BioSumm/'+el+os.sep)
        sys.exit(0)


#gtk.gdk.threads_init()
gobject.threads_init()
letsdothis = search()
gtk.main()
