from optparse import OptionParser
import os

def main():
        p = OptionParser()
        p.add_option("--work", "-w", dest="workDirNameNB", default="F:\gene_name\\", help="Absolute path of the directory where source and destination are")
        p.add_option("--sourceName", "-s", dest="sourceFileNameNB", default="BIOGRID-IDENTIFIERS-2.0.41.tab.txt", help="Name of the plain text file storing the informations about genes")
        p.add_option("--sourceName1", "-a", dest="sourceFileName_1NB", default="BIOGRID-ALL-SINGLEFILE-2.0.41.tab.txt", help="Name of the plain text file storing the informations about genes")
        p.add_option("--destName", "-d", dest="destFileNameNB", default="gene_dictionary.txt", help="Name of the text file storing the processing results")
        p.add_option("--linux", "-l", dest="linuxOrNot", default="", help="If not set -> working under Windows; if set to linux working under Linux")
        option, arguments = p.parse_args()

        if option.linuxOrNot == "linux" :
                workDirName = option.workDirNameNB.replace('%20', ' ')        
                sourceFileName = option.sourceFileNameNB.replace('%20', ' ')
                sourceFileName_1 = option.sourceFileName_1NB.replace('%20', ' ')
                destFileName = option.destFileNameNB.replace('%20', ' ')
                workDirName = workDirName.replace("F:\\", "/media/DATI/")
		workDirName = workDirName.replace('\\', '/')
        else :
                workDirName = option.workDirNameNB.replace('%20', ' ')        
                sourceFileName = option.sourceFileNameNB.replace('%20', ' ')
                sourceFileName_1 = option.sourceFileName_1NB.replace('%20', ' ')
                destFileName = option.destFileNameNB.replace('%20', ' ')
                
        source = os.path.normpath(workDirName + os.sep + sourceFileName)
        source_1 = os.path.normpath(workDirName + os.sep + sourceFileName_1)
        dest = os.path.normpath(workDirName + os.sep + destFileName)
        
        parserFunction(source,source_1,dest)
        return

def parserFunction(sourceFile,sourceFile_1,destFile):
        
        fs = open (sourceFile, mode='r')
        fs_1 = open (sourceFile_1, mode='r')
        fd = open (destFile, mode='w')
        ft = open ("F:\\test.txt", mode='w')

        f = open ("F:\\@_Lorenzo\\@_Tesi\\@_Framework_Parts\\stopWords.txt", mode='r')
        

        stopDict ={}
        
        for line in f :
                words = line.strip()
                stopDict[words] = ''

        f.close()

##      To work with gene_info
##        header = 0
##        rowCounter = 0
##        for line in fs :
##                words = line.strip().split('\t')
##                if header != 0 :
##                        neededColumn = words[4].strip()
##                        if neededColumn != "-" :
##                                if ( neededColumn.find("|") != -1) :
##                                    for subColumn in neededColumn.split('|') :
##                                            blackList (ft, stopDict, subColumn, line)
##                                            fd.write(subColumn.strip()+"\n")
##                                            rowCounter += 1
##                                else :
##                                        blackList (ft, stopDict, neededColumn, line)
##                                        fd.write(neededColumn.strip()+"\n")                                                      
##                                        rowCounter += 1
##                header = 1

        geneDict = {}

##      To process GO product name and synonims        
##        rowCounter = 0
##        for line in fs :
##                words = line.strip().split('\t')                
##                word = words[1].strip()
##                if ( (word.isdigit() == True) or (stopDict.has_key(word) == 1) or (word[0] == '#') or (word[0] == '-') or word.find(" ") != -1) :
##                        ft.write(word + " IN LINE " + line)
##                        continue
##                geneDict[word] = ''                
##                rowCounter += 1
##
##        rowCounter_1 = 0
##        for line in fs_1 :
##                words = line.strip().split('\t')
##                if len(words) == 1:
##                        continue                
##                word = words[1].strip()
##                if ( (word.isdigit() == True) or (stopDict.has_key(word) == 1) or (word[0] == '#') or (word[0] == '-') or word.find(" ") != -1) :
##                        ft.write(word + " IN LINE " + line)
##                        continue
##                geneDict[word] = ''                
##                rowCounter_1 += 1

        rowCounter = 0
        for line in fs :
                words = line.strip().split('\t')                
                word = words[1].strip()
                toCheck = words[2].strip()
                homo = words[3].strip()
                if ( toCheck == "OFFICIAL_SYMBOL" or toCheck == "SYNONYM" ) :
                        if ( homo == "Homo sapiens" ) :
                                if ( (word.isdigit() == True) or (stopDict.has_key(word) == 1) or (word[0] == '#') or (word[0] == '-') or word.find(" ") != -1 or (len(word)<=3)) :
                                        ft.write(word + " IN LINE " + line)
                                        continue                
                                geneDict[word] = ''                
                rowCounter += 1

##        rowCounter_1 = 0
##        for line in fs_1 :
##                words = line.strip().split('\t')
##                if (blackList (ft, stopDict, words[2].strip(), line) == 0) :
##                        geneDict[words[2].strip()] = ''
##                if (blackList (ft, stopDict, words[3].strip(), line) == 0) :
##                        geneDict[words[3].strip()] = ''
##                neededColumn = words[4].strip()
##                if ( neededColumn.find("|") != -1) :
##                        for subColumn in neededColumn.split('|') :
##                                if (blackList (ft, stopDict, subColumn.strip(), line) == 0) :
##                                        geneDict[subColumn.strip()] = ''
##                                else :
##                                        if (blackList (ft, stopDict, neededColumn.strip(), line) == 0) :
##                                                geneDict[neededColumn.strip()] = ''
##                neededColumn = words[5].strip()
##                if ( neededColumn.find("|") != -1) :
##                        for subColumn in neededColumn.split('|') :
##                                if (blackList (ft, stopDict, subColumn.strip(), line) == 0) :
##                                        geneDict[subColumn.strip()] = ''
##                                else :
##                                        if (blackList (ft, stopDict, neededColumn.strip(), line) == 0) :
##                                                geneDict[neededColumn.strip()] = ''             
##
##                rowCounter_1 += 1


        counter = 0
        for word in geneDict.keys() :
                counter+=1
                fd.write(word+"\n")
        fd.write("\n"+str(counter) +"\n")        
        #fd.write(str(rowCounter)+"\n")
        fs.close()
        fs_1.close()        
        fd.close()
        ft.close()
        return

def blackList (ft, stopDict, word, line) :
        
        if ( (word.isdigit() == True) or (stopDict.has_key(word) == 1) or (word[0] == '#') or (word[0] == '-') or word.find(" ") != -1) :
                ft.write(word + " IN LINE " + line)
                return 1
        
        return 0

if __name__ == "__main__":
	# Someone is launching this directly
	main()
