from urllib import urlretrieve
from pdf import PdfFileReader
from BeautifulSoup import BeautifulSoup
import HTMLParserEdit, urllib
import threading
import os
import time

try:  
    import pygtk  
    pygtk.require("2.0")  
except:
    pass  
try:  
    import gtk  
    import gtk.glade  
except:  
    print("GTK Not Availible")
    sys.exit(1)
    
    

class downloadText():
	'''
	This class contains functions that download articles in
	HTML or PDF format from the web, and call other classes
	to parse such files
	'''
	def __init__(self, wTree, idlist, infos):
		self.wTree = wTree
		self.idlist = idlist
		self.infos = infos

	def download(self):
		'''
		Download files from urls in self.idlist, and calls html2txt
		if they are in HTML format, or pdf2txt if they are PDF files.
		'''
		threads = []
		i = 0
		# Each file is downloaded in a separate thread to exploit
		# concourrent downloading. The program then waits for all 
		# threads to end, using the Thread.join() function.
		for url in self.idlist:
			i += 1
			l = url.split('/')
			le = len(l)				
			if not 'pdf' in l[le-1]:
				l[le-1] = (l[le-1] + '.html').replace('\n','')
			a = threading.Thread(target=urlretrieve, args=(url, './GoogleScholar/original/'+ l[le-1]))
			a.start()
			time.sleep(0.1)
			threads.append(a)
		for t in threads:	
			t.join()
		
		# Call pdftotxt or htmltotxt depending on the format
		# of the original file. This is done for each downloaded file.		
		for url in self.idlist:
			l = url.split('/')
			le = len(l)
			for el in self.infos:
				if self.infos[el]['link'] == url:
					self.info = self.infos[el]
			p = GoogleResultParser(self.wTree, self.info)
			if 'pdf' in l[le-1]:
				text = p.pdftotxt('./GoogleScholar/original/' + l[le-1])
			else:
				text = p.htmltotxt('./GoogleScholar/original/' + l[le-1] + '.html')
			f = open('./scripts/toDownload.tmp', 'r')
			toDownload = int(f.readline())
			f.close()
			f=open('./scripts/toDownload.tmp','w')
			f.write(str(toDownload-1)+'\n\n')
			f.close()
		return True


class GoogleResultParser:
	'''
	This class parses results in HTML or PDF format and
	returns a txt-pseudo-xml file suited to be given in
	input to our summarizer
	'''
	def __init__(self, wTree, infos):
		self.wTree = wTree
		self.infos = infos
	
	
	def pdftotxt(self, path):
		content='<!DOCTYPE article PUBLIC \"-//NLM//DTD Journal Archiving and Interchange DTD v2.3 20070202//EN\" \"archivearticle.dtd\"><article xmlns:xlink=\"http://www.w3.org/1999/xlink\" xmlns:mml=\"http://www.w3.org/1998/Math/MathML\" article-type=\"research-article\" xml:lang=\"EN\"><head>\n'
		content += self.infos['author']+'\n'+self.infos['journal']+'\n'+self.infos['year']+'\n'+self.infos['title']
		content += '\n</head>\n<front>\n<title-group>\n' + self.infos['title'].replace('<','&lt;') + '\n</title-group>\n</front>\n<body>\n<p>\n'
		
		os.system("pdftotext -enc ASCII7 "+path+' ./GoogleScholar/temp.txt')
		path = path.split('/')
    		path = path[len(path)-1]
		f = open('./GoogleScholar/temp.txt', 'r')
		content += f.read().replace('&','&amp;').replace('<','&lt;')
		f.close()
		os.remove('./GoogleScholar/temp.txt')	
		content += '\n</p>\n</body>\n</article>'
		content = content.replace('\x0c','')

		# Collapse whitespace
    		#content = " ".join(content.replace(u"\xa0", " ").strip().split())
    		content.decode('ascii','ignore')
    		#content = content.replace('\xa0',' ')
		if self.infos['title'] != '':
    			f = open( './GoogleScholar/txt/' + path + '.txt.nxml' , 'w')
    			f.write(content)
    			f.close()
    		return content.encode("ascii", "ignore")
    		
			
	
    		
    	def htmltotxt(self, path):
    		# Do parse    		
    		f = urllib.urlopen(path)
    		#bs = BeautifulSoup(f.read())
    		bs = f.read()
    		path = path.split('/')
    		path = path[len(path)-1]
    		p = GoogleHtmlParse(path)
    		try:
	    		p.feed(str(bs))
    		except TypeError:
    			print 'Error'
    		f.close()
    		content = '<!DOCTYPE article PUBLIC \"-//NLM//DTD Journal Archiving and Interchange DTD v2.3 20070202//EN\" \"archivearticle.dtd\"><article xmlns:xlink=\"http://www.w3.org/1999/xlink\" xmlns:mml=\"http://www.w3.org/1998/Math/MathML\" article-type=\"research-article\" xml:lang=\"EN\"><head>\n'
    		content += self.infos['author']+'\n'+self.infos['journal']+'\n'+self.infos['year']+'\n'+self.infos['title']+'\n'
    		content += '</head><front>\n<title-group>\n' + self.infos['title'] + '\n</title-group>\n</front>\n<body>\n<p>\n'
    		content += p.get_data().replace('&','&amp;').replace('<','&lt;') + '\n</p>\n</body>\n</article>'

    		
    		if self.infos['title'] != '':
    			f = open( './GoogleScholar/txt/' + path + '.txt.nxml' , 'w')
    			f.write(content)
    			f.close()
    		#return content.encode("ascii","ignore")
		return content
    		
    		
    		
class GoogleHtmlParse(HTMLParserEdit.HTMLParser):
	'''
	This class uses the Python HTMLParserEdit class to
	parse the HTML file in a customized way, in order
	to try to obtain only the article part from the 
	file, removing html menus and other texts that are not
	part of the article.
	'''
	def __init__(self, path):
		self.okParse = 0
		self.text = ''
		self.path = path
		self.okParse = True
		HTMLParserEdit.HTMLParser.__init__(self)
	
	
	def handle_starttag(self, tag, attributes):
		if tag == 'a' or tag == 'A' or tag=='h2':
			for name, value in attributes:
				if value == 'Abstract' or value == 'ABS' or value =='abs':
				   	 self.okParse = True
		else: self.text += ' '
	
	
	def handle_data(self, text):
		if 'Abstract' in text or '\xc2' in text or 'Copyright' in text:
			self.okParse = True
		elif self.okParse:
		    	while gtk.events_pending():
    				gtk.main_iteration_do(False)
			self.text += text

	
	def get_data(self):
		return self.text.replace('<!--', '').replace('-->','')		
			
